package com.ibm.itso.sab404r.address.dao;
import java.sql.*;
import com.ibm.db.beans.*;

/**
 * This class sets the DBSelect property values. It also provides 
 * methods that execute your SQL statement, return 
 * a DBSelect reference, and return an array of objects  
 * representing the rows in the result set.
 * Generated:  Jun 23, 2004 1:55:57 PM
 */

public class GetAddressKeyByOwnerAndTypeDAO
{
	private DBSelect select;

	/**
	 * Constructor for a DBSelect class.
	 */
	public GetAddressKeyByOwnerAndTypeDAO()
	{
		super();
		initializer();
	}

	/**
	 * Creates a DBSelect instance and initializes its properties.
	 */
	protected void initializer()
	{
		select = new DBSelect();
		try
		{
			select.setDataSourceName("jdbc/agency");
			select.setCommand(
				"SELECT DB2ADMIN.ADDRESS.ADDR_KEY FROM DB2ADMIN.ADDRESS WHERE DB2ADMIN.ADDRESS.ADDR_TYPE = :addrType AND DB2ADMIN.ADDRESS.ADDR_OWNER = :addrOwner");
			DBParameterMetaData parmMetaData = select.getParameterMetaData();
			parmMetaData.setParameter(
				1,
				"addrType",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.CHAR,
				String.class);
			parmMetaData.setParameter(
				2,
				"addrOwner",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.INTEGER,
				Integer.class);
		}
		catch (SQLException ex)
		{
			ex.printStackTrace();
		}
	}

	/**
	 * Executes the SQL statement.
	 */
	public void execute(String addrType, Integer addrOwner) throws SQLException
	{
		try
		{
			
			select.setParameter("addrType", addrType);
			select.setParameter("addrOwner", addrOwner);
			select.execute();
		}

		// Free resources of select object. 
		finally
		{
			select.close();
		}
	}

	/**
	 * Returns a DBSelect reference.
	 */
	public DBSelect getDBSelect()
	{
		return select;
	}

	/**
	 * Returns an array of objects representing the rows in the result set.
	 */
	public GetAddressKeyByOwnerAndTypeDAORow[] getRows()
	{
		GetAddressKeyByOwnerAndTypeDAORow[] rows =
			new GetAddressKeyByOwnerAndTypeDAORow[select.getRowCount()];
		for (int i = 0; i <= select.getRowCount() - 1; i++)
		{
			rows[i] = new GetAddressKeyByOwnerAndTypeDAORow(select, i + 1);
		};
		return rows;
	}
}