package com.ibm.itso.sab404r.address.dao;
import java.sql.*;
import com.ibm.db.beans.*;

/**
 * This class sets the DBModify property values. It also provides 
 * methods that execute your SQL statement and return 
 * a DBModify reference.
 * Generated:  Jun 23, 2004 11:19:53 AM
 */

public class InsertAddressDAO
{
	private DBModify modify;

	/**
	 * Constructor for a DBModify class.
	 */
	public InsertAddressDAO()
	{
		super();
		initializer();
	}

	/**
	 * Creates a DBModify instance and initializes its properties.
	 */
	protected void initializer()
	{
		modify = new DBModify();
		try
		{
			modify.setDataSourceName("jdbc/agency");
			modify.setCommand(
				"INSERT INTO DB2ADMIN.ADDRESS ( ADDR_TYPE, ADDR_OWNER, ADDR_LINE1, ADDR_LINE2, ADDR_CITY, ADDR_ZIP, ADDR_STATE, ADDR_COUNTRY ) VALUES ( :addrType, :addrOwner, :addrLine1, :addrLine2, :addrCity, :addrZip, :addrState, :addrCountry )");
			DBParameterMetaData parmMetaData = modify.getParameterMetaData();
			parmMetaData.setParameter(
				1,
				"addrType",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.CHAR,
				String.class);
			parmMetaData.setParameter(
				2,
				"addrOwner",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.INTEGER,
				Integer.class);
			parmMetaData.setParameter(
				3,
				"addrLine1",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				4,
				"addrLine2",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				5,
				"addrCity",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				6,
				"addrZip",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.CHAR,
				String.class);
			parmMetaData.setParameter(
				7,
				"addrState",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.CHAR,
				String.class);
			parmMetaData.setParameter(
				8,
				"addrCountry",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
		}
		catch (SQLException ex)
		{
			ex.printStackTrace();
		}
	}

	/**
	 * Executes the SQL statement.
	 */
	public void execute(
		String addrType,
		Integer addrOwner,
		String addrLine1,
		String addrLine2,
		String addrCity,
		String addrZip,
		String addrState,
		String addrCountry)
		throws SQLException
	{
		try
		{
			modify.setParameter("addrType", addrType);
			modify.setParameter("addrOwner", addrOwner);
			modify.setParameter("addrLine1", addrLine1);
			modify.setParameter("addrLine2", addrLine2);
			modify.setParameter("addrCity", addrCity);
			modify.setParameter("addrZip", addrZip);
			modify.setParameter("addrState", addrState);
			modify.setParameter("addrCountry", addrCountry);
			modify.execute();
		}

		// Free resources of modify object. 
		finally
		{
			modify.close();
		}
	}

	/**
	 * Returns a DBModify reference.
	 */
	public DBModify getDBModify()
	{
		return modify;
	}
}