package com.ibm.itso.sab404r.employee.dao;
import java.sql.*;
import com.ibm.db.beans.*;

/**
 * This class sets the DBSelect property values. It also provides 
 * methods that execute your SQL statement, return 
 * a DBSelect reference, and return an array of objects  
 * representing the rows in the result set.
 * Generated:  Jun 23, 2004 10:54:36 AM
 */

public class GetEmployeeKeyByIdDAO
{
	private DBSelect select;

	/**
	 * Constructor for a DBSelect class.
	 */
	public GetEmployeeKeyByIdDAO()
	{
		super();
		initializer();
	}

	/**
	 * Creates a DBSelect instance and initializes its properties.
	 */
	protected void initializer()
	{
		select = new DBSelect();
		try
		{
			select.setDataSourceName("jdbc/agency");
			select.setCommand(
				"SELECT DB2ADMIN.EMPLOYEE.EMP_KEY FROM DB2ADMIN.EMPLOYEE WHERE DB2ADMIN.EMPLOYEE.EMP_ID = :empId");
			DBParameterMetaData parmMetaData = select.getParameterMetaData();
			parmMetaData.setParameter(
				1,
				"empId",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.CHAR,
				String.class);
		}
		catch (SQLException ex)
		{
			ex.printStackTrace();
		}
	}

	/**
	 * Executes the SQL statement.
	 */
	public void execute(String empId) throws SQLException
	{
		try
		{
			select.setParameter("empId", empId);
			select.execute();
		}

		// Free resources of select object. 
		finally
		{
			select.close();
		}
	}

	/**
	 * Returns a DBSelect reference.
	 */
	public DBSelect getDBSelect()
	{
		return select;
	}

	/**
	 * Returns an array of objects representing the rows in the result set.
	 */
	public GetEmployeeKeyByIdDAORow[] getRows()
	{
		GetEmployeeKeyByIdDAORow[] rows =
			new GetEmployeeKeyByIdDAORow[select.getRowCount()];
		for (int i = 0; i <= select.getRowCount() - 1; i++)
		{
			rows[i] = new GetEmployeeKeyByIdDAORow(select, i + 1);
		};
		return rows;
	}
}