package com.ibm.itso.sab404r.employee.dao;
import java.sql.*;
import com.ibm.db.beans.*;

/**
 * This class sets the DBModify property values. It also provides 
 * methods that execute your SQL statement and return 
 * a DBModify reference.
 * Generated:  Jun 25, 2004 3:29:46 PM
 */

public class InsertEmployeeDAO
{
	private DBModify modify;

	/**
	 * Constructor for a DBModify class.
	 */
	public InsertEmployeeDAO()
	{
		super();
		initializer();
	}

	/**
	 * Creates a DBModify instance and initializes its properties.
	 */
	protected void initializer()
	{
		modify = new DBModify();
		try
		{
			modify.setDataSourceName("jdbc/agency");
			modify.setCommand(
				"INSERT INTO DB2ADMIN.EMPLOYEE ( EMP_OFFICE_KEY, EMP_TYPE, EMP_FIRST_NAME, EMP_LAST_NAME, EMP_DATE_HIRED, EMP_ID, EMP_DOB, EMP_SEX, EMP_TAX_ID ) VALUES ( :officeKey, :empType, :empFirstName, :empLastName, :empDateHired, :empId, :empDateOfBirth, :empSex, :empTaxId )");
			DBParameterMetaData parmMetaData = modify.getParameterMetaData();
			parmMetaData.setParameter(
				1,
				"officeKey",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.INTEGER,
				Integer.class);
			parmMetaData.setParameter(
				2,
				"empType",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.CHAR,
				String.class);
			parmMetaData.setParameter(
				3,
				"empFirstName",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				4,
				"empLastName",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				5,
				"empDateHired",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.DATE,
				java.sql.Date.class);
			parmMetaData.setParameter(
				6,
				"empId",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.CHAR,
				String.class);
			parmMetaData.setParameter(
				7,
				"empDateOfBirth",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.DATE,
				java.sql.Date.class);
			parmMetaData.setParameter(
				8,
				"empSex",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.CHAR,
				String.class);
			parmMetaData.setParameter(
				9,
				"empTaxId",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.CHAR,
				String.class);
		}
		catch (SQLException ex)
		{
			ex.printStackTrace();
		}
	}

	/**
	 * Executes the SQL statement.
	 */
	public void execute(
		Integer officeKey,
		String empType,
		String empFirstName,
		String empLastName,
		java.sql.Date empDateHired,
		String empId,
		java.sql.Date empDateOfBirth,
		String empSex,
		String empTaxId)
		throws SQLException
	{
		try
		{
			modify.setParameter("officeKey", officeKey);
			modify.setParameter("empType", empType);
			modify.setParameter("empFirstName", empFirstName);
			modify.setParameter("empLastName", empLastName);
			modify.setParameter("empDateHired", empDateHired);
			modify.setParameter("empId", empId);
			modify.setParameter("empDateOfBirth", empDateOfBirth);
			modify.setParameter("empSex", empSex);
			modify.setParameter("empTaxId", empTaxId);
			modify.execute();
		}

		// Free resources of modify object. 
		finally
		{
			modify.close();
		}
	}

	/**
	 * Returns a DBModify reference.
	 */
	public DBModify getDBModify()
	{
		return modify;
	}
}