/*
 * Created on Jul 28, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.ibm.itso.sab404r.employee.dao;

import javax.jms.JMSException;
import javax.jms.ObjectMessage;
import javax.jms.Queue;
import javax.jms.QueueConnection;
import javax.jms.QueueConnectionFactory;
import javax.jms.QueueSender;
import javax.jms.QueueSession;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import org.apache.log4j.Logger;

import com.ibm.itso.sab404r.employee.dto.EmployeeDTO;
import com.ibm.itso.sal404.user.dto.UserDetailsDTO;


/**
 * @author db2admin
 * 
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class WriteEmployeeDAO {

	private static Logger logger = Logger.getLogger(WriteEmployeeDAO.class);

	private static final String QUEUE_NAME = "jms/RealtyIncomingQueue";

	private static final String CONNECTION_FACTORY_NAME = "jms/RealtyConnectionFactory";

	private Context envContext;

	private QueueConnectionFactory connectionFactory;

	private Queue queue;

	private UserDetailsDTO buildTransferMessageObject(EmployeeDTO anEmployee) {
		logger.debug("buildTransferMessageObject() ENTER");
		
		if (anEmployee == null) {
			logger.error("buildTransferMessageObject() anEmployee object is NULL");
		}

		UserDetailsDTO userDetailsDTO = new UserDetailsDTO();

		userDetailsDTO.setActive(Boolean.TRUE);
		userDetailsDTO.setAddrAddltext(anEmployee.getHomeAddress().getLine1());
		userDetailsDTO.setAddrBldNum(anEmployee.getHomeAddress().getLine2());
		userDetailsDTO.setAddrCntryCode(anEmployee.getHomeAddress()
				.getCountry());
		userDetailsDTO.setAddrMuni(anEmployee.getHomeAddress().getCity());
		userDetailsDTO.setAddrName(anEmployee.getEmpType());
		//userDetailsDTO.setAddrPoBox(anEmployee.getWorkAddress().getLine1());
		userDetailsDTO.setAddrPostCode(anEmployee.getHomeAddress().getZip());
		userDetailsDTO.setAddrRgn(anEmployee.getHomeAddress().getState());
		userDetailsDTO
				.setAddrStreetName(anEmployee.getHomeAddress().getLine1());
		//userDetailsDTO.setAddrUnitNum("unknown");
		//userDetailsDTO.setCrdOn("unknown");
		//userDetailsDTO.setDelete("unknown");
		//userDetailsDTO.setEmailAddr("unknown");
		userDetailsDTO.setFirstName(anEmployee.getFirstName());
		userDetailsDTO.setLastName(anEmployee.getLastName());
		userDetailsDTO.setPassword("password"); // sorry, this is realy an
		// example!!!
		//userDetailsDTO.setPhoneNum("unknown");
		userDetailsDTO.setRole("Customer"); // TODO: change this to be entered
		//userDetailsDTO.setTitle("unknown");
		userDetailsDTO.setUserName(anEmployee.getFirstName() + "."
				+ anEmployee.getLastName()); // TODO: change this
		//userDetailsDTO.setWebURL("unknown");

		logger.debug("buildTransferMessageObject() EXIT");
		return userDetailsDTO;
	}

	private void lookupResources() throws NamingException {
		logger.debug("lookupResources() ENTER");
		InitialContext ctx = new InitialContext();
		logger.debug("Instantiated initial context ");
		envContext = (Context) ctx.lookup("java:comp/env");
		logger.debug("got env");
		connectionFactory = (QueueConnectionFactory) envContext
				.lookup(getConnectionFactoryName());
		logger.debug("got connectionFactory=" + getConnectionFactoryName());
		queue = (Queue) envContext.lookup(getQueueName());
		logger.debug("got queue=" + getQueueName());
		logger.debug("lookupResources() EXIT");
	}

	/**
	 * @return
	 */
	private String getConnectionFactoryName() {
		return CONNECTION_FACTORY_NAME;
	}

	/**
	 * @return
	 */
	private String getQueueName() {
		return QUEUE_NAME;
	}

	private void sendMessage(EmployeeDTO anEmployee) throws JMSException {
		logger.debug("sendMessage() ENTER");
		try {
			QueueConnection conn = connectionFactory.createQueueConnection();
			logger.debug("Got connection");
			QueueSession sess = conn.createQueueSession(true,
					QueueSession.AUTO_ACKNOWLEDGE);
			logger.debug("Got session");
			QueueSender sender = sess.createSender(queue);
			logger.debug("Got sender for " + QUEUE_NAME);
			ObjectMessage msg = sess.createObjectMessage();
			//msg.setJMSType("NI_CR");
			msg.setObject(buildTransferMessageObject(anEmployee));

			sender.send(msg);
			logger.debug("sent message to " + QUEUE_NAME);
			sess.commit();
			logger.debug("commit done for " + QUEUE_NAME);
			sender.close();
			logger.debug("sender closed");
			conn.close();
			logger.debug("connection closed");
		} catch (JMSException e) {
			e.printStackTrace();
			throw e;
		}
		logger.debug("sendMessage() EXIT");
	}

	public void execute(EmployeeDTO anEmployee) {
		System.out.println("execute() ENTER");
		logger.debug("execute() ENTER");
		logger.debug("Entered execute of PressReleaseDAO");
		try {
			// do the JNDI lookups
			lookupResources();
		} catch (NamingException e) {
			logger.error("execute() error while looking up resources", e);
		}
		
		try {
			sendMessage(anEmployee);
		} catch (JMSException e) {
			logger.error("execute() error while sending message", e);
		}
		logger.debug("execute() EXIT");
	}

}