/*
 * Created on Jun 23, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.ibm.itso.sab404r.employee.manager;

import java.sql.SQLException;

import com.ibm.itso.sab404r.address.manager.AddressManager;
import com.ibm.itso.sab404r.employee.dao.GetEmployeeKeyByIdDAO;
import com.ibm.itso.sab404r.employee.dao.GetEmployeeKeyByIdDAORow;
import com.ibm.itso.sab404r.employee.dao.InsertEmployeeDAO;
import com.ibm.itso.sab404r.employee.dao.WriteEmployeeDAO;
import com.ibm.itso.sab404r.employee.dto.EmployeeDTO;
import com.ibm.itso.sab404r.utils.Sab404rException;

/**
 * @author sab404
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class EmployeeManager
{
	public void addAnEmployee(EmployeeDTO anEmployee) throws Sab404rException
	{
		// replaced the DB access with JMS messaging
		addEmployeeToJMSQueue(anEmployee);
		
		// the old DB access stuff...
		/*
		addEmployeeToDB(anEmployee);
		retrieveEmployeeKey(anEmployee);
		anEmployee.getHomeAddress().setOwner(anEmployee.getEmpKey());
		addHomeAddress(anEmployee);
		*/

	}

	private void addHomeAddress(EmployeeDTO anEmployee)
	{
		AddressManager addressManager = new AddressManager();
		addressManager.insertAddress(anEmployee.getHomeAddress());
	}
	
	private void addEmployeeToJMSQueue(EmployeeDTO anEmployee) throws Sab404rException {
		WriteEmployeeDAO writeEmployeeDAO = new WriteEmployeeDAO();
		writeEmployeeDAO.execute(anEmployee);
	}

	private void addEmployeeToDB(EmployeeDTO anEmployee) throws Sab404rException
	{
		try
		{
			InsertEmployeeDAO insertEmployeeDao = new InsertEmployeeDAO();
			insertEmployeeDao.execute(
				anEmployee.getOfficeKey(),
				anEmployee.getEmpType(),
				anEmployee.getFirstName(),
				anEmployee.getLastName(),
				new java.sql.Date(anEmployee.getDateHired().getTime()),
				anEmployee.getEmpId(),
				new java.sql.Date(anEmployee.getDateOfBirth().getTime()),
				anEmployee.getSex(),
				anEmployee.getTaxId());
		}
		catch (SQLException e)
		{
			// 
			e.printStackTrace();
			throw new Sab404rException(e, "SQL exception on employee insert");
		}
	}

	private EmployeeDTO retrieveEmployeeKey(EmployeeDTO anEmployee)
	{
		try
		{
			GetEmployeeKeyByIdDAO getKeyDao = new GetEmployeeKeyByIdDAO();
			getKeyDao.execute(anEmployee.getEmpId());
			GetEmployeeKeyByIdDAORow[] rows = getKeyDao.getRows();
			anEmployee.setEmpKey((Integer) rows[0].getEMPLOYEE_EMP_KEY());
		}
		catch (SQLException e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		return anEmployee;
	}
}
