/*
 * Created on Jul 28, 2004
 *
 * To change the template for this generated file go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
package com.ibm.itso.sab404r.publicity.dao;

import java.text.SimpleDateFormat;

import javax.jms.Connection;
import javax.jms.ConnectionFactory;
import javax.jms.Destination;
import javax.jms.JMSException;
import javax.jms.MessageProducer;
import javax.jms.Session;
import javax.jms.TextMessage;
import javax.naming.Context;
import javax.naming.InitialContext;
import javax.naming.NamingException;

import com.ibm.itso.sab404r.publicity.dto.PressReleaseDTO;
import com.ibm.ws.sib.trm.topology.Sender;

/**
 * @author db2admin
 *
 * To change the template for this generated type comment go to
 * Window&gt;Preferences&gt;Java&gt;Code Generation&gt;Code and Comments
 */
public class WritePressReleaseDAO
{
	private Context ctx;

	private ConnectionFactory connectionFactory;
	
	private String buildXMLString(PressReleaseDTO aRelease)
	{
		SimpleDateFormat formatter = new SimpleDateFormat("yyyy-MM-dd");
		String dateString = formatter.format(aRelease.getReleaseDate());
		StringBuffer buf = new StringBuffer();
		buf.append("<NewsItem>");
		String itemNumber = new Integer(aRelease.getReleaseNo()).toString();
		addElementNameAndContentsToBuffer("ItemNummber",itemNumber,buf);
		addElementNameAndContentsToBuffer("ItemTitle",aRelease.getTitle(),buf);
		addElementNameAndContentsToBuffer("ItemDate",dateString,buf);
		addElementNameAndContentsToBuffer("ItemAuthor",aRelease.getAuthor(),buf);
		addElementNameAndContentsToBuffer("ItemBody",aRelease.getReleaseText(),buf);
		buf.append("</NewsItem>");
		return buf.toString();
	}

	/**
	 * @param string
	 * @param string2
	 * @param buf
	 */
	private void addElementNameAndContentsToBuffer(String elementName, String contents, StringBuffer buf)
	{
		// 
		buf.append("<");
		buf.append(elementName);
		buf.append(">");
		buf.append(contents);
		buf.append("</");
		buf.append(elementName);
		buf.append(">");
		
	}

	private void getCF()
	{
		try
		{
			ctx = new InitialContext();
			System.out.println("Instantiated initial context ");
			connectionFactory = (ConnectionFactory) ctx.lookup("java:comp/env/jms/PublicityCf");
			System.out.println("Got QCF");
	
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}

	public void sendMessage(PressReleaseDTO aRelease) throws Exception
	{
		try
		{
			Connection conn = connectionFactory.createConnection();
			System.out.println("Got connection");
			Session sess = conn.createSession(true, Session.AUTO_ACKNOWLEDGE);
			System.out.println("Got session");
			Destination dest = (Destination) ctx.lookup("java:comp/env/jms/PublicityQ");
			System.out.println("Got PublicityQ");
			MessageProducer sender = sess.createProducer(dest);
			System.out.println("Got sender for PublicityQ");
			TextMessage msg =
				sess.createTextMessage();
			msg.setJMSType("NI_CR");
			msg.setText(buildXMLString(aRelease));
			
			
			sender.send(msg);
			System.out.println("sent message to PublicityQ");
			sess.commit();
			System.out.println("commit done for PublicityQ");
			sender.close();
			System.out.println("sender closed");
			conn.close();
			System.out.println("connection closed");
		}
		catch (JMSException e)
		{
			e.printStackTrace();
			throw e;
		}
		catch (NamingException e)
		{
			e.printStackTrace();
			throw e;
		}
	}

	public void execute(PressReleaseDTO aRelease)
	{
		System.out.println("Entered execute of PressReleaseDAO");
		getCF();
		try
		{
			sendMessage(aRelease);
		}
		catch (Exception e)
		{
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
	}

}
