/*
 * Created on May 26, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package com.ibm.itso.sal404.bidding;

import java.math.BigDecimal;
import java.sql.SQLException;
import java.util.Date;
import java.util.Vector;

import org.apache.log4j.Logger;

import com.ibm.itso.sal404.bidding.dao.InsertBidDAO;
import com.ibm.itso.sal404.bidding.dao.ListBidsForPropertyDAO;
import com.ibm.itso.sal404.bidding.dao.ListBidsForPropertyDAORow;
import com.ibm.itso.sal404.bidding.dao.UpdateBidDAO;
import com.ibm.itso.sal404.bidding.dto.BidDTO;
import com.ibm.itso.sal404.common.exception.ApplicationException;


/**
 * @author Moore
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class BidManager
{
    private static Logger logger = Logger.getLogger(BidManager.class);
    /**
     * @return
     * @throws ApplicationException
     */
    public Vector listBids(Integer propertyId) throws ApplicationException
    {
        Vector vectorOfBids = new Vector();
        try
        {
            //Create the DAO object
            ListBidsForPropertyDAO listBidsDAO = new ListBidsForPropertyDAO();

            listBidsDAO.execute(propertyId);
            ListBidsForPropertyDAORow[] getBidDAORow = listBidsDAO.getRows();

            BidDTO bidDTO = null;

            for (int i = 0; i < getBidDAORow.length; i++)
            {
                bidDTO = new BidDTO();

                
              
                String bidId = (String) getBidDAORow[i]
                        .getBID_BID_ID();
                bidDTO.setId(bidId);
                
                Date bidDate = (Date) getBidDAORow[i].getBID_BID_CRD_ON();
                bidDTO.setBidDate(bidDate);
                
                BigDecimal bidPrice =  (BigDecimal) getBidDAORow[i].getBID_BID_PRICE();
                bidDTO.setBidPrice(bidPrice);
                
                Integer bidPropId = (Integer) getBidDAORow[i].getBID_BID_PROP_ID();
                bidDTO.setPropertyId(bidPropId);
                
                Integer bidPropSeller = (Integer) getBidDAORow[i].getBID_BID_PROP_SELLER();
                bidDTO.setPropertySeller(bidPropSeller);
                
                String bidStatus = (String) getBidDAORow[i].getBID_BID_STATUS();
                bidDTO.setStatus(bidStatus);
                
                Integer bidder = (Integer) getBidDAORow[i].getBID_BID_USR_ID();
                bidDTO.setBidderId(bidder);
                
                                /* populating the vector with all the news items */
                vectorOfBids.add(bidDTO);
            }
        } catch (Exception exc)
        {
            logger.info("DBerror: " + exc.getMessage());
            ApplicationException ae = new ApplicationException();
            ae.setStrutsMessage("error.bid.search");
            throw ae;
        } finally
        {
            logger.info("EXIT:  listBids");
        }
        return vectorOfBids;

    }

    /**
     * @param bidItem
     * @throws ApplicationException
     */
    public void addBid(BidDTO bid) throws ApplicationException
    {
        InsertBidDAO bidDAO = new InsertBidDAO();
        try
        {
            bidDAO.execute("DummyId", bid.getPropertyId(), bid.getBidderId(), bid
                    .getStatus(), bid.getPropertySeller(), bid.getBidDate(), bid.getBidPrice());
        }
        catch (Exception e)
        {
            
            logger.info("DBerror " + e.getMessage());

            logger.error("addBid: " + e.getMessage());

            ApplicationException ae = new ApplicationException();
            ae.setStrutsMessage("bid.error.addBid");
            throw ae;
        } finally
        {
            logger.info("EXIT:  addBid");
        }

    }

    /**
     * @param bidItem
     * @throws ApplicationException
     */
    public void modifyBid(BidDTO bid) throws ApplicationException
    {
        logger.info("Entry modifyBid" );
        UpdateBidDAO bidDAO = new UpdateBidDAO();
        try
        {
            bidDAO.execute(bid.getStatus(),bid.getBidPrice(),bid.getId());
        } catch (SQLException e)
        {
            logger.info("DBerror " + e.getMessage());
            ApplicationException ae = new ApplicationException();
            ae.setStrutsMessage("bid.error.updateBid");
            throw ae;
        }

    }

    /**
     * @param id
     */
    public void deleteBid(String id)
    {
        // TODO Auto-generated method stub
        
    }
}
