/*
 * Created on Nov 22, 2004
 *
 */
package com.ibm.itso.sal404.bidding;

import java.util.Vector;

import org.apache.log4j.Logger;

import com.ibm.itso.sal404.bidding.dto.BidDTO;
import com.ibm.itso.sal404.common.exception.ApplicationException;

/**
 * @author grove
 * 
 * $Id $Log
 * 
 * Note: Bid has no search criteria.
 *  
 */
public class BidSessionData
{
    // Configure Log4J Logger
    private static Logger logger = Logger.getLogger(BidSessionData.class);

    // the manager
    private BidManager bidManager = new BidManager();

    // the list
    private Vector bidList = null;

    // currently selected
    private BidDTO current = null;

    /**
     * @return Returns the current.
     */
    public BidDTO getCurrent()
    {
        return current;
    }

    /**
     * @param current
     *            The current to set.
     */
    public void setCurrent(BidDTO current)
    {
        this.current = current;
    }

    /**
     * @param current
     *            The current to set.
     * @throws ApplicationException
     */
    //    public void setCurrent(String current) throws ApplicationException
    //    {
    //        BidDTO aBid = null;
    //        for (int i = 0; i < getBidList().size(); i++)
    //        {
    //            aBid = (BidDTO) getBidList().elementAt(i);
    //            if (aBid.getId().equals(current))
    //                break;
    //        }
    //
    //        this.current = aBid;
    //    }
    /**
     * @return Returns the bidList.
     * @throws ApplicationException
     */
    public Vector getBidList(Integer propertyId) throws ApplicationException
    {
        logger.debug("ENTRY: getBidsList");
        if (bidList == null)
            setBidList(getBidManager().listBids(propertyId));
        return bidList;
    }

    /**
     * @param bidList
     *            The bidList to set.
     */
    private void setBidList(Vector bidsList)
    {
        this.bidList = bidsList;
    }

    /**
     * @return Returns the bidManager.
     */
    private BidManager getBidManager()
    {
        return bidManager;
    }

    /**
     * @param bidManager
     *            The bidManager to set.
     */
    private void setBidManager(BidManager bidManager)
    {
        this.bidManager = bidManager;
    }

    /**
     * @throws ApplicationException
     *  
     */
    public void delete() throws ApplicationException
    {
        getBidManager().deleteBid(getCurrent().getId());

        // clear the list
        setBidList(null);
    }

    /**
     * 
     * @param bidItem
     * @throws ApplicationException
     */
    public void create(BidDTO bid) throws ApplicationException
    {
        getBidManager().addBid(bid);

        // clear the list
        setBidList(null);
    }

    /**
     * 
     * @param bidItem
     * @throws ApplicationException
     */
    public void update(BidDTO bid) throws ApplicationException
    {
        getBidManager().modifyBid(bid);

        // clear the list
        setBidList(null);
    }

    public void resetBidList()
    {
        bidList = null;
    }

    /**
     * @param current
     *            The current to set.
     * @throws ApplicationException
     */
    //    public void setCurrent(String current) throws ApplicationException
    //    {
    //        BidDTO aBid = null;
    //        for (int i = 0; i < getBidList().size(); i++)
    //        {
    //            aBid = (BidDTO) getBidList().elementAt(i);
    //            if (aBid.getId().equals(current))
    //                break;
    //        }
    //
    //        this.current = aBid;
    //    }
    /**
     * @return Returns the bidList.
     * @throws ApplicationException
     */
    public Vector getBidList() throws ApplicationException
    {
        return bidList;
    }

    /**
     * @param current
     *            The current to set.
     * @throws ApplicationException
     */
    public void setCurrent(String current) throws ApplicationException
    {
        BidDTO bid = null;
        for (int i = 0; i < getBidList().size(); i++)
        {
            bid = (BidDTO) getBidList().elementAt(i);
            if (bid.getId().equals(current))
                break;
        }

        this.current = bid;
    }
}
