package com.ibm.itso.sal404.email;

import java.math.BigDecimal;

import com.ibm.itso.sal404.email.dto.*;
import com.ibm.itso.sal404.propertycatalog.dto.PropertyDTO;
import com.ibm.itso.sal404.user.dto.*;

/**
 * 
 * sal404 Realty sample application
 * 
 * @component	name of component here
 * @layer		name of layer here
 * 
 * Description of the class here
 * 
 * @author 		Author full name here
 * @created		initial creation date here		
 * @version		x.y.z / @May 14, 2003	
 *
 * @see		 	classes associated with this class
 * 
 */
public class TestEmail
{

	public static void main(String[] args) throws Exception
	{

		UserDetailsDTO user = new UserDetailsDTO();
		user.setUserName("testUser");
		user.setPassword("testPass");
		user.setFirstName("testFirst");
		user.setLastName("testLast");
		user.setTitle("Mr.");
		user.setEmailAddr("johnb@lansa.com");
		user.setPhoneNum("919.466.8862");
		user.setWebURL("http://www.sal404.com");

		UserDetailsDTO agent = new UserDetailsDTO();
		agent.setUserName("agentUser");
		agent.setFirstName("agentFirst");
		agent.setLastName("agentLast");
		agent.setTitle("Mr.");
		agent.setEmailAddr("john.bo@lansa.com");
		agent.setPhoneNum("919.543.4321");

		PropertyDTO property = new PropertyDTO();
		property.setId(new Integer(1));
		property.setStreetName("Summer Sky Drive");
		property.setBuildingNumber("2100");
		property.setMunicipality("Morrisville");
		property.setPostalCode("27560");
		property.setUnitNumber("2122");
		property.setPrice(new BigDecimal("170000.00"));

		EmailManager emailManager = new EmailManager();

		EmailMessage greeting =  emailManager.createGreetingMessage(user);
		System.out.println(
			"greeting message sent out? "
				+ greeting.sendMessage());

		EmailMessage passwordReply =  emailManager.createPasswordReplyMessage(user);				
		System.out.println(
			"password reply message  sent out? "
				+ passwordReply.sendMessage());
				
		EmailMessage userInterest =  emailManager.createUserInterestMessage(property,user,agent);				
		System.out.println(
			"user ineterest message  sent out? "
				+ userInterest.sendMessage());

	}
}
