/*
 * Created on Nov 22, 2004
 *
 */
package com.ibm.itso.sal404.news;

import java.util.Vector;

import org.apache.log4j.Logger;

import com.ibm.itso.sal404.common.exception.ApplicationException;
import com.ibm.itso.sal404.news.dto.NewsItemDTO;

/**
 * @author grove
 * 
 * $Id
 * $Log
 * 
 * Note: News has no search criteria.
 *
 */
public class NewsSessionData {
	// Configure Log4J Logger
	private static Logger logger = Logger.getLogger(NewsSessionData.class);
    
    // the manager
    private NewsManager newsManager = new NewsManager();
    
    // the list
    private Vector newsList = null;

    // currently selected 
    private NewsItemDTO current = null;
    
    /**
     * @return Returns the current.
     */
    public NewsItemDTO getCurrent() {
        return current;
    }

    /**
     * @param current The current to set.
     */
    public void setCurrent(NewsItemDTO current) {
        this.current = current;
    }

    /**
     * @param current The current to set.
     * @throws ApplicationException
     */
    public void setCurrent(String current) throws ApplicationException {
        NewsItemDTO newsItem = null;
        for (int i=0; i<getNewsList().size(); i++) {
            newsItem = (NewsItemDTO)getNewsList().elementAt(i);
            if (newsItem.getId().equals(current))
                break;
        }
            
        this.current = newsItem;
    }

    /**
     * @return Returns the newsList.
     * @throws ApplicationException
     */
    public Vector getNewsList() throws ApplicationException {
        logger.debug("ENTRY: getNewsList");
        logger.debug("Load the changes for bill now please");
        if (newsList == null)
            setNewsList(getNewsManager().viewNewsItem());
        return newsList;
    }
    
    /**
     * @param newsList The newsList to set.
     */
    private void setNewsList(Vector newsList) {
        this.newsList = newsList;
    }

    /**
     * @return Returns the newsManager.
     */
    private NewsManager getNewsManager() {
        return newsManager;
    }

    /**
     * @param newsManager The newsManager to set.
     */
    private void setNewsManager(NewsManager newsManager) {
        this.newsManager = newsManager;
    }
    
    /**
     * @throws ApplicationException
     * 
     */
    public void delete() throws ApplicationException {
       getNewsManager().deleteNewsItem(getCurrent().getId());
       
       // clear the list
       setNewsList(null);
    }

    /**
     * 
     * @param newsItem
     * @throws ApplicationException
     */
    public void create(NewsItemDTO newsItem) throws ApplicationException
    {
        getNewsManager().addNewsItem(newsItem);
    
        // clear the list
        setNewsList(null);
    }
    
    /**
     * 
     * @param newsItem
     * @throws ApplicationException
     */
    public void update(NewsItemDTO newsItem) throws ApplicationException {
        getNewsManager().modifyNewsItem(newsItem);
        
        // clear the list
        setNewsList(null);
    }

    public void resetNewsList()
    {
        newsList = null;
    }
}
