/*
 * Created on Nov 8, 2004
 *
 */
package com.ibm.itso.sal404.referencedata;

import com.ibm.itso.sal404.ReferenceDataLocal;
import com.ibm.itso.sal404.ReferenceDataLocalHome;
import com.ibm.itso.sal404.common.base.ManagerIf;

import java.util.ArrayList;

import org.apache.log4j.Logger;

import com.ibm.itso.sal404.common.exception.ApplicationException;
import com.ibm.etools.service.locator.ServiceLocatorManager;
/**
 * @author grove
 *
 */
public class ReferenceDataManager implements ManagerIf {
    private final static String STATIC_ReferenceDataLocalHome_REF_NAME = "ejb/ReferenceData";
    private final static Class STATIC_ReferenceDataLocalHome_CLASS = ReferenceDataLocalHome.class;

	// Configure Log4J Logger
	private static Logger logger = Logger.getLogger(ReferenceDataManager.class);
    
    public ArrayList getPropertyStatus() {
        ReferenceDataLocal aReferenceDataLocal = createReferenceDataLocal();
        ArrayList anArrayList = null;
        try {
            anArrayList = aReferenceDataLocal.getPropertyStatus();
        } catch (ApplicationException ex) {
            ex.printStackTrace();
        }
    	return anArrayList;
    }

    public ArrayList getPropertyTypes() {
        ArrayList anArrayList = null;
        try {
            ReferenceDataLocal aReferenceDataLocal = createReferenceDataLocal();
            anArrayList = aReferenceDataLocal.getPropertyTypes();
        } catch (ApplicationException ex) {
            ex.printStackTrace();
        } catch (Throwable t) {
            logger.error("exception in getPropertyTypes " + t.getMessage());
        }
    	return anArrayList;
    }
    
    public ArrayList getCountryCode() {
        ReferenceDataLocal aReferenceDataLocal = createReferenceDataLocal();
        ArrayList anArrayList = null;
        try {
            anArrayList = aReferenceDataLocal.getCountryCode();
        } catch (ApplicationException ex) {
            ex.printStackTrace();
        }
    	return anArrayList;
    }
    
    public ArrayList getUserRoles() {
        ReferenceDataLocal aReferenceDataLocal = createReferenceDataLocal();
        ArrayList anArrayList = null;
        try {
            anArrayList = aReferenceDataLocal.getUserRoles();
        } catch (ApplicationException ex) {
            ex.printStackTrace();
        }
    	return anArrayList;
    }
    
    
    protected ReferenceDataLocal createReferenceDataLocal() {
        ReferenceDataLocalHome aReferenceDataLocalHome = (ReferenceDataLocalHome) ServiceLocatorManager
                .getLocalHome(STATIC_ReferenceDataLocalHome_REF_NAME,
                        STATIC_ReferenceDataLocalHome_CLASS);
        try {
            if (aReferenceDataLocalHome != null)
                return aReferenceDataLocalHome.create();
        } catch (javax.ejb.CreateException ce) {
            ce.printStackTrace();
        }
        return null;
    }
}
