/* $Id: UserBusinessDelegate.java,v 1.5 2004/12/14 15:30:03 grove Exp $
 * 
 * This code is part of the sample application that has been created
 * for the redbook WebSphere Application Server - Express V6
 * Developers Guide and A Development Example (SG24-6500).
 *
 * Revision History:
 *
 *   $Log: UserBusinessDelegate.java,v $
 *   Revision 1.5  2004/12/14 15:30:03  grove
 *   refactoring
 *
 *   Revision 1.1  2004/11/25 14:47:53  grovedc
 *   week 4
 *
 *   Revision 1.4  2004/11/24 16:08:45  ansgar
 *   removed lookup method
 *
 *   Revision 1.3  2004/11/23 18:12:49  ansgar
 *   formatting
 *
 *   Revision 1.2  2004/11/22 17:38:08  grove
 *   yet more refactoring
 *
 *   Revision 1.1  2004/11/22 15:14:33  ansgar
 *   reorganized the project structure
 *
 */
package com.ibm.itso.sal404.user;

import org.apache.log4j.Logger;

import com.ibm.etools.service.locator.ServiceLocatorManager;
import com.ibm.itso.sal404.user.dto.UserDetailsDTO;

/**
 * This delegate wraps the UserFacade and hides the JNDI lookups.
 * 
 * 
 * <BR>
 * <BR>
 * Creation date: Nov 21, 2004
 * 
 * @author ansgar
 */
public class UserBusinessDelegate implements UserBusinessInterface {

    /** log4j logger */
    private static Logger logger = Logger.getLogger(UserBusinessDelegate.class);

    private static final String USER_FACADE_JNDI = "ejb/UserFacade";

    /** cache local home interface */
    private UserFacadeLocalHome userFacadeLocalHome = null;

    private UserFacadeLocal createUserFacadeLocal() {
        // get the home interface
        if (userFacadeLocalHome == null) {
            userFacadeLocalHome = (UserFacadeLocalHome) ServiceLocatorManager
                    .getLocalHome(USER_FACADE_JNDI, UserFacadeLocalHome.class);
        }
        // now create the 
        try {
            if (userFacadeLocalHome != null) {
                return userFacadeLocalHome.create();
            }
        } catch (javax.ejb.CreateException ce) {
            ce.printStackTrace();
        }
        return null;
    }

    /**
     * @see com.ibm.itso.sal404.user.UserBusinessInterface#createUser(com.ibm.itso.sal404.user.dto.UserDetailsDTO)
     */
    public void createUser(UserDetailsDTO userDetailsDTO) {
        UserFacadeLocal userFacade = createUserFacadeLocal();
        userFacade.createUser(userDetailsDTO);
    }

}