package com.ibm.itso.sal404.user;

import org.apache.log4j.Logger;

import com.ibm.itso.sal404.common.exception.ApplicationException;
import com.ibm.itso.sal404.user.UserManager;
import com.ibm.itso.sal404.user.dto.UserDetailsDTO;

/**
 * Bean implementation class for Enterprise Bean: UserFacade
 */
public class UserFacadeBean implements javax.ejb.SessionBean,
        UserBusinessInterface {

    /** log4j logger */
    private static Logger logger = Logger.getLogger(UserFacadeBean.class);

    private javax.ejb.SessionContext mySessionCtx;

    /**
     * getSessionContext
     */
    public javax.ejb.SessionContext getSessionContext() {
        return mySessionCtx;
    }

    /**
     * setSessionContext
     */
    public void setSessionContext(javax.ejb.SessionContext ctx) {
        mySessionCtx = ctx;
    }

    /**
     * ejbCreate
     */
    public void ejbCreate() throws javax.ejb.CreateException {
    }

    /**
     * ejbActivate
     */
    public void ejbActivate() {
    }

    /**
     * ejbPassivate
     */
    public void ejbPassivate() {
    }

    /**
     * ejbRemove
     */
    public void ejbRemove() {
    }

    /*
     * (non-Javadoc)
     * 
     * @see com.ibm.itso.sal404.user.UserBusinessInterface#createUser(com.ibm.itso.sal404.user.dto.UserDetailsDTO)
     */
    public void createUser(UserDetailsDTO userDetailsDTO) {
        UserManager userManager = new UserManager();
        try {
            userManager.registerUser(userDetailsDTO);
        } catch (ApplicationException e) {
            logger.error("createUser() error creating a new user", e);
        }
    }
}