package com.ibm.itso.sal404.bidding.dao;

import java.sql.*;
import com.ibm.db.beans.*;
import com.ibm.itso.sal404.common.util.AppProperties;
import com.ibm.itso.sal404.common.util.KeyGenerator;

/**
 * This class sets the DBModify property values. It also provides 
 * methods that execute your SQL statement and return 
 * a DBModify reference.
 * Generated:  Jun 7, 2005 1:29:02 AM
 */

public class InsertBidDAO
{
    private DBModify modify;

    /**
     * Constructor for a DBModify class.
     */
    public InsertBidDAO()
    {
        super();
        initializer();
    }

    /**
     * Creates a DBModify instance and initializes its properties.
     */
    protected void initializer()
    {
        modify = new DBModify();
        try
        {
            modify.setDataSourceName(AppProperties.getInstance().getProperty("dataSourceJNDIName"));
            modify
                    .setCommand("INSERT INTO DB2ADMIN.BID ( BID_ID, BID_PROP_ID, BID_USR_ID, BID_STATUS, BID_PROP_SELLER, BID_CRD_ON, BID_PRICE ) VALUES ( :bidId, :bidPropId, :bidUsrId, :bidStatus, :bidPropSeller, :bidDate, :bidPrice )");
            DBParameterMetaData parmMetaData = modify.getParameterMetaData();
            parmMetaData.setParameter(1, "bidId",
                    java.sql.DatabaseMetaData.procedureColumnIn,
                    java.sql.Types.CHAR, String.class);
            parmMetaData.setParameter(2, "bidPropId",
                    java.sql.DatabaseMetaData.procedureColumnIn,
                    java.sql.Types.INTEGER, Integer.class);
            parmMetaData.setParameter(3, "bidUsrId",
                    java.sql.DatabaseMetaData.procedureColumnIn,
                    java.sql.Types.INTEGER, Integer.class);
            parmMetaData.setParameter(4, "bidStatus",
                    java.sql.DatabaseMetaData.procedureColumnIn,
                    java.sql.Types.CHAR, String.class);
            parmMetaData.setParameter(5, "bidPropSeller",
                    java.sql.DatabaseMetaData.procedureColumnIn,
                    java.sql.Types.INTEGER, Integer.class);
            parmMetaData.setParameter(6, "bidDate",
                    java.sql.DatabaseMetaData.procedureColumnIn,
                    java.sql.Types.TIMESTAMP, Date.class);
            parmMetaData.setParameter(7, "bidPrice",
                    java.sql.DatabaseMetaData.procedureColumnIn,
                    java.sql.Types.DECIMAL, java.math.BigDecimal.class);
        }
        catch (SQLException ex)
        {
            ex.printStackTrace();
        }
    }

    /**
     * Executes the SQL statement.
     */
    public void execute(String bidId,
            Integer bidPropId, Integer bidUsrId, String bidStatus,
            Integer bidPropSeller, java.util.Date bidDate, java.math.BigDecimal bidPrice)
            throws SQLException
    {
        try
        {
            java.sql.Date sqlDate = new java.sql.Date(bidDate.getTime());
            KeyGenerator keyGenerator = new KeyGenerator();
            modify.setParameter("bidId", keyGenerator.getKeyString());
            modify.setParameter("bidPropId", bidPropId);
            modify.setParameter("bidUsrId", bidUsrId);
            modify.setParameter("bidStatus", bidStatus);
            modify.setParameter("bidPropSeller", bidPropSeller);
            modify.setParameter("bidDate", sqlDate);
            modify.setParameter("bidPrice", bidPrice);
            modify.execute();
        }

        // Free resources of modify object. 
        finally
        {
            modify.close();
        }
    }

    /**
     * Returns a DBModify reference.
     */
    public DBModify getDBModify()
    {
        return modify;
    }
}