package com.ibm.itso.sal404.bidding.dao;

import java.sql.*;
import com.ibm.db.beans.*;
import com.ibm.itso.sal404.common.util.AppProperties;

/**
 * This class sets the DBSelect property values. It also provides methods that
 * execute your SQL statement, return a DBSelect reference, and return an array
 * of objects representing the rows in the result set. Generated: Jun 15, 2005
 * 6:03:41 PM
 */

public class ListBidsForPropertyDAO
{
    private DBSelect select;

    /**
     * Constructor for a DBSelect class.
     */
    public ListBidsForPropertyDAO()
    {
        super();
        initializer();
    }

    /**
     * Creates a DBSelect instance and initializes its properties.
     */
    protected void initializer()
    {
        select = new DBSelect();
        try
        {
            select.setDataSourceName(AppProperties.getInstance().getProperty(
                    "dataSourceJNDIName"));
            select
                    .setCommand("SELECT * FROM DB2ADMIN.BID WHERE DB2ADMIN.BID.BID_PROP_ID = :propertyId");
            DBParameterMetaData parmMetaData = select.getParameterMetaData();
            parmMetaData.setParameter(1, "propertyId",
                    java.sql.DatabaseMetaData.procedureColumnIn,
                    java.sql.Types.INTEGER, Integer.class);
        }
        catch (SQLException ex)
        {
            ex.printStackTrace();
        }
    }

    /**
     * Executes the SQL statement.
     */
    public void execute(Integer propertyId) throws SQLException
    {
        try
        {
            select.setParameter("propertyId", propertyId);
            select.execute();
        }

        // Free resources of select object.
        finally
        {
            select.close();
        }
    }

    /**
     * Returns a DBSelect reference.
     */
    public DBSelect getDBSelect()
    {
        return select;
    }

    /**
     * Returns an array of objects representing the rows in the result set.
     */
    public ListBidsForPropertyDAORow[] getRows()
    {
        ListBidsForPropertyDAORow[] rows = new ListBidsForPropertyDAORow[select
                .getRowCount()];
        for (int i = 0; i <= select.getRowCount() - 1; i++)
        {
            rows[i] = new ListBidsForPropertyDAORow(select, i + 1);
        }
        return rows;
    }
}