package com.ibm.itso.sal404.bidding.dao;

import java.sql.*;
import com.ibm.db.beans.*;

/**
 * This class represents a specific row of a result set 
 * contained in a DBSelect.
 * Generated:  Jun 15, 2005 6:03:41 PM
 */

public class ListBidsForPropertyDAORow
{
    private int rowNumber;
    private DBSelect select;

    /**
     * Constructs an object that represents a row from a DBSelect.
     */
    public ListBidsForPropertyDAORow(DBSelect aRef, int aRowNumber)
    {
        select = aRef;
        rowNumber = aRowNumber;
    }

    /**
     * Returns the value of column BID_BID_ID in the row represented by this object. 
     */
    public Object getBID_BID_ID() throws SQLException
    {
        return select.getCacheValueAt(rowNumber, 1);
    }

    /**
     * Returns the value of column BID_BID_PROP_ID in the row represented by this object. 
     */
    public Object getBID_BID_PROP_ID() throws SQLException
    {
        return select.getCacheValueAt(rowNumber, 2);
    }

    /**
     * Returns the value of column BID_BID_USR_ID in the row represented by this object. 
     */
    public Object getBID_BID_USR_ID() throws SQLException
    {
        return select.getCacheValueAt(rowNumber, 3);
    }

    /**
     * Returns the value of column BID_BID_STATUS in the row represented by this object. 
     */
    public Object getBID_BID_STATUS() throws SQLException
    {
        return select.getCacheValueAt(rowNumber, 4);
    }

    /**
     * Returns the value of column BID_BID_PROP_SELLER in the row represented by this object. 
     */
    public Object getBID_BID_PROP_SELLER() throws SQLException
    {
        return select.getCacheValueAt(rowNumber, 5);
    }

    /**
     * Returns the value of column BID_BID_CRD_ON in the row represented by this object. 
     */
    public Object getBID_BID_CRD_ON() throws SQLException
    {
        return select.getCacheValueAt(rowNumber, 6);
    }

    /**
     * Returns the value of column BID_BID_PRICE in the row represented by this object. 
     */
    public Object getBID_BID_PRICE() throws SQLException
    {
        return select.getCacheValueAt(rowNumber, 7);
    }

    /**
     * Returns a String that contains all of the values in the row represented by this object. 
     */
    public String toString()
    {
        String string = "";
        try
        {
            for (int i = 1; i <= select.getColumnCount(); i++)
            {
                string += select.getCacheValueAt(rowNumber, i);
                string += "  ";
            }
        }
        catch (SQLException ex)
        {
            return null;
        }
        return string;
    }
}