package com.ibm.itso.sal404.bidding.dao;

import java.sql.*;
import com.ibm.db.beans.*;

/**
 * This class sets the DBModify property values. It also provides 
 * methods that execute your SQL statement and return 
 * a DBModify reference.
 * Generated:  Jun 17, 2005 2:10:49 PM
 */

public class UpdateBidDAO
{
    private DBModify modify;

    /**
     * Constructor for a DBModify class.
     */
    public UpdateBidDAO()
    {
        super();
        initializer();
    }

    /**
     * Creates a DBModify instance and initializes its properties.
     */
    protected void initializer()
    {
        modify = new DBModify();
        try
        {
            modify.setDataSourceName("jdbc/sal404");
            modify
                    .setCommand("UPDATE DB2ADMIN.BID SET BID_STATUS = :bidStatus, BID_PRICE = :bidPrice WHERE DB2ADMIN.BID.BID_ID = :bidId");
            DBParameterMetaData parmMetaData = modify.getParameterMetaData();
            parmMetaData.setParameter(1, "bidStatus",
                    java.sql.DatabaseMetaData.procedureColumnIn,
                    java.sql.Types.CHAR, String.class);
            parmMetaData.setParameter(2, "bidPrice",
                    java.sql.DatabaseMetaData.procedureColumnIn,
                    java.sql.Types.DECIMAL, java.math.BigDecimal.class);
            parmMetaData.setParameter(3, "bidId",
                    java.sql.DatabaseMetaData.procedureColumnIn,
                    java.sql.Types.CHAR, String.class);
        } catch (SQLException ex)
        {
            ex.printStackTrace();
        }
    }

    /**
     * Executes the SQL statement.
     */
    public void execute(String bidStatus, java.math.BigDecimal bidPrice,
            String bidId) throws SQLException
    {
        try
        {
            modify.setUsername("db2admin");
            modify.setPassword("daboss1");
            modify.setParameter("bidStatus", bidStatus);
            modify.setParameter("bidPrice", bidPrice);
            modify.setParameter("bidId", bidId);
            modify.execute();
        }

        // Free resources of modify object. 
        finally
        {
            modify.close();
        }
    }

    /**
     * Returns a DBModify reference.
     */
    public DBModify getDBModify()
    {
        return modify;
    }
}