package com.ibm.itso.sal404.common.base;

import java.io.Serializable;


/**
 * 
 * sal404 Realty sample application
 * 
 * @component	Common component
 * @layer		N/A
 * 
 * A marker interface that all DataTransferObject classes should implement.
 * This is mostly for type safety and to guarantee that all DataTransferObject
 * classes implement the serializable interface.
 * 
 * @author 		Stelios Psarras, Cyantific.net Ltd
 * @created		13 May 2003		
 * @version		1.0.0 / @13-May-03	
 *
 * @see		 	Data Transfer Object (DTO) design pattern, 
 * 				EJB Design Patterns, Floyd  Marinescu, John Wiley & Sons, Inc., 2002, ISBN: 0-471-20831-0
 * 
 * 				Value Object design pattern
 * 
 */
public interface DataTransferObjectIf extends Serializable
{
}
