package com.ibm.itso.sal404.common.util;
/**
 * 
 * sal404 Realty sample application
 * 
 * @component	Common component
 * @layer		N/A
 * 
 * Utility class with static methods for performing conversions
 * between String and boolean values
 * 
 * @author 		Stelios Psarras, Cyantific.net Ltd
 * @created		13 May 2003		
 * @version		1.0.0 / @13-May-03	
 *
 * @see		 	N/A
 * 
 */
public class BooleanValueHelper
{
	/**
	 * Constructor for BooleanValueHelper
	 */
	public BooleanValueHelper()
	{
		super();
	}


	/**
	 * 	convertBooleanToYesNoString(boolean booleanValue)
	 * 
	 * 	returns the String "YES" if the booleanValue==true
	 * 	returns the String "NO" if the booleanValue==false
	 * 
	 * 	@param	booleanValue	String the boolean value we want to convert
	 * 
	 */
	public static String convertBooleanToYesNoString(boolean booleanValue)
	{
		String result = null;
		if (booleanValue == true)
		{
			result = "YES";
		}
		else
		{
			result = "NO";
		}
		return result;
	}


	/**
	 * 	convertBooleanToYNString(boolean booleanValue)
	 * 
	 * 	returns the String "Y" if the booleanValue==true
	 * 	returns the String "N" if the booleanValue==false
	 * 
	 * 	@param	booleanValue	String the boolean value we want to convert
	 * 
	 */	
	public static String convertBooleanToYNString(boolean booleanValue)
	{
		String result = null;
		if (booleanValue == true)
		{
			result = "Y";
		}
		else
		{
			result = "N";
		}
		return result;
	}
	
	
	/**
	 * 	convertBooleanToTrueFalseString(boolean booleanValue)
	 * 
	 * 	returns the String "true" if the booleanValue==true
	 * 	returns the String "false" if the booleanValue==false
	 * 
	 * 	@param	booleanValue	String the boolean value we want to convert
	 * 
	 */	
	public static String convertBooleanToTrueFalseString(boolean booleanValue)
	{
		String result = null;
		if (booleanValue == true)
		{
			result = "true";
		}
		else
		{
			result = "false";
		}
		return result;
	}
	
	
	/**
	 * 	convertStringToBoolean(String booleanValueString)
	 * 
	 * 	returns the boolean true 	if the booleanValueString=="Y" or
	 * 								if the booleanValueString=="YES" or
	 * 								if the booleanValueString=="true"
	 * 	returns the boolean false 	if the booleanValueString=="N" or
	 * 								if the booleanValueString=="NO" or
	 * 								if the booleanValueString=="false"
	 * 
	 * 	@param	booleanValue	String the boolean value we want to convert
	 * 
	 */		
	public static boolean convertStringToBoolean(String booleanValueString)
	{
		boolean result = false;
		if (booleanValueString != null)
		{
			if (booleanValueString.equalsIgnoreCase("Y"))
			{
				result = true;
			}
			else if (booleanValueString.equalsIgnoreCase("YES"))
			{
				result = true;
			}
			else if (booleanValueString.equalsIgnoreCase("true"))
			{
				result = true;
			}
		}
		else
		{
			result = false;
		}
		return result;
	}
}

