package com.ibm.itso.sal404.interestlist.dao;
import java.sql.*;
import com.ibm.db.beans.*;

/**
 * This class sets the DBModify property values. It also provides 
 * methods that execute your SQL statement and return 
 * a DBModify reference.
 * Generated:  May 22, 2003 11:48:37 PM
 */

public class CheckoutInterestListItemDAO
{
	private DBModify modify;

	/**
	 * Constructor for a DBModify class.
	 */
	public CheckoutInterestListItemDAO()
	{
		super();
		initializer();
	}

	/**
	 * Creates a DBModify instance and initializes its properties.
	 */
	protected void initializer()
	{
		modify = new DBModify();
		try
		{
			modify.setDataSourceName("jdbc/sal404");
			modify.setCommand(
				"INSERT INTO DB2ADMIN.INT_LIST_ITM ( INT_LIST_ID, PROP_ID, INT_LIST_ITM_EMAIL, INT_LIST_ITM_BROC, INT_LIST_ITM_DESC ) VALUES ( :INT_LIST_ID, :PROP_ID, :EMAIL, :BROC, :DESC )");
			DBParameterMetaData parmMetaData = modify.getParameterMetaData();
			parmMetaData.setParameter(
				1,
				"INT_LIST_ID",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.INTEGER,
				Integer.class);
			parmMetaData.setParameter(
				2,
				"PROP_ID",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.INTEGER,
				Integer.class);
			parmMetaData.setParameter(
				3,
				"EMAIL",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.CHAR,
				String.class);
			parmMetaData.setParameter(
				4,
				"BROC",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.CHAR,
				String.class);
			parmMetaData.setParameter(
				5,
				"DESC",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
		}
		catch (SQLException ex)
		{
			ex.printStackTrace();
		}
	}

	/**
	 * Executes the SQL statement.
	 */
	public void execute(
		Integer INT_LIST_ID,
		Integer PROP_ID,
		String EMAIL,
		String BROC,
		String DESC)
		throws SQLException
	{
		try
		{
			modify.setParameter("INT_LIST_ID", INT_LIST_ID);
			modify.setParameter("PROP_ID", PROP_ID);
			modify.setParameter("EMAIL", EMAIL);
			modify.setParameter("BROC", BROC);
			modify.setParameter("DESC", DESC);
			modify.execute();
		}

		// Free resources of modify object. 
		finally
		{
			modify.close();
		}
	}

	/**
	 * Returns a DBModify reference.
	 */
	public DBModify getDBModify()
	{
		return modify;
	}
}