package com.ibm.itso.sal404.interestlist.dao;
import java.sql.*;
import com.ibm.db.beans.*;

/**
 * This class sets the DBSelect property values. It also provides 
 * methods that execute your SQL statement, return 
 * a DBSelect reference, and return an array of objects  
 * representing the rows in the result set.
 * Generated:  May 21, 2003 3:58:26 PM
 */

public class gen_InterestListPropertyDetailDAO
{
	private DBSelect select;

	/**
	 * Constructor for a DBSelect class.
	 */
	public gen_InterestListPropertyDetailDAO()
	{
		super();
		initializer();
	}

	/**
	 * Creates a DBSelect instance and initializes its properties.
	 */
	protected void initializer()
	{
		select = new DBSelect();
		try
		{
			select.setDataSourceName("jdbc/sal404");
			select.setCommand(
				"SELECT * FROM DB2ADMIN.PROP WHERE DB2ADMIN.PROP.PROP_ID IN :PROP_ID_LIST");
			DBParameterMetaData parmMetaData = select.getParameterMetaData();
			parmMetaData.setParameter(
				1,
				"PROP_ID_LIST",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.INTEGER,
				Integer.class);
		}
		catch (SQLException ex)
		{
			ex.printStackTrace();
		}
	}

	/**
	 * Executes the SQL statement.
	 */
	public void execute(Integer PROP_ID_LIST) throws SQLException
	{
		try
		{
			select.setUsername("db2admin");
			select.setPassword("g0bears");
			select.setParameter("PROP_ID_LIST", PROP_ID_LIST);
			select.execute();
		}

		// Free resources of select object. 
		finally
		{
			select.close();
		}
	}

	/**
	 * Returns a DBSelect reference.
	 */
	public DBSelect getDBSelect()
	{
		return select;
	}

	/**
	 * Returns an array of objects representing the rows in the result set.
	 */
	public InterestListPropertyDetailDAORow[] getRows()
	{
		InterestListPropertyDetailDAORow[] rows =
			new InterestListPropertyDetailDAORow[select.getRowCount()];
		for (int i = 0; i <= select.getRowCount() - 1; i++)
		{
			rows[i] = new InterestListPropertyDetailDAORow(select, i + 1);
		}
		return rows;
	}
}