package com.ibm.itso.sal404.interestlist.itemadapter;

/**
 * 
 * sal404 Realty sample application
 * 
 * @component	Interest list
 * @layer		Domain Layer
 * 
 * This class is a special adapter for the line item
 * of the interest list
 * 
 * @author 		Mark Buensalido
 * @created		14 May 2003		
 * @version		1.0.0 / @May 14, 2003	
 *
 */
public final class InterestListLineItem
{
	private int _id;
	private int _propertyId;
	private String _address;
	private String _type;
	private String _status;
	private String _price;
	private String _agentName;
	private boolean _emailRequested;
	private boolean _brochureRequested;
	private boolean _remove;


	/**
	 * Returns the brochureRequested.
	 * @return boolean
	 * @since 1.0.0
	 */
	public boolean isBrochureRequested()
	{
		return _brochureRequested;
	}

	/**
	 * Returns the emailRequested.
	 * @return boolean
	 * @since 1.0.0
	 */
	public boolean isEmailRequested()
	{
		return _emailRequested;
	}

	/**
	 * Returns the id.
	 * @return int
	 * @since 1.0.0
	 */
	public int getId()
	{
		return _id;
	}

	/**
	 * Returns the propertyId.
	 * @return int
	 * @since 1.0.0
	 */
	public int getPropertyId()
	{
		return _propertyId;
	}

	/**
	 * Sets the brochureRequested.
	 * @param brochureRequested The brochureRequested to set
	 * @since 1.0.0
	 */
	public void setBrochureRequested(boolean brochureRequested)
	{
		_brochureRequested = brochureRequested;
	}

	/**
	 * Sets the emailRequested.
	 * @param emailRequested The emailRequested to set
	 * @since 1.0.0
	 */
	public void setEmailRequested(boolean emailRequested)
	{
		_emailRequested = emailRequested;
	}

	/**
	 * Sets the id.
	 * @param id The id to set
	 * @since 1.0.0
	 */
	public void setId(int id)
	{
		_id = id;
	}

	/**
	 * Sets the propertyId.
	 * @param propertyId The propertyId to set
	 * @since 1.0.0
	 */
	public void setPropertyId(int propertyId)
	{
		_propertyId = propertyId;
	}

	/**
	 * Returns the address.
	 * @return String
	 * @since 1.0.0
	 */
	public String getAddress()
	{
		return _address;
	}

	/**
	 * Returns the agentName.
	 * @return String
	 * @since 1.0.0
	 */
	public String getAgentName()
	{
		return _agentName;
	}

	/**
	 * Returns the price.
	 * @return String
	 * @since 1.0.0
	 */
	public String getPrice()
	{
		return _price;
	}

	/**
	 * Returns the status.
	 * @return String
	 * @since 1.0.0
	 */
	public String getStatus()
	{
		return _status;
	}

	/**
	 * Returns the type.
	 * @return String
	 * @since 1.0.0
	 */
	public String getType()
	{
		return _type;
	}

	/**
	 * Sets the address.
	 * @param address The address to set
	 * @since 1.0.0
	 */
	public void setAddress(String address)
	{
		_address = address;
	}

	/**
	 * Sets the agentName.
	 * @param agentName The agentName to set
	 * @since 1.0.0
	 */
	public void setAgentName(String agentName)
	{
		_agentName = agentName;
	}

	/**
	 * Sets the price.
	 * @param price The price to set
	 * @since 1.0.0
	 */
	public void setPrice(String price)
	{
		_price = price;
	}

	/**
	 * Sets the status.
	 * @param status The status to set
	 * @since 1.0.0
	 */
	public void setStatus(String status)
	{
		_status = status;
	}

	/**
	 * Sets the type.
	 * @param type The type to set
	 * @since 1.0.0
	 */
	public void setType(String type)
	{
		_type = type;
	}

	/**
	 * Returns the remove.
	 * @return boolean
	 * @since 1.0.0
	 */
	public boolean isRemove()
	{
		return _remove;
	}

	/**
	 * Sets the remove.
	 * @param remove The remove to set
	 * @since 1.0.0
	 */
	public void setRemove(boolean remove)
	{
		_remove = remove;
	}

}