package com.ibm.itso.sal404.news.dao;
import java.sql.SQLException;

import com.ibm.db.beans.DBModify;
import com.ibm.db.beans.DBParameterMetaData;
import com.ibm.itso.sal404.common.util.AppProperties;
/**
 * 
 * sal404 Realty sample application
 * 
 * @component	newscomponent
 * @layer		business facade
 * 
 * This class sets the DBModify property values. It also provides 
 * methods that execute your SQL statement and return 
 * a DBModify reference.
 * 
 * Generated:  May 21, 2003 2:32:41 PM
 * @author 		Ilaria Gorla
 * @version		1.0.0
 * 
 */
public class DeleteNewsItemDAO
{
	private DBModify modify;
	/**
	 * Constructor for a DBModify class.
	 */
	public DeleteNewsItemDAO()
	{
		super();
		initializer();
	}
	/**
	 * Creates a DBModify instance and initializes its properties.
	 */
	protected void initializer()
	{
		modify = new DBModify();
		
		try
		{
			modify.setDataSourceName(AppProperties.getInstance().getProperty("dataSourceJNDIName"));
			modify.setCommand("DELETE FROM DB2ADMIN.NEWS_ITM WHERE DB2ADMIN.NEWS_ITM.NEWS_ITM_ID = :id");
			DBParameterMetaData parmMetaData = modify.getParameterMetaData();
			parmMetaData.setParameter(
				1,
				"id",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.CHAR,
				String.class);
		}
		catch (SQLException ex)
		{
			ex.printStackTrace();
		}
	}
	/**
	 * Executes the SQL statement.
	 */
	public void execute(String id) throws SQLException
	{
		try
		{
			modify.setParameter("id", id);
			modify.execute();
		}
		// Free resources of modify object. 
		finally
		{
			modify.close();
		}
	}
	/**
	 * Returns a DBModify reference.
	 */
	public DBModify getDBModify()
	{
		return modify;
	}
}