package com.ibm.itso.sal404.news.dao;
import java.sql.*;
import com.ibm.db.beans.*;
/**
 * sal404 Realty sample application
 * 
 * @component	newscomponent
 * @layer		business facade
 * 
 * This class represents a specific row of a result set 
 * contained in a DBSelect.
 * 
 * Generated:  May 20, 2003 2:31:05 PM
 * @author 		Ilaria Gorla
 * @version		1.0.0
 */
public class GetNewsItemDetailsDAORow
{
	private int rowNumber;
	private DBSelect select;
	/**
	 * Constructs an object that represents a row from a DBSelect.
	 */
	public GetNewsItemDetailsDAORow(DBSelect aRef, int aRowNumber)
	{
		select = aRef;
		rowNumber = aRowNumber;
	}
	/**
	 * Returns the value of column NEWS_ITM_NEWS_ITM_ID in the row represented by this object. 
	 */
	public Object getNEWS_ITM_NEWS_ITM_ID() throws SQLException
	{
		return select.getCacheValueAt(rowNumber, 1);
	}
	/**
	 * Returns the value of column NEWS_ITM_NEWS_ITM_TITLE in the row represented by this object. 
	 */
	public Object getNEWS_ITM_NEWS_ITM_TITLE() throws SQLException
	{
		return select.getCacheValueAt(rowNumber, 2);
	}
	/**
	 * Returns the value of column NEWS_ITM_NEWS_ITM_DATE in the row represented by this object. 
	 */
	public Object getNEWS_ITM_NEWS_ITM_DATE() throws SQLException
	{
		return select.getCacheValueAt(rowNumber, 3);
	}
	/**
	 * Returns the value of column NEWS_ITM_NEWS_ITM_AUTHOR in the row represented by this object. 
	 */
	public Object getNEWS_ITM_NEWS_ITM_AUTHOR() throws SQLException
	{
		return select.getCacheValueAt(rowNumber, 4);
	}
	/**
	 * Returns the value of column NEWS_ITM_NEWS_ITM_BODY in the row represented by this object. 
	 */
	public Object getNEWS_ITM_NEWS_ITM_BODY() throws SQLException
	{
		return select.getCacheValueAt(rowNumber, 5);
	}
	/**
	 * Returns a String that contains all of the values in the row represented by this object. 
	 */
	public String toString()
	{
		String string = "";
		try
		{
			for (int i = 1; i <= select.getColumnCount(); i++)
			{
				string += select.getCacheValueAt(rowNumber, i);
				string += "  ";
			}
		}
		catch (SQLException ex)
		{
			return null;
		}
		return string;
	}
}