/*
 * Created on May 3, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package com.ibm.itso.sal404.news.dao;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.sql.Connection;
import java.util.Iterator;
import java.util.List;
import java.util.Vector;

import org.apache.log4j.Logger;

import com.ibm.itso.sal404.common.exception.ApplicationException;
import com.ibm.itso.sal404.common.util.DatabaseConnectionFactory;
import com.ibm.itso.sal404.news.dto.NewsItemDTO;
import com.ibm.websphere.sdo.mediator.JDBCMediator;
import com.ibm.websphere.sdo.mediator.exception.MediatorException;
import com.ibm.websphere.sdo.mediator.jdbc.ConnectionWrapper;
import com.ibm.websphere.sdo.mediator.jdbc.exception.InvalidMetadataException;
import com.ibm.ws.sdo.mediator.jdbc.ConnectionWrapperFactoryImpl;
import com.ibm.ws.sdo.mediator.jdbc.JDBCMediatorFactoryImpl;
import commonj.sdo.DataObject;

/**
 * @author bill
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class SDOListNewsDAO
{
    protected DataObject listNewsParameters;
    protected List listNews;
    protected JDBCMediator listNewsMediator;
    private ConnectionWrapper SDOConnectionWrapper;
    private static final String listNews_metadataFileName = "/listNews.xml";
     /** Configure Log4J Logger */
    private static Logger logger = Logger.getLogger(SDOListNewsDAO.class);

    public Vector listNewsItems() throws ApplicationException
    {
        Vector allNews = new Vector();
        try
        {
            allNews = this.buildNewsList();
        }
        catch (Exception e)
        {
            e.printStackTrace();
            logger.error(getClass().getName() + " listNewsItems: " + e.getMessage());

            ApplicationException ae = new ApplicationException();
            ae.setStrutsMessage("news.error.listFailed");
            throw ae;
        }

        return allNews;
    }

    protected InputStream getResourceInputStream(String relPath)
            throws FileNotFoundException
    {
        logger.info("Entry: getResourceInputStream");
        return this.getClass().getClassLoader().getResourceAsStream(relPath);
    }

    /**
     * @throws MediatorException
     * @throws ApplicationException
     * @throws IOException
     * @throws FileNotFoundException
     * @throws InvalidMetadataException
     *  
     */
    private Vector buildNewsList() throws InvalidMetadataException,
            FileNotFoundException, MediatorException, IOException,
            ApplicationException
    {
        logger.info("Entry: buildNewsList");
        Vector theList = new Vector();
        DataObject graph;

        graph = getListNewsMediator().getGraph();
        listNews = graph.getList(0);
        for (Iterator iter = listNews.iterator(); iter.hasNext();)
        {
            DataObject element = (DataObject) iter.next();
            NewsItemDTO item = new NewsItemDTO();
            item.setAuthor(element.getString("NEWS_ITM_AUTHOR"));
            item.setBody(element.getString("NEWS_ITM_BODY"));
            item.setDate(element.getDate("NEWS_ITM_DATE"));
            item.setTitle(element.getString("NEWS_ITM_TITLE"));
            item.setId(element.getString("NEWS_ITM_ID"));
            theList.addElement(item);
        }

        return theList;

    }

    protected ConnectionWrapper getSDOConnectionWrapper()
            throws MediatorException, ApplicationException
    {
        logger.info("Entry: getSDOConnectionWrapper");
        if (SDOConnectionWrapper == null)
        {

            logger.info("getSDOConnectionWrapper getting new connection");
            DatabaseConnectionFactory factory = new DatabaseConnectionFactory();
            Connection con;

            con = factory.getConnection();
            logger.info("getSDOConnectionWrapper new connection obtained");
            SDOConnectionWrapper = ConnectionWrapperFactoryImpl.soleInstance
                    .createConnectionWrapper(con);
            logger.info("getSDOConnectionWrapper Wrapper obtained");

        }
        return SDOConnectionWrapper;
    }

    /**
     * @return Returns the listNewsMediator.
     * @throws ApplicationException
     * @throws MediatorException
     * @throws IOException
     * @throws FileNotFoundException
     * @throws InvalidMetadataException
     */
    public JDBCMediator getListNewsMediator() throws InvalidMetadataException,
            FileNotFoundException, IOException, MediatorException,
            ApplicationException
    {
        logger.info("Entry: getListNewsMediator");
        if (listNewsMediator == null)
        {

            logger.info("Creating new ListNewsMediator");
            listNewsMediator = JDBCMediatorFactoryImpl.soleInstance
                    .createMediator(
                            getResourceInputStream(listNews_metadataFileName),
                            getSDOConnectionWrapper());
            logger.info("Created new ListNewsMediator");

        }
        return listNewsMediator;
    }

    /**
     * @param listNewsMediator
     *            The listNewsMediator to set.
     */
    public void setListNewsMediator(JDBCMediator listNewsMediator)
    {
        this.listNewsMediator = listNewsMediator;
    }
}