/*
 * Created on Jul 25, 2005
 *
 * TODO To change the template for this generated file go to
 * Window - Preferences - Java - Code Style - Code Templates
 */
package com.ibm.itso.sal404.news.dao;

import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.sql.Connection;
import java.sql.SQLException;

import org.apache.log4j.Logger;

import com.ibm.itso.sal404.common.exception.ApplicationException;
import com.ibm.itso.sal404.common.util.DatabaseConnectionFactory;
import com.ibm.itso.sal404.news.dto.NewsItemDTO;
import com.ibm.websphere.sdo.mediator.JDBCMediator;
import com.ibm.websphere.sdo.mediator.exception.MediatorException;
import com.ibm.websphere.sdo.mediator.jdbc.ConnectionWrapper;
import com.ibm.websphere.sdo.mediator.jdbc.exception.InvalidMetadataException;
import com.ibm.ws.sdo.mediator.jdbc.ConnectionWrapperFactoryImpl;
import com.ibm.ws.sdo.mediator.jdbc.JDBCMediatorFactoryImpl;
import commonj.sdo.DataObject;

/**
 * @author Moore
 * 
 * TODO To change the template for this generated type comment go to Window -
 * Preferences - Java - Code Style - Code Templates
 */
public class SDOModifyNews
{
    final String parameter = "newsId";

    private DataObject newsItem;

    protected DataObject newsParameters;

    protected JDBCMediator newsMediator;

    private ConnectionWrapper SDOConnectionWrapper;

    private static final String modifyNews_metadataFileName = "/newsItem.xml";

    /** Configure Log4J Logger */
    private static Logger logger = Logger.getLogger(SDOListNewsDAO.class);

    protected InputStream getResourceInputStream(String relPath)
            throws FileNotFoundException
    {
        logger.info("Entry: getResourceInputStream");
        return this.getClass().getClassLoader().getResourceAsStream(relPath);
    }

    /**
     * @return Returns the listNewsMediator.
     * @throws InvalidMetadataException
     * @throws FileNotFoundException
     * @throws IOException
     * @throws MediatorException
     * @throws ApplicationException
     * @throws SQLException
     */
    public JDBCMediator getNewsMediator() throws InvalidMetadataException, FileNotFoundException, IOException, MediatorException, ApplicationException, SQLException
    {
        logger.info("Entry: getNewsMediator");
        if (newsMediator == null)
        {

            logger.info("Creating new NewsMediator");
            newsMediator = JDBCMediatorFactoryImpl.soleInstance.createMediator(
                    getResourceInputStream(modifyNews_metadataFileName),
                    getSDOConnectionWrapper());
            logger.info("Created new NewsMediator");

        }
        return newsMediator;
    }

    protected ConnectionWrapper getSDOConnectionWrapper()
            throws MediatorException, ApplicationException, SQLException
    {
        logger.info("Entry: getSDOConnectionWrapper");
        if (SDOConnectionWrapper == null)
        {

            logger.info("getSDOConnectionWrapper getting new connection");
            DatabaseConnectionFactory factory = new DatabaseConnectionFactory();
            Connection con;

            con = factory.getConnection();
            con.setAutoCommit(false);
            logger.info("getSDOConnectionWrapper new connection obtained");
            SDOConnectionWrapper = ConnectionWrapperFactoryImpl.soleInstance
                    .createConnectionWrapper(con);
            logger.info("getSDOConnectionWrapper Wrapper obtained");

        }
        return SDOConnectionWrapper;
    }

    /**
     * @throws InvalidMetadataException
     * @throws FileNotFoundException
     * @throws MediatorException
     * @throws IOException
     * @throws ApplicationException
     * @throws SQLException
     * @paramBean id=newsItem
     */
    public DataObject getNewsItemParameters() throws InvalidMetadataException, FileNotFoundException, MediatorException, IOException, ApplicationException, SQLException
    {

        if (newsParameters == null)
        {

            newsParameters = getNewsMediator().getParameterDataObject();

        }
        return newsParameters;
    }

    private void fetchNewsItem(String newsId) throws InvalidMetadataException, FileNotFoundException, MediatorException, IOException, ApplicationException, SQLException
    {
        DataObject graph;
        newsParameters = getNewsMediator().getParameterDataObject();
        newsParameters.set(parameter, newsId);

        graph = getNewsMediator().getGraph(newsParameters);
        setNewsItem((DataObject) graph.getList(0).get(0));
        logger.info(getNewsItem().getString("NEWS_ITM_ID"));
        logger.info(getNewsItem().getString("NEWS_ITM_TITLE"));
        logger.info(getNewsItem().getString("NEWS_ITM_AUTHOR"));
        logger.info(getNewsItem().getString("NEWS_ITM_BODY"));

    }

    private void modifyNewsItem() throws InvalidMetadataException, FileNotFoundException, MediatorException, IOException, ApplicationException, SQLException
    {
        getNewsMediator().applyChanges(
                getNewsItem().getDataGraph().getRootObject());

    }

    /**
     * @return Returns the newsItem.
     */
    public DataObject getNewsItem()
    {
        return newsItem;
    }

    /**
     * @param newsItem
     *            The newsItem to set.
     */
    public void setNewsItem(DataObject newsItem)
    {
        this.newsItem = newsItem;
    }

    /**
     * @param tempNewsItemDTO
     */
    public void modifyNews(NewsItemDTO tempNewsItemDTO)
    {
        try
        {
            fetchNewsItem(tempNewsItemDTO.getId());
            DataObject news = getNewsItem();
            news.setString("NEWS_ITM_TITLE",tempNewsItemDTO.getTitle());
            news.setString("NEWS_ITM_AUTHOR",tempNewsItemDTO.getAuthor());
            news.setString("NEWS_ITM_BODY",tempNewsItemDTO.getBody());
            news.setDate("NEWS_ITM_DATE",tempNewsItemDTO.getDate());
            setNewsItem(news);
            modifyNewsItem();
            
            
        } catch (InvalidMetadataException e)
        {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (FileNotFoundException e)
        {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (MediatorException e)
        {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (IOException e)
        {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (ApplicationException e)
        {
            // TODO Auto-generated catch block
            e.printStackTrace();
        } catch (SQLException e)
        {
            // TODO Auto-generated catch block
            e.printStackTrace();
        }
        
    }
}
