package com.ibm.itso.sal404.news.dto;

import java.util.Date;

import com.ibm.itso.sal404.common.base.DataTransferObjectIf;
/**
 * 
 * sal404 Realty sample application
 * 
 * @component	newscomponent
 * @layer		Domain Layer
 * 
 * This class is a DataTransferObject that includes information
 * about a news item.
 * 
 * @author 		Ilaria Gorla
 * @created		May 2003		
 * @version		1.0.0	
 *
 * 
 */
public class NewsItemDTO implements DataTransferObjectIf
{
	/*
	 *  Variables declaration
	 */
	private String id = null;
	private String title = null;
	private Date date = null;
	private String author = null;
	private String body = null;
	private boolean delete = false;
	
	/*
	 * Constructor for NewsItemDTO class
	 */	
	public NewsItemDTO()
	{
		super();
	}

	/**
	 * Returns the id.
	 * @return String
	 */
	public String getId()
	{
		return id;
	}

	/**
	 * Sets the id.
	 * @param id The id to set
	 */
	public void setId(String id)
	{
	    this.id = id;
	}

	/**
	 * Returns the title.
	 * @return String
	 */
	public String getTitle()
	{
		return title;
	}

	/**
	 * Sets the title.
	 * @param title The title to set
	 */
	public void setTitle(String title)
	{
	    this.title = title;
	}
	
	/**
	 * Returns the date.
	 * @return Date
	 */
	public Date getDate()
	{
		return date;
	}
	
	/**
	 * Sets the date.
	 * @param date The date to set
	 */
	public void setDate(Date date)
	{
	    this.date = date;
	}
	
	/**
	 * Returns the author.
	 * @return String
	 */
	public String getAuthor()
	{
		return author;
	}
	
	/**
	 * Sets the author.
	 * @param author The author to set
	 */
	public void setAuthor(String author)
	{
	    this.author = author;
	}

	/**
	 * Returns the body.
	 * @return String
	 */
	public String getBody()
	{
		return body;
	}

	/**
	 * Sets the body.
	 * @param body The body to set
	 */
	public void setBody(String body)
	{
	    this.body = body;
	}
	/**
	 * Returns the delete.
	 * @return boolean
	 */
	public boolean isDelete()
	{
		return delete;
	}

	/**
	 * Sets the delete.
	 * @param delete The delete to set
	 */
	public void setDelete(boolean delete)
	{
		this.delete = delete;
	}

    private static final long serialVersionUID = 4335646556706046324L;

}
