package com.ibm.itso.sal404.propertycatalog.dao;
import java.sql.*;
import com.ibm.db.beans.*;
/**
 * 
 * sal404 Realty sample application
 * 
 * @component	propertycatalogcomponent
 * @layer		business facade
 * 
 * This class sets the DBModify property values. It also provides 
 * methods that execute your SQL statement and return 
 * a DBModify reference.
 * Generated:  May 16, 2003 2:08:23 PM
 * 
 * @author 		Gwen Gaumond
 * @created		May 13, 2003		
 * @version		1.0.0 / @May 16, 2003 2:08:23 PM	
 *
 * @see		 	to be determined
 * 
 */

/**
 * This class sets the DBModify property values. It also provides 
 * methods that execute your SQL statement and return 
 * a DBModify reference.
 * Generated:  May 16, 2003 2:08:23 PM
 */
public class AddPropertyDetailsDAO
{
	private DBModify modify;
	/**
	 * Constructor for a DBModify class.
	 */
	public AddPropertyDetailsDAO()
	{
		super();
		initializer();	
	}
	/**
	 * Creates a DBModify instance and initializes its properties.
	 */
	protected void initializer()
	{
		modify = new DBModify();
		
		try
		{
			modify.setDataSourceName("jdbc/sal404");
			
			modify.setCommand(
				"INSERT INTO DB2ADMIN.PROP ( USR_ID, PROP_TYPE_ID, PROP_STATUS_ID, PROP_ADDR_CNTRY_CD, PROP_ADDR_POST_CD, PROP_ADDR_RGN, PROP_ADDR_MUNI, PROP_ADDR_STRT_NAM, PROP_ADDR_BLDG_NUM, PROP_ADDR_UNIT_NUM, PROP_ADDR_PO_BOX, PROP_ADDR_ADDL_TEX, PROP_PRICE, PROP_PIC_URL, PROP_SELLER ) VALUES ( :userId, :type, :status, :countryCode, :postalCode, :region, :municipality, :streetName, :buildingNumber, :unitNumber, :postOfficeBox, :additionalText, :price, :pictureURL, :seller )");
			DBParameterMetaData parmMetaData = modify.getParameterMetaData();
			parmMetaData.setParameter(
				1,
				"userId",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.INTEGER,
				Integer.class);
			parmMetaData.setParameter(
				2,
				"type",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.INTEGER,
				Integer.class);
			parmMetaData.setParameter(
				3,
				"status",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.INTEGER,
				Integer.class);
			parmMetaData.setParameter(
				4,
				"countryCode",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.CHAR,
				String.class);
			parmMetaData.setParameter(
				5,
				"postalCode",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				6,
				"region",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				7,
				"municipality",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				8,
				"streetName",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				9,
				"buildingNumber",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				10,
				"unitNumber",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				11,
				"postOfficeBox",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				12,
				"additionalText",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				13,
				"price",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.DECIMAL,
				java.math.BigDecimal.class);
			parmMetaData.setParameter(
				14,
				"pictureURL",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				15,
				"seller",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.INTEGER,
				Integer.class);				
		}
		catch (SQLException ex)
		{
			ex.printStackTrace();
		}
	}
	/**
	 * Executes the SQL statement.
	 */
	public void execute(
		Integer userId,
		Integer type,
		Integer status,
		String countryCode,
		String postalCode,
		String region,
		String municipality,
		String streetName,
		String buildingNumber,
		String unitNumber,
		String postOfficeBox,
		String additionalText,
		java.math.BigDecimal price,
		String pictureURL,
		Integer seller)
		throws SQLException
	{
		try
		{
			
			modify.setParameter("userId", userId);
			modify.setParameter("type", type);
			modify.setParameter("status", status);
			modify.setParameter("countryCode", countryCode);
			modify.setParameter("postalCode", postalCode);
			modify.setParameter("region", region);
			modify.setParameter("municipality", municipality);
			modify.setParameter("streetName", streetName);
			modify.setParameter("buildingNumber", buildingNumber);
			modify.setParameter("unitNumber", unitNumber);
			modify.setParameter("postOfficeBox", postOfficeBox);
			modify.setParameter("additionalText", additionalText);
			modify.setParameter("price", price);
			modify.setParameter("pictureURL", pictureURL);
			modify.setParameter("seller", seller);
			
			modify.execute();
			
		}
		// Free resources of modify object. 
		finally
		{
			modify.close();
		}
	}
	/**
	 * Returns a DBModify reference.
	 */
	public DBModify getDBModify()
	{
		return modify;
	}
}