package com.ibm.itso.sal404.propertycatalog.dao;
import java.sql.*;
import com.ibm.db.beans.*;

/**
 * 
 * sal404 Realty sample application
 * 
 * @component	propertycatalogcomponent
 * @layer		business facade
 * 
 * This class sets the DBModify property values. It also provides 
 * methods that execute your SQL statement and return 
 * a DBModify reference.
 * Generated:  May 19, 2003 2:46:49 PM
 * @author 		Pasi Valjus, Gwen Gaumond
 * @created		May 13, 2003		
 * @version		1.0.0 / @May 19, 2003	
 *
 * @see		 	to be determined
 * 
 */

public class AddPropertyDetailsFeatureDAO
{
	private DBModify modify;
	/**
	 * Constructor for a DBModify class.
	 */
	public AddPropertyDetailsFeatureDAO()
	{
		super();
		initializer();
	}
	/**
	 * Creates a DBModify instance and initializes its properties.
	 */
	protected void initializer()
	{
		modify = new DBModify();
		try
		{
			modify.setDataSourceName("jdbc/sal404");
			
			modify.setCommand(
				"INSERT INTO DB2ADMIN.PROP_FTR_ITM (PROP_ID, PROP_FTR_NAME, PROP_FTR_VALUE ) VALUES ( :propertyId, :name, :value )");
			DBParameterMetaData parmMetaData = modify.getParameterMetaData();
			parmMetaData.setParameter(
				1,
				"propertyId",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.INTEGER,
				Integer.class);
			parmMetaData.setParameter(
				2,
				"name",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				3,
				"value",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
		}
		catch (SQLException ex)
		{
			ex.printStackTrace();
		}
	}
	/**
	 * Executes the SQL statement.
	 */
	public void execute(Integer propertyId, String name, String value)
		throws SQLException
	{
		try
		{
			//modify.setUsername("db2admin");
			//modify.setPassword("db2admin");
			modify.setParameter("propertyId", propertyId);
			modify.setParameter("name", name);
			modify.setParameter("value", value);
			modify.execute();
		}
		// Free resources of modify object. 
		finally
		{
			modify.close();
		}
	}
	/**
	 * Returns a DBModify reference.
	 */
	public DBModify getDBModify()
	{
		return modify;
	}
}