package com.ibm.itso.sal404.propertycatalog.dao;
import java.sql.*;
import com.ibm.db.beans.*;
/**
 * 
 * sal404 Realty sample application
 * 
 * @component	propertycatalogcomponent
 * @layer		business facade
 * 
 * This class sets the DBSelect property values. It also provides 
 * methods that execute your SQL statement, return 
 * a DBSelect reference, and return an array of objects  
 * representing the rows in the result set.
 * Generated:  May 23, 2003 9:32:35 AM
 * @author 		Pasi Valjus, Gwen Gaumond
 * @created		May 13, 2003		
 * @version		1.0.0 / @May 19, 2003	
 *
 * @see		 	to be determined
 * 
 */

public class GetCountryCodeDAO
{
	private DBSelect select;
	/**
	 * Constructor for a DBSelect class.
	 */
	public GetCountryCodeDAO()
	{
		super();
		initializer();
	}
	/**
	 * Creates a DBSelect instance and initializes its properties.
	 */
	protected void initializer()
	{
		select = new DBSelect();
		try
		{	select.setDataSourceName("jdbc/sal404");
			
			select.setCommand(
				"SELECT DB2ADMIN.CNTRY.CNTRY_ID, DB2ADMIN.CNTRY.CNTRY_CD, DB2ADMIN.CNTRY.CNTRY_NAME FROM DB2ADMIN.CNTRY ORDER BY CNTRY_NAME ASC");
		}
		catch (SQLException ex)
		{
			ex.printStackTrace();
		}
	}
	/**
	 * Executes the SQL statement.
	 */
	public void execute() throws SQLException
	{
		try
		{
			
			select.execute();
		}
		// Free resources of select object. 
		finally
		{
			select.close();
		}
	}
	/**
	 * Returns a DBSelect reference.
	 */
	public DBSelect getDBSelect()
	{
		return select;
	}
	/**
	 * Returns an array of objects representing the rows in the result set.
	 */
	public GetCountryCodeDAORow[] getRows()
	{
		GetCountryCodeDAORow[] rows =
			new GetCountryCodeDAORow[select.getRowCount()];
		for (int i = 0; i <= select.getRowCount() - 1; i++)
		{
			rows[i] = new GetCountryCodeDAORow(select, i + 1);
		}
		return rows;
	}
}