package com.ibm.itso.sal404.propertycatalog.dao;
import java.sql.*;
import com.ibm.db.beans.*;

/**
 * 
 * sal404 Realty sample application
 * 
 * @component	propertycatalogcomponent
 * @layer		business facade
 * 
 * This class represents a specific row of a result set 
 * contained in a DBSelect.
 * Generated:  May 23, 2003 9:32:35 AM
 * Generated:  May 19, 2003 2:46:49 PM
 * @author 		Pasi Valjus, Gwen Gaumond
 * @created		May 13, 2003		
 * @version		1.0.0 / @May 19, 2003	
 *
 * @see		 	to be determined
 * 
 */

public class GetCountryCodeDAORow
{
	private int rowNumber;
	private DBSelect select;
	/**
	 * Constructs an object that represents a row from a DBSelect.
	 */
	public GetCountryCodeDAORow(DBSelect aRef, int aRowNumber)
	{
		select = aRef;
		rowNumber = aRowNumber;
	}
	/**
	 * Returns the value of column CNTRY_CNTRY_ID in the row represented by this object. 
	 */
	public Object getCNTRY_CNTRY_ID() throws SQLException
	{
		return select.getCacheValueAt(rowNumber, 1);
	}
	/**
	 * Returns the value of column CNTRY_CNTRY_CD in the row represented by this object. 
	 */
	public Object getCNTRY_CNTRY_CD() throws SQLException
	{
		return select.getCacheValueAt(rowNumber, 2);
	}
	/**
	 * Returns the value of column CNTRY_CNTRY_NAME in the row represented by this object. 
	 */
	public Object getCNTRY_CNTRY_NAME() throws SQLException
	{
		return select.getCacheValueAt(rowNumber, 3);
	}
	/**
	 * Returns a String that contains all of the values in the row represented by this object. 
	 */
	public String toString()
	{
		String string = "";
		try
		{
			for (int i = 1; i <= select.getColumnCount(); i++)
			{
				string += select.getCacheValueAt(rowNumber, i);
				string += "  ";
			}
		}
		catch (SQLException ex)
		{
			return null;
		}
		return string;
	}
}