package com.ibm.itso.sal404.propertycatalog.dao;
import java.sql.*;
import com.ibm.db.beans.*;
import com.ibm.itso.sal404.common.util.AppProperties;
/**
 * This class sets the DBSelect property values. It also provides 
 * methods that execute your SQL statement, return 
 * a DBSelect reference, and return an array of objects  
 * representing the rows in the result set.
 * Generated:  May 15, 2003 2:07:53 PM
 */
public class GetPropertiesBySearchCriteriaDAO
{
	private DBSelect select;
	/**
	 * Constructor for a DBSelect class.
	 */
	public GetPropertiesBySearchCriteriaDAO()
	{
		super();
		initializer();
	}
	/**
	 * Creates a DBSelect instance and initializes its properties.
	 */
	protected void initializer()
	{
		select = new DBSelect();
		try
		{
			select.setDataSourceName(AppProperties.getInstance().getProperty("dataSourceJNDIName"));
			select.setCommand(
				"SELECT DB2ADMIN.PROP.PROP_ID, DB2ADMIN.PROP.PROP_ADDR_STRT_NAM, DB2ADMIN.PROP.PROP_PRICE, DB2ADMIN.PROP_TYPE.PROP_TYPE_DESC, DB2ADMIN.PROP_STS.PROP_STS_DESC, DB2ADMIN.USR.USR_USERNAME, DB2ADMIN.USR.USR_FIRST_NAME, DB2ADMIN.USR.USR_LAST_NAME FROM DB2ADMIN.USR, DB2ADMIN.PROP LEFT OUTER JOIN DB2ADMIN.PROP_TYPE ON DB2ADMIN.PROP.PROP_TYPE_ID = DB2ADMIN.PROP_TYPE.PROP_TYPE_ID LEFT OUTER JOIN DB2ADMIN.PROP_STS ON DB2ADMIN.PROP.PROP_STATUS_ID = DB2ADMIN.PROP_STS.PROP_STS_ID WHERE DB2ADMIN.PROP.USR_ID = DB2ADMIN.USR.USR_ID AND DB2ADMIN.PROP.PROP_TYPE_ID = :propertyType AND DB2ADMIN.PROP.PROP_PRICE > :minPrice AND DB2ADMIN.PROP.PROP_PRICE < :maxPrice AND DB2ADMIN.PROP.PROP_ADDR_POST_CD like :postalCode");
			DBParameterMetaData parmMetaData = select.getParameterMetaData();
			parmMetaData.setParameter(
				1,
				"propertyType",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.INTEGER,
				Integer.class);
			parmMetaData.setParameter(
				2,
				"minPrice",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.DECIMAL,
				java.math.BigDecimal.class);
			parmMetaData.setParameter(
				3,
				"maxPrice",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.DECIMAL,
				java.math.BigDecimal.class);
			parmMetaData.setParameter(
				4,
				"postalCode",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
		}
		catch (SQLException ex)
		{
			ex.printStackTrace();
		}
	}
	/**
	 * Executes the SQL statement.
	 */
	public void execute(
		Integer propertyType,
		java.math.BigDecimal minPrice,
		java.math.BigDecimal maxPrice,
		String postalCode)
		throws SQLException
	{
		try
		{
			select.setParameter("propertyType", propertyType);
			select.setParameter("minPrice", minPrice);
			select.setParameter("maxPrice", maxPrice);
			select.setParameter("postalCode", postalCode);
			select.execute();
		}
		// Free resources of select object. 
		finally
		{
			select.close();
		}
	}
	/**
	 * Returns a DBSelect reference.
	 */
	public DBSelect getDBSelect()
	{
		return select;
	}
	/**
	 * Returns an array of objects representing the rows in the result set.
	 */
	public GetPropertiesBySearchCriteriaRowDAO[] getRows()
	{
		GetPropertiesBySearchCriteriaRowDAO[] rows =
			new GetPropertiesBySearchCriteriaRowDAO[select.getRowCount()];
		for (int i = 0; i <= select.getRowCount() - 1; i++)
		{
			rows[i] = new GetPropertiesBySearchCriteriaRowDAO(select, i + 1);
		}
		return rows;
	}
}