package com.ibm.itso.sal404.propertycatalog.dao;
import java.sql.*;
import com.ibm.db.beans.*;
import com.ibm.itso.sal404.common.util.AppProperties;
/**
 * This class sets the DBSelect property values. It also provides 
 * methods that execute your SQL statement, return 
 * a DBSelect reference, and return an array of objects  
 * representing the rows in the result set.
 * Generated:  15-May-03 20:51:00
 */
public class GetPropertiesForAgentDAO
{
	private DBSelect select;
	/**
	 * Constructor for a DBSelect class.
	 */
	public GetPropertiesForAgentDAO()
	{
		super();
		initializer();
	}
	/**
	 * Creates a DBSelect instance and initializes its properties.
	 */
	protected void initializer()
	{
		select = new DBSelect();
		try
		{
			select.setDataSourceName(AppProperties.getInstance().getProperty("dataSourceJNDIName"));
			select.setCommand(
				"SELECT PROP.PROP_ID, PROP_TYPE.PROP_TYPE_DESC, PROP_STS.PROP_STS_DESC,PROP.PROP_ADDR_POST_CD, PROP.PROP_ADDR_RGN, PROP.PROP_ADDR_MUNI, PROP.PROP_ADDR_STRT_NAM, PROP.PROP_ADDR_UNIT_NUM, PROP.PROP_ADDR_PO_BOX, PROP.PROP_ADDR_BLDG_NUM, PROP.PROP_ADDR_ADDL_TEX, PROP.PROP_PRICE, PROP.PROP_PIC_URL, USR.USR_USERNAME, USR.USR_FIRST_NAME, USR.USR_LAST_NAME FROM DB2ADMIN.USR AS USR inner join DB2ADMIN.PROP AS PROP ON USR.USR_ID = PROP.USR_ID inner join DB2ADMIN.PROP_STS AS PROP_STS ON PROP.PROP_STATUS_ID = PROP_STS.PROP_STS_ID inner join DB2ADMIN.PROP_TYPE AS PROP_TYPE ON PROP.PROP_TYPE_ID = PROP_TYPE.PROP_TYPE_ID    WHERE PROP.USR_ID = :agentId ");
			DBParameterMetaData parmMetaData = select.getParameterMetaData();
			parmMetaData.setParameter(
				1,
				"agentId",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.INTEGER,
				Integer.class);
		}
		catch (SQLException ex)
		{
			ex.printStackTrace();
		}
	}
	/**
	 * Executes the SQL statement.
	 */
	public void execute(Integer agentId) throws SQLException
	{
		try
		{
			select.setParameter("agentId", agentId);
			select.execute();
		}
		// Free resources of select object. 
		finally
		{
			select.close();
		}
	}
	/**
	 * Returns a DBSelect reference.
	 */
	public DBSelect getDBSelect()
	{
		return select;
	}
	/**
	 * Returns an array of objects representing the rows in the result set.
	 */
	public GetPropertiesForAgentDAORow[] getRows()
	{
		GetPropertiesForAgentDAORow[] rows =
			new GetPropertiesForAgentDAORow[select.getRowCount()];
		for (int i = 0; i <= select.getRowCount() - 1; i++)
		{
			rows[i] = new GetPropertiesForAgentDAORow(select, i + 1);
		}
		return rows;
	}
}