package com.ibm.itso.sal404.propertycatalog.dao;
import java.sql.*;
import com.ibm.db.beans.*;
/**
 * 
 * sal404 Realty sample application
 * 
 * @component	Property Catalog component
 * @layer		name of layer here
 * 
 * This class sets the DBSelect property values. It also provides 
 * methods that execute your SQL statement, return 
 * a DBSelect reference, and return an array of objects  
 * representing the rows in the result set.
 * Generated:  May 23, 2003 8:24:13 PM
 * 
 * 
 * @author 		Gwen Gaumond, Twinstar Incorporated
 * @created		initial creation date here		
 * @version		x.y.z / @May 22, 2003 12:51:04 AM
 *
 * @see		 	classes associated with this class
 * 
 */

public class GetPropertyByIdDAO
{
	private DBSelect select;
	/**
	 * Constructor for a DBSelect class.
	 */
	public GetPropertyByIdDAO()
	{
		super();
		initializer();
	}
	/**
	 * Creates a DBSelect instance and initializes its properties.
	 */
	protected void initializer()
	{
		select = new DBSelect();
		try
		{
			select.setDataSourceName("jdbc/sal404");
			
			select.setCommand(
				"SELECT DB2ADMIN.PROP.PROP_ID, DB2ADMIN.PROP.USR_ID, DB2ADMIN.PROP.PROP_TYPE_ID, DB2ADMIN.PROP.PROP_STATUS_ID, DB2ADMIN.PROP.PROP_ADDR_CNTRY_CD, DB2ADMIN.PROP.PROP_ADDR_POST_CD, DB2ADMIN.PROP.PROP_ADDR_RGN, DB2ADMIN.PROP.PROP_ADDR_MUNI, DB2ADMIN.PROP.PROP_ADDR_STRT_NAM, DB2ADMIN.PROP.PROP_ADDR_BLDG_NUM, DB2ADMIN.PROP.PROP_ADDR_UNIT_NUM, DB2ADMIN.PROP.PROP_ADDR_PO_BOX, DB2ADMIN.PROP.PROP_ADDR_ADDL_TEX, DB2ADMIN.PROP.PROP_PRICE, DB2ADMIN.PROP.PROP_PIC_URL, DB2ADMIN.PROP.PROP_CRD_ON, DB2ADMIN.PROP.PROP_SELLER FROM DB2ADMIN.PROP WHERE DB2ADMIN.PROP.PROP_ID = :Id");
			DBParameterMetaData parmMetaData = select.getParameterMetaData();
			parmMetaData.setParameter(
				1,
				"Id",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.INTEGER,
				Integer.class);
		}
		catch (SQLException ex)
		{
			ex.printStackTrace();
		}
	}
	/**
	 * Executes the SQL statement.
	 */
	public void execute(Integer Id) throws SQLException
	{
		try
		{
			
			select.setParameter("Id", Id);
			select.execute();
		}
		// Free resources of select object. 
		finally
		{
			select.close();
		}
	}
	/**
	 * Returns a DBSelect reference.
	 */
	public DBSelect getDBSelect()
	{
		return select;
	}
	/**
	 * Returns an array of objects representing the rows in the result set.
	 */
	public GetPropertyByIdDAORow[] getRows()
	{
		GetPropertyByIdDAORow[] rows =
			new GetPropertyByIdDAORow[select.getRowCount()];
		for (int i = 0; i <= select.getRowCount() - 1; i++)
		{
			rows[i] = new GetPropertyByIdDAORow(select, i + 1);
		}
		return rows;
	}
}