package com.ibm.itso.sal404.propertycatalog.dao;
import java.sql.*;
import com.ibm.db.beans.*;
import com.ibm.itso.sal404.common.util.AppProperties;
/**
 * This class sets the DBSelect property values. It also provides 
 * methods that execute your SQL statement, return 
 * a DBSelect reference, and return an array of objects  
 * representing the rows in the result set.
 * Generated:  May 15, 2003 5:19:52 PM
 */
public class GetPropertyDetailsDAO
{
	private DBSelect select;
	/**
	 * Constructor for a DBSelect class.
	 */
	public GetPropertyDetailsDAO()
	{
		super();
		initializer();
	}
	/**
	 * Creates a DBSelect instance and initializes its properties.
	 */
	protected void initializer()
	{
		select = new DBSelect();
		try
		{
			select.setDataSourceName(AppProperties.getInstance().getProperty("dataSourceJNDIName"));
			select.setCommand(
				"SELECT DB2ADMIN.CNTRY.CNTRY_NAME, DB2ADMIN.PROP.PROP_ID,DB2ADMIN.PROP.PROP_ADDR_POST_CD,DB2ADMIN.PROP.PROP_ADDR_RGN,DB2ADMIN.PROP.PROP_ADDR_MUNI, DB2ADMIN.PROP.PROP_ADDR_STRT_NAM, DB2ADMIN.PROP.PROP_ADDR_BLDG_NUM, DB2ADMIN.PROP.PROP_ADDR_UNIT_NUM, DB2ADMIN.PROP.PROP_ADDR_PO_BOX, DB2ADMIN.PROP.PROP_ADDR_ADDL_TEX, DB2ADMIN.PROP.PROP_PRICE, DB2ADMIN.PROP.PROP_PIC_URL, DB2ADMIN.PROP_STS.PROP_STS_DESC, DB2ADMIN.PROP_TYPE.PROP_TYPE_DESC, DB2ADMIN.USR.USR_USERNAME, DB2ADMIN.USR.USR_FIRST_NAME, DB2ADMIN.USR.USR_LAST_NAME FROM DB2ADMIN.USR, DB2ADMIN.PROP LEFT OUTER JOIN DB2ADMIN.PROP_TYPE ON DB2ADMIN.PROP.PROP_TYPE_ID = DB2ADMIN.PROP_TYPE.PROP_TYPE_ID  LEFT OUTER JOIN DB2ADMIN.PROP_STS ON DB2ADMIN.PROP.PROP_STATUS_ID = DB2ADMIN.PROP_STS.PROP_STS_ID  RIGHT OUTER JOIN DB2ADMIN.CNTRY ON DB2ADMIN.PROP.PROP_ADDR_CNTRY_CD = DB2ADMIN.CNTRY.CNTRY_CD WHERE  DB2ADMIN.PROP.USR_ID = DB2ADMIN.USR.USR_ID AND DB2ADMIN.PROP.PROP_ID = :propertyId");
			DBParameterMetaData parmMetaData = select.getParameterMetaData();
			parmMetaData.setParameter(
				1,
				"propertyId",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.INTEGER,
				Integer.class);
		}
		catch (SQLException ex)
		{
			ex.printStackTrace();
		}
	}
	/**
	 * Executes the SQL statement.
	 */
	public void execute(Integer propertyId)
		throws SQLException
	{
		try
		{
			select.setParameter("propertyId", propertyId);
			select.execute();
		}
		// Free resources of select object. 
		finally
		{
			select.close();
		}
	}
	/**
	 * Returns a DBSelect reference.
	 */
	public DBSelect getDBSelect()
	{
		return select;
	}
	/**
	 * Returns an array of objects representing the rows in the result set.
	 */
	public GetPropertyDetailsRowDAO[] getRows()
	{
		GetPropertyDetailsRowDAO[] rows =
			new GetPropertyDetailsRowDAO[select.getRowCount()];
		for (int i = 0; i <= select.getRowCount() - 1; i++)
		{
			rows[i] = new GetPropertyDetailsRowDAO(select, i + 1);
		}
		return rows;
	}
}