package com.ibm.itso.sal404.propertycatalog.dao;
import java.sql.*;
import com.ibm.db.beans.*;
import com.ibm.itso.sal404.common.util.AppProperties;
/**
 * This class sets the DBSelect property values. It also provides 
 * methods that execute your SQL statement, return 
 * a DBSelect reference, and return an array of objects  
 * representing the rows in the result set.
 * Generated:  May 19, 2003 11:28:13 AM
 */
public class GetPropertyFeaturesDAO
{
	private DBSelect select;
	/**
	 * Constructor for a DBSelect class.
	 */
	public GetPropertyFeaturesDAO()
	{
		super();
		initializer();
	}
	/**
	 * Creates a DBSelect instance and initializes its properties.
	 */
	protected void initializer()
	{
		select = new DBSelect();
		try
		{
			select.setDataSourceName(AppProperties.getInstance().getProperty("dataSourceJNDIName"));
			select.setCommand(
				"SELECT DB2ADMIN.PROP_FTR_ITM.PROP_FTR_NAME, DB2ADMIN.PROP_FTR_ITM.PROP_FTR_VALUE FROM DB2ADMIN.PROP_FTR_ITM WHERE DB2ADMIN.PROP_FTR_ITM.PROP_ID = :propertyId");
			DBParameterMetaData parmMetaData = select.getParameterMetaData();
			parmMetaData.setParameter(
				1,
				"propertyId",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.INTEGER,
				Integer.class);
		}
		catch (SQLException ex)
		{
			ex.printStackTrace();
		}
	}
	/**
	 * Executes the SQL statement.
	 */
	public void execute(Integer propertyId)
		throws SQLException
	{
		try
		{
			select.setParameter("propertyId", propertyId);
			select.execute();
		}
		// Free resources of select object. 
		finally
		{
			select.close();
		}
	}
	/**
	 * Returns a DBSelect reference.
	 */
	public DBSelect getDBSelect()
	{
		return select;
	}
	/**
	 * Returns an array of objects representing the rows in the result set.
	 */
	public GetPropertyFeaturesDAORow[] getRows()
	{
		GetPropertyFeaturesDAORow[] rows =
			new GetPropertyFeaturesDAORow[select.getRowCount()];
		for (int i = 0; i <= select.getRowCount() - 1; i++)
		{
			rows[i] = new GetPropertyFeaturesDAORow(select, i + 1);
		}
		return rows;
	}
}