package com.ibm.itso.sal404.propertycatalog.dao;
import java.sql.*;
import com.ibm.db.beans.*;
/**
 * 
 * sal404 Realty sample application
 * 
 * @component	Property Catalog component
 * @layer		name of layer here
 * 
 * This class sets the DBSelect property values. It also provides 
 * methods that execute your SQL statement, return 
 * a DBSelect reference, and return an array of objects  
 * representing the rows in the result set.
 * Generated:  May 22, 2003 6:38:14 PM
 * 
 * 
 * @author 		Gwen Gaumond, Twinstar Incorporated
 * @created		initial creation date here		
 * @version		x.y.z / @May 22, 2003 12:51:04 AM
 *
 * @see		 	classes associated with this class
 * 
 */


public class GetPropertyStatusDAO
{
	private DBSelect select;
	/**
	 * Constructor for a DBSelect class.
	 */
	public GetPropertyStatusDAO()
	{
		super();
		initializer();
	}
	/**
	 * Creates a DBSelect instance and initializes its properties.
	 */
	protected void initializer()
	{
		select = new DBSelect();
		try
		{	select.setDataSourceName("jdbc/sal404");
			
			select.setCommand(
				"SELECT DB2ADMIN.PROP_STS.PROP_STS_ID, DB2ADMIN.PROP_STS.PROP_STS_DESC FROM DB2ADMIN.PROP_STS");
		}
		catch (SQLException ex)
		{
			ex.printStackTrace();
		}
	}
	/**
	 * Executes the SQL statement.
	 */
	public void execute() throws SQLException
	{
		try
		{
			
			select.execute();
		}
		// Free resources of select object. 
		finally
		{
			select.close();
		}
	}
	/**
	 * Returns a DBSelect reference.
	 */
	public DBSelect getDBSelect()
	{
		return select;
	}
	/**
	 * Returns an array of objects representing the rows in the result set.
	 */
	public GetPropertyStatusDAORow[] getRows()
	{
		GetPropertyStatusDAORow[] rows =
			new GetPropertyStatusDAORow[select.getRowCount()];
		for (int i = 0; i <= select.getRowCount() - 1; i++)
		{
			rows[i] = new GetPropertyStatusDAORow(select, i + 1);
		}
		return rows;
	}
}