package com.ibm.itso.sal404.propertycatalog.dao;
import java.sql.*;
import com.ibm.db.beans.*;
import com.ibm.itso.sal404.common.util.AppProperties;
/**
 * This class sets the DBSelect property values. It also provides 
 * methods that execute your SQL statement, return 
 * a DBSelect reference, and return an array of objects  
 * representing the rows in the result set.
 * Generated:  May 17, 2003 12:40:29 PM
 */
public class GetPropertyTypesDAO
{
	private DBSelect select;
	/**
	 * Constructor for a DBSelect class.
	 */
	public GetPropertyTypesDAO()
	{
		super();
		initializer();
	}
	/**
	 * Creates a DBSelect instance and initializes its properties.
	 */
	protected void initializer()
	{
		select = new DBSelect();
		try
		{
			select.setDataSourceName(AppProperties.getInstance().getProperty("dataSourceJNDIName"));
			select.setCommand(
				"SELECT DB2ADMIN.PROP_TYPE.PROP_TYPE_ID, DB2ADMIN.PROP_TYPE.PROP_TYPE_DESC FROM DB2ADMIN.PROP_TYPE");
		}
		catch (SQLException ex)
		{
			ex.printStackTrace();
		}
	}
	/**
	 * Executes the SQL statement.
	 */
	public void execute() throws SQLException
	{
		try
		{
			select.execute();
		}
		// Free resources of select object. 
		finally
		{
			select.close();
		}
	}
	/**
	 * Returns a DBSelect reference.
	 */
	public DBSelect getDBSelect()
	{
		return select;
	}
	/**
	 * Returns an array of objects representing the rows in the result set.
	 */
	public GetPropertyTypesDAORow[] getRows()
	{
		GetPropertyTypesDAORow[] rows =
			new GetPropertyTypesDAORow[select.getRowCount()];
		for (int i = 0; i <= select.getRowCount() - 1; i++)
		{
			rows[i] = new GetPropertyTypesDAORow(select, i + 1);
		}
		return rows;
	}
}