package com.ibm.itso.sal404.propertycatalog.dao;
import java.sql.*;
import com.ibm.db.beans.*;
/**
 * 
 * sal404 Realty sample application
 * 
 * @component	Property Catalog component
 * @layer		name of layer here
 * 
 *This class sets the DBModify property values. It also provides 
 * methods that execute your SQL statement and return 
 * a DBModify reference.
 * Generated:  May 22, 2003 12:51:04 AM
 * 
 * 
 * @author 		Gwen Gaumond, Twinstar Incorporated
 * @created		initial creation date here		
 * @version		x.y.z / @May 22, 2003 12:51:04 AM
 *
 * @see		 	classes associated with this class
 * 
 */

public class ModifyPropertyDetailsDAO
{
	private DBModify modify;
	/**
	 * Constructor for a DBModify class.
	 */
	public ModifyPropertyDetailsDAO()
	{
		super();
		initializer();
	}
	/**
	 * Creates a DBModify instance and initializes its properties.
	 */
	protected void initializer()
	{
		modify = new DBModify();
		try
		{
			modify.setDataSourceName("jdbc/sal404");
			
			modify.setCommand(
				"UPDATE DB2ADMIN.PROP SET USR_ID = :userId, PROP_TYPE_ID = :type, PROP_STATUS_ID = :status, PROP_ADDR_CNTRY_CD = :countryCode, PROP_ADDR_POST_CD = :postalCode, PROP_ADDR_RGN = :region, PROP_ADDR_MUNI = :municipality, PROP_ADDR_STRT_NAM = :streetName, PROP_ADDR_BLDG_NUM = :buildingNumber, PROP_ADDR_UNIT_NUM = :unitNumber, PROP_ADDR_PO_BOX = :postOfficeBox, PROP_ADDR_ADDL_TEX = :additionalText, PROP_PRICE = :price, PROP_PIC_URL = :propPictureURL WHERE DB2ADMIN.PROP.PROP_ID = :id");
			DBParameterMetaData parmMetaData = modify.getParameterMetaData();
			parmMetaData.setParameter(
				1,
				"userId",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.INTEGER,
				Integer.class);
			parmMetaData.setParameter(
				2,
				"type",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.INTEGER,
				Integer.class);
			parmMetaData.setParameter(
				3,
				"status",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.INTEGER,
				Integer.class);
			parmMetaData.setParameter(
				4,
				"countryCode",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.CHAR,
				String.class);
			parmMetaData.setParameter(
				5,
				"postalCode",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				6,
				"region",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				7,
				"municipality",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				8,
				"streetName",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				9,
				"buildingNumber",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				10,
				"unitNumber",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				11,
				"postOfficeBox",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				12,
				"additionalText",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				13,
				"price",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.DECIMAL,
				java.math.BigDecimal.class);
			parmMetaData.setParameter(
				14,
				"propPictureURL",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				15,
				"id",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.INTEGER,
				Integer.class);
		}
		catch (SQLException ex)
		{
			ex.printStackTrace();
		}
	}
	/**
	 * Executes the SQL statement.
	 */
	public void execute(
		Integer id,
		Integer userId,
		Integer type,
		Integer status,
		String countryCode,
		String postalCode,
		String region,
		String municipality,
		String streetName,
		String buildingNumber,
		String unitNumber,
		String postOfficeBox,
		String additionalText,
		java.math.BigDecimal price,
		String propPictureURL		
		)
		throws SQLException
	{
		try
		{
			
			
			modify.setParameter("userId", userId);
			modify.setParameter("type", type);
			modify.setParameter("status", status);
			modify.setParameter("countryCode", countryCode);
			modify.setParameter("postalCode", postalCode);
			modify.setParameter("region", region);
			modify.setParameter("municipality", municipality);
			modify.setParameter("streetName", streetName);
			modify.setParameter("buildingNumber", buildingNumber);
			modify.setParameter("unitNumber", unitNumber);
			modify.setParameter("postOfficeBox", postOfficeBox);
			modify.setParameter("additionalText", additionalText);
			modify.setParameter("price", price);
			modify.setParameter("propPictureURL", propPictureURL);
			//modify.setParameter("createdOn", createdOn);
			modify.setParameter("id", id);
			modify.execute();
		}
		// Free resources of modify object. 
		finally
		{
			modify.close();
		}
	}
	/**
	 * Returns a DBModify reference.
	 */
	public DBModify getDBModify()
	{
		return modify;
	}
}