package com.ibm.itso.sal404.propertycatalog.dao;
import java.sql.*;
import com.ibm.db.beans.*;
/**
 * This class sets the DBModify property values. It also provides 
 * methods that execute your SQL statement and return 
 * a DBModify reference.
 * Generated:  May 22, 2003 12:53:25 AM
 */
public class ModifyPropertyFeatureDetailsDAO
{
	private DBModify modify;
	/**
	 * Constructor for a DBModify class.
	 */
	public ModifyPropertyFeatureDetailsDAO()
	{
		super();
		initializer();
	}
	/**
	 * Creates a DBModify instance and initializes its properties.
	 */
	protected void initializer()
	{
		modify = new DBModify();
		try
		{
			modify.setDriverName("COM.ibm.db2.jdbc.app.DB2Driver");
			modify.setUrl("jdbc:db2:sal404");
			modify.setCommand(
				"UPDATE DB2ADMIN.PROP_FTR_ITM SET PROP_FTR_NAME = :name, PROP_FTR_VALUE = :value WHERE DB2ADMIN.PROP_FTR_ITM.ID = :id AND DB2ADMIN.PROP_FTR_ITM.PROP_ID = :propertyId");
			DBParameterMetaData parmMetaData = modify.getParameterMetaData();
			parmMetaData.setParameter(
				1,
				"propertyId",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.INTEGER,
				Integer.class);
			parmMetaData.setParameter(
				2,
				"name",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				3,
				"value",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				4,
				"id",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.INTEGER,
				Integer.class);
		}
		catch (SQLException ex)
		{
			ex.printStackTrace();
		}
	}
	/**
	 * Executes the SQL statement.
	 */
	public void execute(
		Integer id,
		Integer propertyId,
		String name,
		String value
		)
		throws SQLException
	{
		try
		{
			//modify.setUsername("db2admin");
			//modify.setPassword("db2admin");
			//modify.setParameter("id", id);
			modify.setParameter("propertyId", propertyId);
			modify.setParameter("name", name);
			modify.setParameter("value", value);
			modify.execute();
		}
		// Free resources of modify object. 
		finally
		{
			modify.close();
		}
	}
	/**
	 * Returns a DBModify reference.
	 */
	public DBModify getDBModify()
	{
		return modify;
	}
}