package com.ibm.itso.sal404.propertycatalog.dao;
import java.sql.*;
import com.ibm.db.beans.*;
/**
 * 
 * sal404 Realty sample application
 * 
 * @component	Property Catalog component
 * @layer		name of layer here
 * 
 * This class represents a specific row of a result set 
 * contained in a DBSelect.
 * Generated:  May 20, 2003 6:15:06 PM
 * 
 * 
 * @author 		Gwen Gaumond, Twinstar Incorporated
 * @created		initial creation date here		
 * @version		x.y.z / @May 20, 2003	
 *
 * @see		 	classes associated with this class
 * 
 */


public class NewPropertyIdDAORow
{
	private int rowNumber;
	private DBSelect select;
	/**
	 * Constructs an object that represents a row from a DBSelect.
	 */
	public NewPropertyIdDAORow(DBSelect aRef, int aRowNumber)
	{
		select = aRef;
		rowNumber = aRowNumber;
	}
	/**
	 * Returns the value of column PROP_PROP_ID in the row represented by this object. 
	 */
	public Object getPROP_PROP_ID() throws SQLException
	{
		return select.getCacheValueAt(rowNumber, 1);
	}
	/**
	 * Returns a String that contains all of the values in the row represented by this object. 
	 */
	public String toString()
	{
		String string = "";
		try
		{
			for (int i = 1; i <= select.getColumnCount(); i++)
			{
				string += select.getCacheValueAt(rowNumber, i);
				string += "  ";
			}
		}
		catch (SQLException ex)
		{
			return null;
		}
		return string;
	}
}