package com.ibm.itso.sal404.propertycatalog.dto;
import com.ibm.itso.sal404.common.base.DataTransferObjectIf;
import java.math.*;
/**
 * 
 * sal404 Realty sample application
 * 
 * @component 	PropertyCatalog component
 * @layer		Domain Layer
 * 
 * Description of the class here
 * 
 * @author 		Gwen Gaumond, Twinstar Incorporated
 * @created		May 13, 2003	
 * @version		1.0.0 / @May 13, 2003	
 *
 * @see		 	to be completed
 * 
 */
public final class PropertyDTO implements DataTransferObjectIf
{
	private Integer id;
	private Integer userId;
	private Integer type;
	private Integer status;
	private Integer seller = null;
	private String countryCode = null;
	private String postalCode = null;
	private String region = null;
	private String municipality = null;
	private String streetName = null;
	private String buildingNumber = null;
	private String unitNumber = null;
	private String postOfficeBox = null;
	private String additionalText = null;
	private String pictureURL = null;
	private BigDecimal price = null;
	private String createdOn = null;
	
    /**
     * @return Returns the seller.
     */
    public Integer getSeller() {
        return seller;
    }
    /**
     * @param seller The seller to set.
     */
    public void setSeller(Integer seller) {
        this.seller = seller;
    }
	/**
	 * Constructor for PropertyCatalogDTO.
	 */
	public PropertyDTO()
	{
		//constructor start
		super();
	} //constructor finish
	/**
	 * Returns the additionalText.
	 * @return String
	 */
	public String getAdditionalText()
	{
		return additionalText;
	}
	/**
	 * Returns the buildingNumber.
	 * @return String
	 */
	public String getBuildingNumber()
	{
		return buildingNumber;
	}
	/**
	 * Returns the countryCode.
	 * @return String
	 */
	public String getCountryCode()
	{
		return countryCode;
	}
	/**
	 * Returns the createdOn.
	 * @return String
	 */
	public String getCreatedOn()
	{
		return createdOn;
	}
	/**
	 * Returns the municipality.
	 * @return String
	 */
	public String getMunicipality()
	{
		return municipality;
	}
	/**
	 * Returns the pictureURL.
	 * @return String
	 */
	public String getPictureURL()
	{
		return pictureURL;
	}
	/**
	 * Returns the postalCode.
	 * @return String
	 */
	public String getPostalCode()
	{
		return postalCode;
	}
	/**
	 * Returns the postOfficeBox.
	 * @return String
	 */
	public String getPostOfficeBox()
	{
		return postOfficeBox;
	}

	public BigDecimal getPrice()
	{
		return price;
	}

	/**
	 * Returns the region.
	 * @return String
	 */
	public String getRegion()
	{
		return region;
	}
	/**
	 * Returns the status.
	 * @return String
	 */

	public String getStreetName()
	{
		return streetName;
	}
	/**
	 * Returns the unitNumber.
	 * @return String
	 */
	public String getUnitNumber()
	{
		return unitNumber;
	}
	/**
	 * Sets the additionalText.
	 * @param additionalText The additionalText to set
	 */
	public void setAdditionalText(String additionalText)
	{
	    this.additionalText = additionalText;
	}
	/**
	 * Sets the buildingNumber.
	 * @param buildingNumber The buildingNumber to set
	 */
	public void setBuildingNumber(String buildingNumber)
	{
	    this.buildingNumber = buildingNumber;
	}
	/**
	 * Sets the countryCode.
	 * @param countryCode The countryCode to set
	 */
	public void setCountryCode(String country)
	{
	    this.countryCode = country;
	}
	/**
	 * Sets the createdOn.
	 * @param createdOn The createdOn to set
	 */
	public void setCreatedOn(String createdOn)
	{
	    this.createdOn = createdOn;
	}
	/**
	 * Sets the municipality.
	 * @param municipality The municipality to set
	 */
	public void setMunicipality(String municipality)
	{
	    this.municipality = municipality;
	}
	/**
	 * Sets the pictureURL.
	 * @param pictureURL The pictureURL to set
	 */
	public void setPictureURL(String pictureURL)
	{
	    this.pictureURL = pictureURL;
	}
	/**
	 * Sets the postalCode.
	 * @param postalCode The postalCode to set
	 */
	public void setPostalCode(String postalCode)
	{
	    this.postalCode = postalCode;
	}
	/**
	 * Sets the postOfficeBox.
	 * @param postOfficeBox The postOfficeBox to set
	 */
	public void setPostOfficeBox(String postOfficeBox)
	{
	    this.postOfficeBox = postOfficeBox;
	}
	/**
	 * Sets the price.
	 * @param price The price to set
	 */
	public void setPrice(BigDecimal price)
	{
	    this.price = price;
	}

	/**
	 * Sets the region.
	 * @param region The region to set
	 */
	public void setRegion(String region)
	{
	    this.region = region;
	}

	/**
	 * Sets the streetName.
	 * @param streetName The streetName to set
	 */
	public void setStreetName(String streetName)
	{
	    this.streetName = streetName;
	}

	/**
	 * Sets the unitNumber.
	 * @param unitNumber The unitNumber to set
	 */
	public void setUnitNumber(String unitNumber)
	{
	    this.unitNumber = unitNumber;
	}
	/**
	 * Sets the type.
	 * @param type The type to set
	 */
	public void setType(Integer type)
	{
	    this.type = type;
	}

	/**
	 * Returns the type.
	 * @return Integer
	 */
	public Integer getType()
	{
		return type;
	}

	/**
	 * Sets the status.
	 * @param status The status to set
	 */
	public void setStatus(Integer status)
	{
	    this.status = status;
	}

	/**
	 * Returns the status.
	 * @return Integer
	 */
	public Integer getStatus()
	{
		return status;
	}

	/**
	 * Returns the _id.
	 * @return Integer
	 */
	public Integer getId()
	{
		return id;
	}

	/**
	 * Sets the _id.
	 * @param _id The _id to set
	 */
	public void setId(Integer id)
	{
		this.id = id;
	}

	/**
	 * Returns the _userId.
	 * @return Integer
	 */
	public Integer getUserId()
	{
		return userId;
	}

	/**
	 * Sets the _userId.
	 * @param _userId The _userId to set
	 */
	public void setUserId(Integer userId)
	{
		this.userId = userId;
	}

    private static final long serialVersionUID = 9034382389953454375L;

}
