package com.ibm.itso.sal404.propertycatalog.dto;
import java.util.Vector;

import com.ibm.itso.sal404.common.base.DataTransferObjectIf;
/**
 * 
 * sal404 Realty sample application
 * 
 * @component 	PropertyCatalog component
 * @layer		domain layer
 * 
 * Contains all data for a property except property features
 * Used on the way out as a result from a SQL
 * 
 * @author 		Pasi Valjus
 * @created		May 25  2003	
 * @version		1.0.0 / @May 25, 2003	
 *
 * @see		 	to be completed
 * 
 */
public final class ResultPropertyDetailsDTO implements DataTransferObjectIf
{
	
	
	private int 		_id;
	private String 		_typeDescription;
	private String 		_statusDescription;
	private String		_addressCountryName;
	private String		_addressPostCode;
	private String		_addressRegion;
	private String		_addressMunicipality;
	private String		_addressStreetName;
	private String		_addressUnitNumber;
	private String		_addressPOBox;
	private String		_addressBuildingNumber;
	private String		_addressAdditionalText;
	private double		_price;
	private String		_pictureURL;
	private String		_userName;
	private String		_countryName;
	private Vector		_propertyFeatures;
	private String		_firstName;
	private String		_lastName;
	
	
	/**
	 * Constructor for ResultFromPropertyDetailsDTO.
	 */
	public ResultPropertyDetailsDTO()
	{
		super();
	}
	

	
	/**
	 * Returns the addressAdditionalText.
	 * @return String
	 */
	public String getAddressAdditionalText()
	{
		return _addressAdditionalText;
	}

	/**
	 * Returns the addressBuildingNumber.
	 * @return String
	 */
	public String getAddressBuildingNumber()
	{
		return _addressBuildingNumber;
	}

	/**
	 * Returns the addressCountryName.
	 * @return String
	 */
	public String getAddressCountryName()
	{
		return _addressCountryName;
	}

	/**
	 * Returns the addressMunicipality.
	 * @return String
	 */
	public String getAddressMunicipality()
	{
		return _addressMunicipality;
	}

	/**
	 * Returns the addressPOBox.
	 * @return String
	 */
	public String getAddressPOBox()
	{
		return _addressPOBox;
	}

	/**
	 * Returns the addressPostCode.
	 * @return String
	 */
	public String getAddressPostCode()
	{
		return _addressPostCode;
	}

	/**
	 * Returns the addressRegion.
	 * @return String
	 */
	public String getAddressRegion()
	{
		return _addressRegion;
	}

	/**
	 * Returns the addressStreetName.
	 * @return String
	 */
	public String getAddressStreetName()
	{
		return _addressStreetName;
	}

	/**
	 * Returns the addressUnitNumber.
	 * @return String
	 */
	public String getAddressUnitNumber()
	{
		return _addressUnitNumber;
	}

	/**
	 * Returns the id.
	 * @return int
	 */
	public int getId()
	{
		return _id;
	}

	/**
	 * Returns the pictureURL.
	 * @return String
	 */
	public String getPictureURL()
	{
		return _pictureURL;
	}

	/**
	 * Returns the price.
	 * @return double
	 */
	public double getPrice()
	{
		return _price;
	}

	/**
	 * Returns the statusDescription.
	 * @return String
	 */
	public String getStatusDescription()
	{
		return _statusDescription;
	}

	/**
	 * Returns the typeDescription.
	 * @return String
	 */
	public String getTypeDescription()
	{
		return _typeDescription;
	}

	/**
	 * Returns the userName.
	 * @return String
	 */
	public String getUserName()
	{
		return _userName;
	}

	/**
	 * Sets the addressAdditionalText.
	 * @param addressAdditionalText The addressAdditionalText to set
	 */
	public void setAddressAdditionalText(String addressAdditionalText)
	{
		_addressAdditionalText = addressAdditionalText;
	}

	/**
	 * Sets the addressBuildingNumber.
	 * @param addressBuildingNumber The addressBuildingNumber to set
	 */
	public void setAddressBuildingNumber(String addressBuildingNumber)
	{
		_addressBuildingNumber = addressBuildingNumber;
	}

	/**
	 * Sets the addressCountryName.
	 * @param addressCountryName The addressCountryName to set
	 */
	public void setAddressCountryName(String addressCountryName)
	{
		_addressCountryName = addressCountryName;
	}

	/**
	 * Sets the addressMunicipality.
	 * @param addressMunicipality The addressMunicipality to set
	 */
	public void setAddressMunicipality(String addressMunicipality)
	{
		_addressMunicipality = addressMunicipality;
	}

	/**
	 * Sets the addressPOBox.
	 * @param addressPOBox The addressPOBox to set
	 */
	public void setAddressPOBox(String addressPOBox)
	{
		_addressPOBox = addressPOBox;
	}

	/**
	 * Sets the addressPostCode.
	 * @param addressPostCode The addressPostCode to set
	 */
	public void setAddressPostCode(String addressPostCode)
	{
		_addressPostCode = addressPostCode;
	}

	/**
	 * Sets the addressRegion.
	 * @param addressRegion The addressRegion to set
	 */
	public void setAddressRegion(String addressRegion)
	{
		_addressRegion = addressRegion;
	}

	/**
	 * Sets the addressStreetName.
	 * @param addressStreetName The addressStreetName to set
	 */
	public void setAddressStreetName(String addressStreetName)
	{
		_addressStreetName = addressStreetName;
	}

	/**
	 * Sets the addressUnitNumber.
	 * @param addressUnitNumber The addressUnitNumber to set
	 */
	public void setAddressUnitNumber(String addressUnitNumber)
	{
		_addressUnitNumber = addressUnitNumber;
	}

	/**
	 * Sets the id.
	 * @param id The id to set
	 */
	public void setId(int id)
	{
		_id = id;
	}

	/**
	 * Sets the pictureURL.
	 * @param pictureURL The pictureURL to set
	 */
	public void setPictureURL(String pictureURL)
	{
		_pictureURL = pictureURL;
	}

	/**
	 * Sets the price.
	 * @param price The price to set
	 */
	public void setPrice(double price)
	{
		_price = price;
	}

	/**
	 * Sets the statusDescription.
	 * @param statusDescription The statusDescription to set
	 */
	public void setStatusDescription(String statusDescription)
	{
		_statusDescription = statusDescription;
	}

	/**
	 * Sets the typeDescription.
	 * @param typeDescription The typeDescription to set
	 */
	public void setTypeDescription(String typeDescription)
	{
		_typeDescription = typeDescription;
	}

	/**
	 * Sets the userName.
	 * @param userName The userName to set
	 */
	public void setUserName(String userName)
	{
		_userName = userName;
	}

	/**
	 * Returns the countryName.
	 * @return String
	 */
	public String getCountryName()
	{
		return _countryName;
	}

	/**
	 * Sets the countryName.
	 * @param countryName The countryName to set
	 */
	public void setCountryName(String countryName)
	{
		_countryName = countryName;
	}

	/**
	 * Returns the propertyFeatures.
	 * @return Vector
	 */
	public Vector getPropertyFeatures()
	{
		return _propertyFeatures;
	}

	/**
	 * Sets the propertyFeatures.
	 * @param propertyFeatures The propertyFeatures to set
	 */
	public void setPropertyFeatures(Vector propertyFeatures)
	{
		_propertyFeatures = propertyFeatures;
	}

	/**
	 * Returns the firstName.
	 * @return String
	 */
	public String getFirstName()
	{
		return _firstName;
	}

	/**
	 * Returns the lastName.
	 * @return String
	 */
	public String getLastName()
	{
		return _lastName;
	}

	/**
	 * Sets the firstName.
	 * @param firstName The firstName to set
	 */
	public void setFirstName(String firstName)
	{
		_firstName = firstName;
	}

	/**
	 * Sets the lastName.
	 * @param lastName The lastName to set
	 */
	public void setLastName(String lastName)
	{
		_lastName = lastName;
	}

    private static final long serialVersionUID = 7568629136804505699L;

}
