/*
 * Created on Nov 7, 2004
 *
 */
package com.ibm.itso.sal404.referencedata.datahelper;

import java.sql.SQLException;
import java.util.ArrayList;

import org.apache.log4j.Logger;

import com.ibm.itso.sal404.common.exception.ApplicationException;
import com.ibm.itso.sal404.propertycatalog.dao.GetCountryCodeDAO;
import com.ibm.itso.sal404.propertycatalog.dao.GetCountryCodeDAORow;
import com.ibm.itso.sal404.propertycatalog.dao.GetPropertyStatusDAO;
import com.ibm.itso.sal404.propertycatalog.dao.GetPropertyStatusDAORow;
import com.ibm.itso.sal404.propertycatalog.dao.GetPropertyTypesDAO;
import com.ibm.itso.sal404.propertycatalog.dao.GetPropertyTypesDAORow;
import com.ibm.itso.sal404.propertycatalog.dto.CountryCodeDTO;
import com.ibm.itso.sal404.propertycatalog.dto.PropertyStatusDTO;
import com.ibm.itso.sal404.propertycatalog.dto.ResultPropertyTypeDTO;
import com.ibm.itso.sal404.user.dto.UserRoleDTO;

/**
 * @author grove
 *
 */
public class ReferenceDataHelper {
	// Configure Log4J Logger
	private static Logger logger = Logger.getLogger(ReferenceDataHelper.class);
		
	// ****
	// ****
	// **** Functions
	// ****
	// ****

	/**
	 * 
	 */
	public ArrayList getCountryCode() throws ApplicationException
	{
		logger.info("ENTRY: getCountryCode");
		ArrayList arrayCountryCode = new ArrayList();
		try
		{
			GetCountryCodeDAO getCountryCodeDAO = new GetCountryCodeDAO();
			getCountryCodeDAO.execute();
			GetCountryCodeDAORow[] getCountryCodeDAORow =
				getCountryCodeDAO.getRows();
			ResultPropertyTypeDTO propertyTypeDTO = null;
			for (int i = 0; i < getCountryCodeDAO.getRows().length; i++)
			{
				CountryCodeDTO countryCodeDTO = new CountryCodeDTO();
				Integer countryCodeId =
					(Integer) getCountryCodeDAORow[i].getCNTRY_CNTRY_ID();
				countryCodeDTO.setId(countryCodeId.intValue());
				countryCodeDTO.setCode(
					(String) getCountryCodeDAORow[i].getCNTRY_CNTRY_CD());
				countryCodeDTO.setName(
					(String) getCountryCodeDAORow[i].getCNTRY_CNTRY_NAME());
				arrayCountryCode.add(countryCodeDTO);
			}
		}
		catch (SQLException e)
		{
			logger.error(
				"Error when executing get country code" + e.getMessage());
			ApplicationException applicationException =
				new ApplicationException();
			applicationException.setStrutsMessage(
				"prop.error.propertycountrycodes.dberror");
			throw applicationException;
		}
		catch (Exception e)
		{
			ApplicationException applicationException =
				new ApplicationException();
			applicationException.setStrutsMessage("prop.error.general.failure");
			throw applicationException;
		}
		logger.info("EXIT:  getCountryCode");
		return arrayCountryCode;
	}
	
	/**
	 * 
	 * @return
	 * @throws ApplicationException
	 */
	public ArrayList getPropertyStatus() throws ApplicationException
	{
		ArrayList arrayPropertyStatus = new ArrayList();
		try
		{
			logger.info("ENTRY: getPropertyStatus");
			GetPropertyStatusDAO getPropertyStatusDAO =
				new GetPropertyStatusDAO();
			getPropertyStatusDAO.execute();
			GetPropertyStatusDAORow[] getPropertyStatusDAORow =
				getPropertyStatusDAO.getRows();
			for (int i = 0; i < getPropertyStatusDAO.getRows().length; i++)
			{
				PropertyStatusDTO propertyStatusDTO = new PropertyStatusDTO();
				Integer propertyStatusId =
					(Integer) getPropertyStatusDAORow[i]
						.getPROP_STS_PROP_STS_ID();
				propertyStatusDTO.setId(propertyStatusId.intValue());
				propertyStatusDTO.setDescription(
					(String) getPropertyStatusDAORow[i]
						.getPROP_STS_PROP_STS_DESC());
				arrayPropertyStatus.add(propertyStatusDTO);
			}
		}
		catch (SQLException e)
		{
			logger.error(
				"Error when executing get country code" + e.getMessage());
			ApplicationException applicationException =
				new ApplicationException();
			applicationException.setStrutsMessage(
				"prop.error.propertystatus.dberror");
			throw applicationException;
		}
		catch (Exception e)
		{
			ApplicationException applicationException =
				new ApplicationException();
			applicationException.setStrutsMessage("prop.error.general.failure");
			throw applicationException;
		}
		logger.info("EXIT:  getPropertyStatus");
		return arrayPropertyStatus;
	}
	
	/**
	 * 
	 * @return
	 * @throws ApplicationException
	 */
	public ArrayList getPropertyTypes() throws ApplicationException
	{
		logger.info("ENTRY: getPropertyTypes");
		ArrayList arrayPropertyTypes = null;
		try
		{
			GetPropertyTypesDAO getPropertyTypesDAO = new GetPropertyTypesDAO();
			getPropertyTypesDAO.execute();
			GetPropertyTypesDAORow[] getPropertyTypesDAORow =
				getPropertyTypesDAO.getRows();
			ResultPropertyTypeDTO propertyTypeDTO = null;
			arrayPropertyTypes =
				new ArrayList(getPropertyTypesDAO.getRows().length);
			for (int i = 0; i < getPropertyTypesDAO.getRows().length; i++)
			{
				propertyTypeDTO = new ResultPropertyTypeDTO();
				Integer propertyTypeId =
					(Integer) getPropertyTypesDAORow[i]
						.getPROP_TYPE_PROP_TYPE_ID();
				propertyTypeDTO.setId(propertyTypeId.intValue());
				propertyTypeDTO.setDescription(
					(String) getPropertyTypesDAORow[i]
						.getPROP_TYPE_PROP_TYPE_DESC());
				arrayPropertyTypes.add(propertyTypeDTO);
			}
		}
		catch (SQLException e)
		{
			logger.error(
				"Error when executing get property types" + e.getMessage());
			ApplicationException applicationException =
				new ApplicationException();
			applicationException.setStrutsMessage(
				"prop.error.propertytypes.dberror");
			applicationException.setSeverityLevel(
				ApplicationException.FATAL_ERROR);
			throw applicationException;
		}
		catch (Exception e)
		{
			ApplicationException applicationException =
				new ApplicationException();
			applicationException.setStrutsMessage("prop.error.general.failure");
			applicationException.setSeverityLevel(
				ApplicationException.FATAL_ERROR);
			throw applicationException;
		}
		logger.info("EXIT:  getPropertyTypes");
		return arrayPropertyTypes;
	}	

	/**
	 * 
	 * @return
	 * @throws ApplicationException
	 */
	public ArrayList getUserRoles() throws ApplicationException
	{
		logger.info("ENTRY: getUserRoles");
		ArrayList arrayUserRoles = new ArrayList(3);

		arrayUserRoles.add(new UserRoleDTO(1,"Administrators"));
		arrayUserRoles.add(new UserRoleDTO(2,"Customers"));
		arrayUserRoles.add(new UserRoleDTO(3,"Agents"));
		
		logger.info("EXIT:  getUserRoles");
		return arrayUserRoles;
	}	
}
