package com.ibm.itso.sal404.reporting.dao;
import java.sql.*;
import com.ibm.db.beans.*;
/**
 * This class sets the DBSelect property values. It also provides 
 * methods that execute your SQL statement, return 
 * a DBSelect reference, and return an array of objects  
 * representing the rows in the result set.
 * Generated:  15-May-03 20:51:00
 */
public class ReportPropertyForAgentDAO
{
	private DBSelect select;
	/**
	 * Constructor for a DBSelect class.
	 */
	public ReportPropertyForAgentDAO()
	{
		super();
		initializer();
	}
	/**
	 * Creates a DBSelect instance and initializes its properties.
	 */
	protected void initializer()
	{
		select = new DBSelect();
		try
		{
			select.setDataSourceName("jdbc/sal404");
			select.setCommand(
				"SELECT PROP.PROP_ID, PROP_TYPE.PROP_TYPE_DESC, PROP_STS.PROP_STS_DESC, CNTRY.CNTRY_NAME, PROP.PROP_ADDR_POST_CD, PROP.PROP_ADDR_RGN, PROP.PROP_ADDR_MUNI, PROP.PROP_ADDR_STRT_NAM, PROP.PROP_ADDR_UNIT_NUM, PROP.PROP_ADDR_PO_BOX, PROP.PROP_ADDR_BLDG_NUM, PROP.PROP_ADDR_ADDL_TEX, PROP.PROP_PRICE, PROP.PROP_PIC_URL, PROP.PROP_CRD_ON, (SELECT COUNT(*) FROM INT_LIST_ITM WHERE PROP.PROP_ID=INT_LIST_ITM.PROP_ID) AS COUNT FROM DB2ADMIN.PROP_TYPE AS PROP_TYPE RIGHT OUTER JOIN DB2ADMIN.PROP_STS AS PROP_STS RIGHT OUTER JOIN DB2ADMIN.CNTRY AS CNTRY RIGHT OUTER JOIN DB2ADMIN.PROP AS PROP ON CNTRY.CNTRY_CD = PROP.PROP_ADDR_CNTRY_CD ON PROP_STS.PROP_STS_ID = PROP.PROP_STATUS_ID ON PROP_TYPE.PROP_TYPE_ID =PROP.PROP_TYPE_ID INNER JOIN DB2ADMIN.USR AS USR ON USR.USR_ID = PROP.USR_ID  WHERE PROP.USR_ID = :agentId  ORDER BY COUNT DESC");
			DBParameterMetaData parmMetaData = select.getParameterMetaData();
			parmMetaData.setParameter(
				1,
				"agentId",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.INTEGER,
				Integer.class);
		}
		catch (SQLException ex)
		{
			ex.printStackTrace();
		}
	}
	/**
	 * Executes the SQL statement.
	 */
	public void execute(Integer agentId) throws SQLException
	{
		try
		{
			select.setParameter("agentId", agentId);
			select.execute();
		}
		// Free resources of select object. 
		finally
		{
			select.close();
		}
	}
	/**
	 * Returns a DBSelect reference.
	 */
	public DBSelect getDBSelect()
	{
		return select;
	}
	/**
	 * Returns an array of objects representing the rows in the result set.
	 */
	public ReportPropertyForAgentDAORow[] getRows()
	{
		ReportPropertyForAgentDAORow[] rows =
			new ReportPropertyForAgentDAORow[select.getRowCount()];
		for (int i = 0; i <= select.getRowCount() - 1; i++)
		{
			rows[i] = new ReportPropertyForAgentDAORow(select, i + 1);
		}
		return rows;
	}
}