package com.ibm.itso.sal404.reporting.dao;
import java.sql.*;
import com.ibm.db.beans.*;
/**
 * This class sets the DBSelect property values. It also provides 
 * methods that execute your SQL statement, return 
 * a DBSelect reference, and return an array of objects  
 * representing the rows in the result set.
 * Generated:  15-May-03 20:04:16
 */
public class ReportUserForPropertyDAO
{
	private DBSelect select;
	/**
	 * Constructor for a DBSelect class.
	 */
	public ReportUserForPropertyDAO()
	{
		super();
		initializer();
	}
	/**
	 * Creates a DBSelect instance and initializes its properties.
	 */
	protected void initializer()
	{
		select = new DBSelect();
		try
		{
			select.setDataSourceName("jdbc/sal404");
			select.setCommand(
				"SELECT DB2ADMIN.USR.USR_FIRST_NAME, DB2ADMIN.USR.USR_LAST_NAME, DB2ADMIN.USR.USR_EMAIL_ADDR, DB2ADMIN.USR.USR_WEB_URL, DB2ADMIN.USR.USR_PHN_NUM, DB2ADMIN.USR.USR_ACTIVE, DB2ADMIN.INT_LIST_ITM.INT_LIST_ITM_EMAIL, DB2ADMIN.INT_LIST_ITM.INT_LIST_ITM_BROC FROM DB2ADMIN.INT_LIST, DB2ADMIN.USR, DB2ADMIN.INT_LIST_ITM WHERE DB2ADMIN.INT_LIST.USR_ID = DB2ADMIN.USR.USR_ID AND DB2ADMIN.INT_LIST.INT_LIST_ID = DB2ADMIN.INT_LIST_ITM.INT_LIST_ID AND DB2ADMIN.INT_LIST_ITM.PROP_ID = :propertyId");
			DBParameterMetaData parmMetaData = select.getParameterMetaData();
			parmMetaData.setParameter(
				1,
				"propertyId",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.INTEGER,
				Integer.class);
		}
		catch (SQLException ex)
		{
			ex.printStackTrace();
		}
	}
	/**
	 * Executes the SQL statement.
	 */
	public void execute(Integer propertyId) throws SQLException
	{
		try
		{
			select.setParameter("propertyId", propertyId);
			select.execute();
		}
		// Free resources of select object. 
		finally
		{
			select.close();
		}
	}
	/**
	 * Returns a DBSelect reference.
	 */
	public DBSelect getDBSelect()
	{
		return select;
	}
	/**
	 * Returns an array of objects representing the rows in the result set.
	 */
	public ReportUserForPropertyDAORow[] getRows()
	{
		ReportUserForPropertyDAORow[] rows =
			new ReportUserForPropertyDAORow[select.getRowCount()];
		for (int i = 0; i <= select.getRowCount() - 1; i++)
		{
			rows[i] = new ReportUserForPropertyDAORow(select, i + 1);
		}
		return rows;
	}
}