package com.ibm.itso.sal404.reporting.dto;

import java.util.Calendar;
import java.util.Vector;

import com.ibm.itso.sal404.common.base.DataTransferObjectIf;


/**
 * 
 * sal404 Realty sample application
 * 
 * @component	Reporting component
 * @layer		Domain layer
 * 
 * This class is a DataTransferObject that encapsulates information
 * about a report generated by the application.
 * 
 * @author 		Stelios Psarras, Cyantific.net Ltd
 * @created		14 May 2003		
 * @version		1.0.0 / @14-May-03	
 *
 * @see		 	PropertyDetailsReportItemDTO
 * 				UserDetailsReportItemDTO
 * 				ReportingManager
 * 
 */
public class ReportDTO implements DataTransferObjectIf
{
	private Calendar	_date;
	private String		_description;
	private Vector		_reportItems;
	
	
	/**
	 * Constructor for Report.
	 */
	public ReportDTO()
	{
		super();
	}
	
	
	/**
	 * Returns the date.
	 * @return Calendar
	 */
	public Calendar getDate()
	{
		return _date;
	}

	/**
	 * Returns the description.
	 * @return String
	 */
	public String getDescription()
	{
		return _description;
	}

	/**
	 * Returns the reportItems.
	 * @return Vector
	 */
	public Vector getReportItems()
	{
		return _reportItems;
	}

	/**
	 * Sets the date.
	 * @param date The date to set
	 */
	public void setDate(Calendar date)
	{
		_date = date;
	}

	/**
	 * Sets the description.
	 * @param description The description to set
	 */
	public void setDescription(String description)
	{
		_description = description;
	}

	/**
	 * Sets the reportItems.
	 * @param reportItems The reportItems to set
	 */
	public void setReportItems(Vector reportItems)
	{
		_reportItems = reportItems;
	}

    private static final long serialVersionUID = 8920295183791233834L;

}
