package com.ibm.itso.sal404.reporting.dto;

import com.ibm.itso.sal404.common.base.DataTransferObjectIf;


/**
 * 
 * sal404 Realty sample application
 * 
 * @component	Reporting component
 * @layer		Domain layer
 * 
 * This class is a DataTransferObject that encapsulates information
 * about a user and his interest in a particular property
 * 
 * @author 		Stelios Psarras, Cyantific.net Ltd
 * @created		14 May 2003		
 * @version		1.0.0 / @14-May-03	
 *
 * @see		 	ReportUserForPropertySQL
 * 				ReportingManager
 * 
 */
public class UserDetailsReportItemDTO implements DataTransferObjectIf
{
	private String	_firstName;
	private String	_lastName;
	private String	_emailAddress;
	private String	_webURL;
	private String	_phoneNumber;
	private boolean	_active;
	private boolean	_emailRequested;
	private boolean _brochureRequested;
	
	
	/**
	 * Constructor for UserDetailsReportItemDTO.
	 */
	public UserDetailsReportItemDTO()
	{
		super();
	}
	/**
	 * Returns the active.
	 * @return boolean
	 */
	public boolean isActive()
	{
		return _active;
	}

	/**
	 * Returns the brochureRequested.
	 * @return boolean
	 */
	public boolean isBrochureRequested()
	{
		return _brochureRequested;
	}

	/**
	 * Returns the emailAddress.
	 * @return String
	 */
	public String getEmailAddress()
	{
		return _emailAddress;
	}

	/**
	 * Returns the emailRequested.
	 * @return boolean
	 */
	public boolean isEmailRequested()
	{
		return _emailRequested;
	}

	/**
	 * Returns the firstName.
	 * @return String
	 */
	public String getFirstName()
	{
		return _firstName;
	}

	/**
	 * Returns the lastName.
	 * @return String
	 */
	public String getLastName()
	{
		return _lastName;
	}

	/**
	 * Returns the phoneNumber.
	 * @return String
	 */
	public String getPhoneNumber()
	{
		return _phoneNumber;
	}

	/**
	 * Returns the webURL.
	 * @return String
	 */
	public String getWebURL()
	{
		return _webURL;
	}

	/**
	 * Sets the active.
	 * @param active The active to set
	 */
	public void setActive(boolean active)
	{
		_active = active;
	}

	/**
	 * Sets the brochureRequested.
	 * @param brochureRequested The brochureRequested to set
	 */
	public void setBrochureRequested(boolean brochureRequested)
	{
		_brochureRequested = brochureRequested;
	}

	/**
	 * Sets the emailAddress.
	 * @param emailAddress The emailAddress to set
	 */
	public void setEmailAddress(String emailAddress)
	{
		_emailAddress = emailAddress;
	}

	/**
	 * Sets the emailRequested.
	 * @param emailRequested The emailRequested to set
	 */
	public void setEmailRequested(boolean emailRequested)
	{
		_emailRequested = emailRequested;
	}

	/**
	 * Sets the firstName.
	 * @param firstName The firstName to set
	 */
	public void setFirstName(String firstName)
	{
		_firstName = firstName;
	}

	/**
	 * Sets the lastName.
	 * @param lastName The lastName to set
	 */
	public void setLastName(String lastName)
	{
		_lastName = lastName;
	}

	/**
	 * Sets the phoneNumber.
	 * @param phoneNumber The phoneNumber to set
	 */
	public void setPhoneNumber(String phoneNumber)
	{
		_phoneNumber = phoneNumber;
	}

	/**
	 * Sets the webURL.
	 * @param webURL The webURL to set
	 */
	public void setWebURL(String webURL)
	{
		_webURL = webURL;
	}

    private static final long serialVersionUID = 5456688836907911381L;

}
