package com.ibm.itso.sal404.user.dao;
import java.sql.*;
import com.ibm.db.beans.*;
import com.ibm.itso.sal404.common.util.AppProperties;

// Import Log4J Logger
import org.apache.log4j.Logger;

public class CreateUserAddrDAO
{
	// Configure Log4J Logger
	private static Logger logger = Logger.getLogger(CreateUserAddrDAO.class);	
	
	private DBModify modify;

	/**
	 * Constructor for a DBModify class.
	 */
	public CreateUserAddrDAO()
	{
		super();
		initializer();
	}

	/**
	 * Creates a DBModify instance and initializes its properties.
	 */
	protected void initializer()
	{
		modify = new DBModify();
		try
		{
			modify.setDataSourceName(AppProperties.getInstance().getProperty("dataSourceJNDIName"));
			modify.setCommand(
				"INSERT INTO DB2ADMIN.USR_ADDR ( USR_ID, USR_ADDR_NAME, USR_ADDR_CNTRY_CD, USR_ADDR_POST_CD, USR_ADDR_RGN, USR_ADDR_MUNI, USR_ADDR_STRT_NAME, USR_ADDR_BLDG_NUM, USR_ADDR_UNIT_NUM, USR_ADDR_PO_BOX, USR_ADDR_ADDL_TEXT) VALUES ( :usrID, :name, :countryCode, :postCode, :region, :muni, :streetName, :buildingNum, :unitNum, :poBox, :addlText)");
			DBParameterMetaData parmMetaData = modify.getParameterMetaData();
			parmMetaData.setParameter(
				1,
				"usrID",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.INTEGER,
				Integer.class);
			parmMetaData.setParameter(
				2,
				"name",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				3,
				"countryCode",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.CHAR,
				String.class);
			parmMetaData.setParameter(
				4,
				"postCode",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				5,
				"region",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				6,
				"muni",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				7,
				"streetName",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				8,
				"buildingNum",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				9,
				"unitNum",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				10,
				"poBox",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				11,
				"addlText",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
		}
		catch (SQLException ex)
		{
			ex.printStackTrace();
		}
	}

	/**
	 * Executes the SQL statement.
	 */
	public void execute(
		Integer usrID,
		String name,
		String countryCode,
		String postCode,
		String region,
		String muni,
		String streetName,
		String buildingNum,
		String unitNum,
		String poBox,
		String addlText)
		throws SQLException
	{
		try
		{
			modify.setParameter("usrID", usrID);
			modify.setParameter("name", name);
			modify.setParameter("countryCode", countryCode);
			modify.setParameter("postCode", postCode);
			modify.setParameter("region", region);
			modify.setParameter("muni", muni);
			modify.setParameter("streetName", streetName);
			modify.setParameter("buildingNum", buildingNum);
			modify.setParameter("unitNum", unitNum);
			modify.setParameter("poBox", poBox);
			modify.setParameter("addlText", addlText);
			modify.execute();
		}

		// Free resources of modify object. 
		finally
		{
			modify.close();
		}
	}

	/**
	 * Returns a DBModify reference.
	 */
	public DBModify getDBModify()
	{
		return modify;
	}
}