package com.ibm.itso.sal404.user.dao;
import java.sql.*;
import com.ibm.db.beans.*;
import com.ibm.itso.sal404.common.util.AppProperties;

// Import Log4J Logger
import org.apache.log4j.Logger;


public class CreateUserDAO
{
	// Configure Log4J Logger
	private static Logger logger = Logger.getLogger(CreateUserDAO.class);
	
	private DBModify modify;

	/**
	 * Constructor for a DBModify class.
	 */
	public CreateUserDAO()
	{
		super();
		initializer();
	}

	/**
	 * Creates a DBModify instance and initializes its properties.
	 */
	protected void initializer()
	{
		modify = new DBModify();
		try
		{
			modify.setDataSourceName(AppProperties.getInstance().getProperty("dataSourceJNDIName"));
			modify.setCommand(
				"INSERT INTO DB2ADMIN.USR ( USR_USERNAME, USR_PASSWORD, USR_ROLE, USR_FIRST_NAME, USR_LAST_NAME, USR_EMAIL_ADDR, USR_WEB_URL, USR_PHN_NUM, USR_ACTIVE ) VALUES ( :userName, :userPassword, :userRole, :firstName, :lastName, :emailAddr, :webURL, :phoneNum, :active )");
			DBParameterMetaData parmMetaData = modify.getParameterMetaData();
			parmMetaData.setParameter(
				1,
				"userName",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.CHAR,
				String.class);
			parmMetaData.setParameter(
				2,
				"userPassword",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				3,
				"userRole",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				4,
				"firstName",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				5,
				"lastName",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				6,
				"emailAddr",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				7,
				"webURL",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				8,
				"phoneNum",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				9,
				"active",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.CHAR,
				String.class);
		}
		catch (SQLException ex)
		{
			ex.printStackTrace();
		}
	}

	/**
	 * Executes the SQL statement.
	 */
	public void execute(
		String userName,
		String userPassword,
		String userRole,
		String firstName,
		String lastName,
		String emailAddr,
		String webURL,
		String phoneNum,
		String active)
		throws SQLException
	{
		try
		{
			modify.setParameter("userName", userName);
			modify.setParameter("userPassword", userPassword);
			modify.setParameter("userRole", userRole);
			modify.setParameter("firstName", firstName);
			modify.setParameter("lastName", lastName);
			modify.setParameter("emailAddr", emailAddr);
			modify.setParameter("webURL", webURL);
			modify.setParameter("phoneNum", phoneNum);
			modify.setParameter("active", active);
			modify.execute();
		}

		// Free resources of modify object. 
		finally
		{
			modify.close();
		}
	}

	/**
	 * Returns a DBModify reference.
	 */
	public DBModify getDBModify()
	{
		return modify;
	}
}