package com.ibm.itso.sal404.user.dao;
import java.sql.*;
import com.ibm.db.beans.*;
import com.ibm.itso.sal404.common.util.AppProperties;

// Import Log4J Logger
import org.apache.log4j.Logger;


public class DeleteUserDAO
{
	// Configure Log4J Logger
	private static Logger logger = Logger.getLogger(DeleteUserDAO.class);
	
	private DBModify modify;

	/**
	 * Constructor for a DBModify class.
	 */
	public DeleteUserDAO()
	{
		super();
		initializer();
	}

	/**
	 * Creates a DBModify instance and initializes its properties.
	 */
	protected void initializer()
	{
		modify = new DBModify();
		try
		{
			modify.setDataSourceName(AppProperties.getInstance().getProperty("dataSourceJNDIName"));
			modify.setCommand(
				"DELETE FROM DB2ADMIN.USR WHERE DB2ADMIN.USR.USR_ID = :id");
			DBParameterMetaData parmMetaData = modify.getParameterMetaData();
			parmMetaData.setParameter(
				1,
				"id",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.INTEGER,
				Integer.class);
		}
		catch (SQLException ex)
		{
			ex.printStackTrace();
			logger.error(ex.getMessage());
		}
	}

	/**
	 * Executes the SQL statement.
	 */
	public void execute(
		Integer userId)
		throws SQLException
	{
		try
		{
			modify.setParameter("id", userId);
			modify.execute();
		}

		// Free resources of modify object. 
		finally
		{
			modify.close();
		}
	}

	/**
	 * Returns a DBModify reference.
	 */
	public DBModify getDBModify()
	{
		return modify;
	}
}