package com.ibm.itso.sal404.user.dao;
import java.sql.*;
import com.ibm.db.beans.*;

/**
 * This class sets the DBSelect property values. It also provides 
 * methods that execute your SQL statement, return 
 * a DBSelect reference, and return an array of objects  
 * representing the rows in the result set.
 * Generated:  Jul 18, 2003 5:09:21 PM
 */

public class GetIdForUserDAO
{
	private DBSelect select;

	/**
	 * Constructor for a DBSelect class.
	 */
	public GetIdForUserDAO()
	{
		super();
		initializer();
	}

	/**
	 * Creates a DBSelect instance and initializes its properties.
	 */
	protected void initializer()
	{
		select = new DBSelect();
		try
		{
			select.setDataSourceName("jdbc/sal404");
			select.setCommand(
				"SELECT DB2ADMIN.USR.USR_ID FROM DB2ADMIN.USR WHERE DB2ADMIN.USR.USR_USERNAME = :userName");
			DBParameterMetaData parmMetaData = select.getParameterMetaData();
			parmMetaData.setParameter(
				1,
				"userName",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.CHAR,
				String.class);
		}
		catch (SQLException ex)
		{
			ex.printStackTrace();
		}
	}

	/**
	 * Executes the SQL statement.
	 */
	public void execute(String userName) throws SQLException
	{
		try
		{
			select.setUsername("db2admin");
			select.setPassword("daboss1");
			select.setParameter("userName", userName);
			select.execute();
		}

		// Free resources of select object. 
		finally
		{
			select.close();
		}
	}

	/**
	 * Returns a DBSelect reference.
	 */
	public DBSelect getDBSelect()
	{
		return select;
	}

	/**
	 * Returns an array of objects representing the rows in the result set.
	 */
	public GetIdForUserDAORow[] getRows()
	{
		GetIdForUserDAORow[] rows =
			new GetIdForUserDAORow[select.getRowCount()];
		for (int i = 0; i <= select.getRowCount() - 1; i++)
		{
			rows[i] = new GetIdForUserDAORow(select, i + 1);
		}
		return rows;
	}
}