package com.ibm.itso.sal404.user.dao;
import java.sql.*;
import com.ibm.db.beans.*;
import com.ibm.itso.sal404.common.util.AppProperties;

/**
 * This class sets the DBSelect property values. It also provides 
 * methods that execute your SQL statement, return 
 * a DBSelect reference, and return an array of objects  
 * representing the rows in the result set.
 * Generated:  Jul 23, 2003 6:08:36 PM
 */

public class GetUsersInRoleDAO
{
	private DBSelect select;

	/**
	 * Constructor for a DBSelect class.
	 */
	public GetUsersInRoleDAO()
	{
		super();
		initializer();
	}

	/**
	 * Creates a DBSelect instance and initializes its properties.
	 */
	protected void initializer()
	{
		select = new DBSelect();
		try
		{
			select.setDataSourceName(AppProperties.getInstance().getProperty("dataSourceJNDIName"));
			select.setCommand(
				"SELECT DB2ADMIN.USR.USR_ID, DB2ADMIN.USR.USR_USERNAME, DB2ADMIN.USR.USR_ROLE, DB2ADMIN.USR.USR_FIRST_NAME, DB2ADMIN.USR.USR_LAST_NAME, DB2ADMIN.USR.USR_ACTIVE FROM DB2ADMIN.USR WHERE DB2ADMIN.USR.USR_ROLE = :roleName");
			DBParameterMetaData parmMetaData = select.getParameterMetaData();
			parmMetaData.setParameter(
				1,
				"roleName",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
		}
		catch (SQLException ex)
		{
			ex.printStackTrace();
		}
	}

	/**
	 * Executes the SQL statement.
	 */
	public void execute(String roleName) throws SQLException
	{
		try
		{

			select.setParameter("roleName", roleName);
			select.execute();
		}

		// Free resources of select object. 
		finally
		{
			select.close();
		}
	}

	/**
	 * Returns a DBSelect reference.
	 */
	public DBSelect getDBSelect()
	{
		return select;
	}

	/**
	 * Returns an array of objects representing the rows in the result set.
	 */
	public GetUsersInRoleDAORow[] getRows()
	{
		GetUsersInRoleDAORow[] rows =
			new GetUsersInRoleDAORow[select.getRowCount()];
		for (int i = 0; i <= select.getRowCount() - 1; i++)
		{
			rows[i] = new GetUsersInRoleDAORow(select, i + 1);
		}
		return rows;
	}
}