package com.ibm.itso.sal404.user.dao;

import java.sql.*;
import com.ibm.db.beans.*;
import com.ibm.itso.sal404.common.util.AppProperties;

/**
 * This class sets the DBModify property values. It also provides 
 * methods that execute your SQL statement and return 
 * a DBModify reference.
 * Generated:  Nov 23, 2004 9:54:07 AM
 */

public class UpdateUserAddressDAO {
    private DBModify modify;

    /**
     * Constructor for a DBModify class.
     */
    public UpdateUserAddressDAO() {
        super();
        initializer();
    }

    /**
     * Creates a DBModify instance and initializes its properties.
     */
    protected void initializer() {
        modify = new DBModify();
        try {
            modify.setDataSourceName(AppProperties.getInstance().getProperty("dataSourceJNDIName"));
            modify
                    .setCommand("UPDATE DB2ADMIN.USR_ADDR SET USR_ADDR_NAME = :addr_name, USR_ADDR_CNTRY_CD = :addr_cntry_cd, USR_ADDR_POST_CD = :addr_post_cd, USR_ADDR_RGN = :addr_rgn, USR_ADDR_MUNI = :addr_muni, USR_ADDR_STRT_NAME = :addr_strt_name, USR_ADDR_BLDG_NUM = :addr_bldg_num, USR_ADDR_UNIT_NUM = :addr_unit_num, USR_ADDR_PO_BOX = :addr_po_box, USR_ADDR_ADDL_TEXT = :addr_addl_text WHERE DB2ADMIN.USR_ADDR.USR_ADDR_ID = :addr_id");
            DBParameterMetaData parmMetaData = modify.getParameterMetaData();
            parmMetaData.setParameter(1, "addr_name",
                    java.sql.DatabaseMetaData.procedureColumnIn,
                    java.sql.Types.VARCHAR, String.class);
            parmMetaData.setParameter(2, "addr_cntry_cd",
                    java.sql.DatabaseMetaData.procedureColumnIn,
                    java.sql.Types.CHAR, String.class);
            parmMetaData.setParameter(3, "addr_post_cd",
                    java.sql.DatabaseMetaData.procedureColumnIn,
                    java.sql.Types.VARCHAR, String.class);
            parmMetaData.setParameter(4, "addr_rgn",
                    java.sql.DatabaseMetaData.procedureColumnIn,
                    java.sql.Types.VARCHAR, String.class);
            parmMetaData.setParameter(5, "addr_muni",
                    java.sql.DatabaseMetaData.procedureColumnIn,
                    java.sql.Types.VARCHAR, String.class);
            parmMetaData.setParameter(6, "addr_strt_name",
                    java.sql.DatabaseMetaData.procedureColumnIn,
                    java.sql.Types.VARCHAR, String.class);
            parmMetaData.setParameter(7, "addr_bldg_num",
                    java.sql.DatabaseMetaData.procedureColumnIn,
                    java.sql.Types.VARCHAR, String.class);
            parmMetaData.setParameter(8, "addr_unit_num",
                    java.sql.DatabaseMetaData.procedureColumnIn,
                    java.sql.Types.VARCHAR, String.class);
            parmMetaData.setParameter(9, "addr_po_box",
                    java.sql.DatabaseMetaData.procedureColumnIn,
                    java.sql.Types.VARCHAR, String.class);
            parmMetaData.setParameter(10, "addr_addl_text",
                    java.sql.DatabaseMetaData.procedureColumnIn,
                    java.sql.Types.VARCHAR, String.class);
            parmMetaData.setParameter(11, "addr_id",
                    java.sql.DatabaseMetaData.procedureColumnIn,
                    java.sql.Types.INTEGER, Integer.class);
        } catch (SQLException ex) {
            ex.printStackTrace();
        }
    }

    /**
     * Executes the SQL statement.
     */
    public void execute(String addr_name, String addr_cntry_cd,
            String addr_post_cd, String addr_rgn, String addr_muni,
            String addr_strt_name, String addr_bldg_num, String addr_unit_num,
            String addr_po_box, String addr_addl_text, Integer addr_id)
            throws SQLException {
        try {
            modify.setParameter("addr_name", addr_name);
            modify.setParameter("addr_cntry_cd", addr_cntry_cd);
            modify.setParameter("addr_post_cd", addr_post_cd);
            modify.setParameter("addr_rgn", addr_rgn);
            modify.setParameter("addr_muni", addr_muni);
            modify.setParameter("addr_strt_name", addr_strt_name);
            modify.setParameter("addr_bldg_num", addr_bldg_num);
            modify.setParameter("addr_unit_num", addr_unit_num);
            modify.setParameter("addr_po_box", addr_po_box);
            modify.setParameter("addr_addl_text", addr_addl_text);
            modify.setParameter("addr_id", addr_id);
            modify.execute();
        }

        // Free resources of modify object. 
        finally {
            modify.close();
        }
    }

    /**
     * Returns a DBModify reference.
     */
    public DBModify getDBModify() {
        return modify;
    }
}