package com.ibm.itso.sal404.user.dao;
import java.sql.*;
import com.ibm.db.beans.*;
import com.ibm.itso.sal404.common.util.AppProperties;

// Import Log4J Logger
import org.apache.log4j.Logger;

/**
 * This class sets the DBModify property values. It also provides 
 * methods that execute your SQL statement and return 
 * a DBModify reference.
 * Generated:  May 29, 2003 10:33:39 AM
 */

public class UpdateUserDetailsDAO
{
	// Configure Log4J Logger
	private static Logger logger = Logger.getLogger(CreateUserAddrDAO.class);	
	
	private DBModify modify;

	/**
	 * Constructor for a DBModify class.
	 */
	public UpdateUserDetailsDAO()
	{
		super();
		initializer();
	}

	/**
	 * Creates a DBModify instance and initializes its properties.
	 */
	protected void initializer()
	{
		modify = new DBModify();
		try
		{
			modify.setDataSourceName(AppProperties.getInstance().getProperty("dataSourceJNDIName"));
			modify.setCommand(
				"UPDATE DB2ADMIN.USR SET USR_USERNAME = :userName, USR_PASSWORD = :password, USR_ROLE = :role, USR_FIRST_NAME = :firstName, USR_LAST_NAME = :lastName, USR_EMAIL_ADDR = :emailAddr, USR_WEB_URL = :webURL, USR_PHN_NUM = :phoneNumber, USR_ACTIVE = :active WHERE DB2ADMIN.USR.USR_ID = :userID");
			DBParameterMetaData parmMetaData = modify.getParameterMetaData();
			parmMetaData.setParameter(
				1,
				"userName",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.CHAR,
				String.class);
			parmMetaData.setParameter(
				2,
				"password",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				3,
				"role",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				4,
				"firstName",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				5,
				"lastName",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				6,
				"emailAddr",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				7,
				"webURL",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				8,
				"phoneNumber",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.VARCHAR,
				String.class);
			parmMetaData.setParameter(
				9,
				"active",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.CHAR,
				String.class);
			parmMetaData.setParameter(
				10,
				"userID",
				java.sql.DatabaseMetaData.procedureColumnIn,
				java.sql.Types.INTEGER,
				Integer.class);
		}
		catch (SQLException ex)
		{
			ex.printStackTrace();
		}
	}

	/**
	 * Executes the SQL statement.
	 */
	public void execute(
		Integer id,
		String userName,
		String passWord,
		String role,
		String firstName,
		String lastName,
		String emailAddr,
		String webURL,
		String phoneNumber,
		String active)
		throws SQLException
	{
		try
		{
			if (passWord == null)
				passWord = new String("password");
			
			if (userName == null)
				userName = new String("FIXME");
			
			if (role == null)
				role = new String("Customers");
			
			if (firstName == null)
				firstName = new String("FIXME");
			
			if (lastName == null)
				lastName = new String("FIXME");
			
			modify.setParameter("userID", id);
			modify.setParameter("userName", userName);
			modify.setParameter("password", passWord);
			modify.setParameter("role", role);
			modify.setParameter("firstName", firstName);
			modify.setParameter("lastName", lastName);
			modify.setParameter("emailAddr", emailAddr);
			modify.setParameter("webURL", webURL);
			modify.setParameter("phoneNumber", phoneNumber);
			modify.setParameter("active", active);
			modify.execute();
		}

		// Free resources of modify object. 
		finally
		{
			modify.close();
		}
	}

	/**
	 * Returns a DBModify reference.
	 */
	public DBModify getDBModify()
	{
		return modify;
	}
}