package com.ibm.itso.sal404.bidding.action;

import java.lang.reflect.InvocationTargetException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.beanutils.PropertyUtils;
import org.apache.log4j.Logger;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.ibm.itso.sal404.bidding.BidManager;
import com.ibm.itso.sal404.bidding.BidSessionData;
import com.ibm.itso.sal404.bidding.dto.BidDTO;
import com.ibm.itso.sal404.bidding.form.BidForm;
import com.ibm.itso.sal404.common.exception.ApplicationException;
import com.ibm.itso.sal404.propertycatalog.dto.PropertyDTO;
import com.ibm.itso.sal404.user.UserSessionData;

/**
 * @version 1.0
 * @author
 */
public class AddBidAction extends Action

{
    // Configure Log4J Logger
    private static Logger logger = Logger.getLogger(AddBidAction.class);

    public ActionForward execute(ActionMapping mapping, ActionForm form,
            HttpServletRequest request, HttpServletResponse response)
            throws Exception
    {
        logger.info("Entry: execute");
        ActionErrors errors = new ActionErrors();
        ActionForward forward = new ActionForward(); // return value
        BidForm bidForm = (BidForm) form;
        PropertyDTO prop = (PropertyDTO) request.getSession().getAttribute(
                "propertyDTO");
        UserSessionData userSessionData = (UserSessionData) request
                .getSession().getAttribute("userSessionData");

        try
        {

            BidDTO bidDTO = populateBidDTO(form, prop, userSessionData);
            logger.info("BidDTO populated");
            addBid(request,errors,bidDTO);
            logger.info("After addBid");
//            request.setAttribute("propertyId",prop.getId().toString());
        }
        catch (Exception e)
        {

            // Report the error using the appropriate name and ID.
            errors.add("name", new ActionError("id"));

        }

        // If a message is required, save the specified key(s)
        // into the request for use by the <struts:errors> tag.

        if (!errors.isEmpty())
        {
            logger.info("Errors found");
            logger.info(errors);
            saveErrors(request, errors);
            forward = mapping.findForward("failure");
        }
        else
        {
            // Write logic determining how the user should be forwarded.
            forward = mapping.findForward("success");
        }

        // Finish with
        logger.info("Exit: execute");
        return (forward);

    }

    /**
     * 
     * @param form
     * @param prop
     * @param userSessionData
     * @return
     */
    public BidDTO populateBidDTO(ActionForm form, PropertyDTO prop,
            UserSessionData userSessionData)
    {
        logger.info("ENTRY: populateBidDTO");
        BidForm bidFormBean = (BidForm) form;
        BidDTO bidDTO = new BidDTO();
        try
        {
            PropertyUtils.copyProperties(bidDTO, bidFormBean);
        }
        catch (IllegalAccessException e1)
        {
            e1.printStackTrace();
        }
        catch (InvocationTargetException e1)
        {
            e1.printStackTrace();
        }
        catch (NoSuchMethodException e1)
        {
            e1.printStackTrace();
        }

        bidDTO.setPropertyId((prop.getId()));
        bidDTO.setBidderId(userSessionData.getLogInUser().getId());
        bidDTO.setPropertySeller(prop.getSeller());
        bidDTO.setStatus("open");
        bidDTO.setBidDate(bidFormBean.getBidDate());
        bidDTO.setBidPrice(bidFormBean.getBidPrice());

        logger.info("EXIT:  populateBidDTO");
        return bidDTO;
    }

    /**
     * 
     * @param request
     * @param errors
     * @param bidDTO
     */
    public void addBid(HttpServletRequest request, ActionErrors errors,
            BidDTO bidDTO)
    {
        BidSessionData bidSessionData = (BidSessionData) request.getSession().getAttribute("bidSessionData");

        try
        {
            bidSessionData.create(bidDTO);
            
        }
        catch (ApplicationException ae)
        {
            // Report the error using the appropriate name and ID.
            errors.add("Bid", new ActionError(ae.getStrutsMessage()));
        }
    }
}