package com.ibm.itso.sal404.bidding.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.ibm.itso.sal404.bidding.BidSessionData;
import com.ibm.itso.sal404.propertycatalog.dto.PropertyDTO;

/**
 * @version 1.0
 * @author
 */
public class ListBidsAction extends Action

{
    // Configure Log4J Logger
    private static Logger logger = Logger.getLogger(ListBidsAction.class);

    public ActionForward execute(ActionMapping mapping, ActionForm form,
            HttpServletRequest request, HttpServletResponse response)
            throws Exception
    {

        ActionErrors errors = new ActionErrors();
        ActionForward forward = new ActionForward(); // return value

        try
        {

            BidSessionData bidSessionData = (BidSessionData) request
                    .getSession().getAttribute("bidSessionData");
            bidSessionData.resetBidList();
            Integer propertyId;
            PropertyDTO prop = (PropertyDTO) request.getSession().getAttribute(
                    "propertyDTO");
            propertyId = prop.getId();
            bidSessionData.getBidList(propertyId);

        } catch (Exception e)
        {

            // Report the error using the appropriate name and ID.
            errors.add("name", new ActionError("id"));

        }

        // If a message is required, save the specified key(s)
        // into the request for use by the <struts:errors> tag.

        if (!errors.isEmpty())
        {
            saveErrors(request, errors);
            forward = mapping.findForward("failure");
        } else
        {
            forward = mapping.findForward("success");
        }

        // Finish with
        return (forward);

    }
}
