package com.ibm.itso.sal404.bidding.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.ibm.itso.sal404.bidding.BidSessionData;
import com.ibm.itso.sal404.bidding.dto.BidDTO;
import com.ibm.itso.sal404.bidding.form.ModifyBidForm;
import com.ibm.itso.sal404.propertycatalog.PropertyCatalogManager;
import com.ibm.itso.sal404.propertycatalog.dto.PropertyDTO;

/**
 * @version 1.0
 * @author
 */
public class ModifyBidAction extends Action

{
    // Configure Log4J Logger
    private static Logger logger = Logger.getLogger(ModifyBidAction.class);

    public ActionForward execute(ActionMapping mapping, ActionForm form,
            HttpServletRequest request, HttpServletResponse response)
            throws Exception
    {
        logger.info("Entry: execute");
        ActionErrors errors = new ActionErrors();
        ActionForward forward = new ActionForward(); // return value
        ModifyBidForm bidForm = (ModifyBidForm) form;

        try
        {

            BidSessionData bidSessionData = (BidSessionData)request.getSession().getAttribute("bidSessionData");
            BidDTO bidDTO = bidSessionData.getCurrent();
            bidDTO.setStatus(bidForm.getStatus());
            bidSessionData.update(bidDTO);
            if (bidDTO.getStatus().equals("accepted"))
            {
                PropertyDTO prop = (PropertyDTO) request.getSession().getAttribute(
                "propertyDTO");
                prop.setStatus(new Integer(2));
                PropertyCatalogManager propertyManager = new PropertyCatalogManager();
                propertyManager.modifyPropertyDetails(prop);
            }

        } catch (Exception e)
        {

            // Report the error using the appropriate name and ID.
            errors.add("name", new ActionError("id"));

        }

        // If a message is required, save the specified key(s)
        // into the request for use by the <struts:errors> tag.

        if (!errors.isEmpty())
        {
            saveErrors(request, errors);
            forward = mapping.findForward("failure");
        }
        // Write logic determining how the user should be forwarded.
        else
        {
            forward = mapping.findForward("success");
        }

        // Finish with
        return (forward);

    }
}
