package com.ibm.itso.sal404.bidding.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.ibm.itso.sal404.propertycatalog.PropertyCatalogManager;
import com.ibm.itso.sal404.propertycatalog.dto.PropertyDTO;

/**
 * @version 1.0
 * @author
 */
public class SetupBidAction extends Action

{
    //  Configure Log4J Logger
    private static Logger logger = Logger.getLogger(SetupBidAction.class);

    public ActionForward execute(ActionMapping mapping, ActionForm form,
            HttpServletRequest request, HttpServletResponse response)
            throws Exception
    {

        ActionErrors errors = new ActionErrors();
        ActionForward forward = new ActionForward(); // return value

        try
        {

            PropertyCatalogManager manager = new PropertyCatalogManager();
            PropertyDTO prop = manager.populatePropertyDetails(new Integer(request.getParameter("propertyId")));
            request.getSession().setAttribute("propertyDTO", prop);

        }
        catch (Exception e)
        {

            e.printStackTrace();
            // Report the error using the appropriate name and ID.
            logger.error(e.getMessage());
            errors.add("Bid", new ActionError("No property found"));

        }

        // If a message is required, save the specified key(s)
        // into the request for use by the <struts:errors> tag.

        if (!errors.isEmpty())
        {
            logger.info("errors found in setup bid");
            saveErrors(request, errors);
            forward = mapping.findForward("failure");

        }
        else
        {
            
            forward = mapping.findForward("success");

        }

        // Finish with
        return (forward);

    }
}