package com.ibm.itso.sal404.interestlist.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.ibm.itso.sal404.interestlist.InterestListManager;
import com.ibm.itso.sal404.interestlist.dto.InterestListDTO;

// Import Log4J Logger
import org.apache.log4j.Logger;

/**
 * 
 * sal404 Realty sample application
 * 
 * @component	Interest list
 * @layer		action
 * 
 * ClearInterestListAction<br>
 * This Action clears the entire interest list.<br>
 * 
 * 
 * @author 		Mark Buensalido
 * @version		1.0.0
 *
 * 
 */
public final class ClearInterestListAction extends Action
{

	/**
	 * Configures the log4j Logger.
	 * @since 1.0.0
	 */
	private static Logger logger = Logger.getLogger(ClearInterestListAction.class);

	/**
	* Constructor
	*/
	public ClearInterestListAction()
	{

		super();

	}
	public ActionForward execute(
		ActionMapping mapping,
		ActionForm form,
		HttpServletRequest request,
		HttpServletResponse response)
		throws Exception
	{

		ActionErrors errors = new ActionErrors();
		ActionForward forward = new ActionForward();
		// return value
		
		InterestListManager manager;
		InterestListDTO DTO;
		HttpSession session;

		logger.info("ENTRY:execute");

		try
		{
			session = request.getSession(false);
			logger.debug("HttpSession retrieved");
			
			DTO = (InterestListDTO)session.getAttribute("interestList");
			logger.debug("InterestListDTO retrieved");
			
			logger.debug("Manager begin");
			manager = new InterestListManager(DTO);
			DTO = manager.clear();
			logger.debug("Manager done");
			
			session.setAttribute("interestList", DTO);
			logger.debug("InterestListDTO set into session");

		}
		catch (Exception e)
		{
			
			logger.warn(e.getMessage());
			// Report the error using the appropriate name and ID.
			errors.add("name", new ActionError("id"));

		}

		// If a message is required, save the specified key(s)
		// into the request for use by the <struts:errors> tag.

		if (!errors.isEmpty())
		{
			saveErrors(request, errors);
		}
		// Write logic determining how the user should be forwarded.
		forward = mapping.findForward("success");

		logger.info("EXIT:execute");

		// Finish with
		return (forward);

	}
}
