/* $$Id: TestMessageGatewayServlet.java,v 1.4 2004/12/14 15:33:54 grove Exp $$
 * 
 * This code is part of the sample application that has been created
 * for the redbook WebSphere Application Server - Express V6
 * Developers Guide and A Development Example (SG24-6500).
 *
 * Revision History:
 *
 *   $$Log: TestMessageGatewayServlet.java,v $
 *   $Revision 1.4  2004/12/14 15:33:54  grove
 *   $refactoring
 *   $
 *   $Revision 1.1  2004/11/25 14:53:19  grovedc
 *   $week 4
 *   $
 *   $Revision 1.3  2004/11/22 17:38:06  grove
 *   $yet more refactoring
 *   $
 *   $Revision 1.2  2004/11/22 16:44:19  ansgar
 *   $added comments
 *   $$
 */
package com.ibm.itso.sal404.jms;

import java.io.IOException;
import javax.servlet.Servlet;
import javax.servlet.ServletException;
import javax.servlet.http.HttpServlet;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;

import com.ibm.itso.sal404.user.dto.UserDetailsDTO;

/**
 * Test servlet for the MessageGateway, sends a simple message over the
 * gateway.
 * 
 * 
 * <BR><BR>
 * Creation date: ${date}
 * @author ${user}
 */public class TestMessageGatewayServlet extends HttpServlet implements Servlet {

    /** log4j logger */
    private static Logger logger = Logger
            .getLogger(TestMessageGatewayServlet.class);

    /**
     * 
     * @see javax.servlet.http.HttpServlet#HttpServlet()
     */
    public TestMessageGatewayServlet() {
        super();
    }

    /**
     * 
     * @see javax.servlet.http.HttpServlet#doGet(HttpServletRequest arg0,
     *      HttpServletResponse arg1)
     */
    protected void doGet(HttpServletRequest req, HttpServletResponse response)
            throws ServletException, IOException {
        performTask(req, response);
    }

    /**
     * 
     * @see javax.servlet.http.HttpServlet#doPost(HttpServletRequest arg0,
     *      HttpServletResponse arg1)
     */
    protected void doPost(HttpServletRequest req, HttpServletResponse response)
            throws ServletException, IOException {
        performTask(req, response);
    }

    private void performTask(HttpServletRequest req,
            HttpServletResponse response) {
        logger.debug("performTask() ENTER");
        MessageGateway gateway = MessageGateway.getInstance();
        UserDetailsDTO userDetailsDTO = new UserDetailsDTO();
        userDetailsDTO.setFirstName("John");
        userDetailsDTO.setLastName("Smith");
        try {
            gateway.sendMessage(userDetailsDTO);
            response.getWriter().println("OK");
        } catch (Exception e) {
            try {
                response.getWriter().println("ERROR");
            } catch (IOException e1) {
                logger.error("performTask() error writing to servlet respone", e1);
            }
        }

        logger.debug("performTask() EXIT");
    }

}