package com.ibm.itso.sal404.listeners;

import javax.servlet.http.HttpSessionEvent;
import javax.servlet.http.HttpSessionListener;

import org.apache.log4j.Logger;

import com.ibm.itso.sal404.bidding.BidSessionData;
import com.ibm.itso.sal404.news.NewsSessionData;
import com.ibm.itso.sal404.referencedata.ReferenceSessionData;
import com.ibm.itso.sal404.user.UserSessionData;

public class Sal404SessionListener implements HttpSessionListener {
	// Configure Log4J Logger
	private static Logger logger = Logger.getLogger(Sal404SessionListener.class);

    /* (non-Java-doc)
	 * @see java.lang.Object#Object()
	 */
	public Sal404SessionListener() {
		super();
	}

	/* (non-Java-doc)
	 * @see javax.servlet.http.HttpSessionListener#sessionCreated(HttpSessionEvent arg0)
	 */
	public void sessionCreated(HttpSessionEvent arg0) {
	    logger.info("ENTRY: sessionCreated");
	    arg0.getSession().setAttribute("userSessionData", new UserSessionData());
	    arg0.getSession().setAttribute("referenceSessionData", new ReferenceSessionData());
	    arg0.getSession().setAttribute("newsSessionData", new NewsSessionData());
	    arg0.getSession().setAttribute("bidSessionData", new BidSessionData());
	    logger.info("EXIT:  sessionCreated");
	}

	/* (non-Java-doc)
	 * @see javax.servlet.http.HttpSessionListener#sessionDestroyed(HttpSessionEvent arg0)
	 */
	public void sessionDestroyed(HttpSessionEvent arg0) {
	    logger.info("ENTRY: sessionDestroyed");
	    // can't redirect to expired from here ?????
	    logger.info("EXIT:  sessionDestroyed");
	}

}