package com.ibm.itso.sal404.news.action;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.ibm.itso.sal404.common.exception.ApplicationException;
import com.ibm.itso.sal404.news.NewsSessionData;
/**
 * sal404 Realty sample application
 * 
 * @component	newscomponent
 * @layer		Controller Layer
 * 
 * This Action allows to view the news item details
 * 
 * @author 		Ilaria Gorla
 * @created		May 2003		
 * @version		1.0.0	
 */
public class ViewNewsItemDetailsAction extends Action
{
	// Configure Log4J Logger
	private static Logger logger = Logger.getLogger(ViewNewsItemDetailsAction.class);
	
	/**
	* Constructor
	*/
	public ViewNewsItemDetailsAction()
	{
		super();
	}
	public ActionForward execute(
		ActionMapping mapping,
		ActionForm form,
		HttpServletRequest request,
		HttpServletResponse response)
	{
		logger.info("ENTRY: execute");

		ActionErrors errors = new ActionErrors();
		ActionForward forward = new ActionForward();

		NewsSessionData newsSessionData = null;
		try
		{
		    newsSessionData = (NewsSessionData)request.getSession().getAttribute("newsSessionData");
		    newsSessionData.setCurrent(request.getParameter("newsId"));
		}
		catch (ApplicationException ae)
		{
			// Report the error using the appropriate name and ID.
			errors.add("News", new ActionError(ae.getMessage()));
		}

		// If a message is required, save the specified key(s)
		// into the request for use by the <struts:errors> tag.
		if (!errors.isEmpty())
		{
			saveErrors(request, errors);
			// Forward control to the appropriate 'failure' URI (change name as desired)
			forward = mapping.findForward("failure");
		}
		else
		{
			// Forward control to the appropriate 'success' URI (change name as desired)
			forward = mapping.findForward("success");
		}

		logger.info("EXIT: execute");

		// Finish with
		return (forward);
	}
}
