package com.ibm.itso.sal404.news.form;
import java.util.List;

import javax.servlet.http.HttpServletRequest;

import org.apache.log4j.Logger;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;

import com.ibm.itso.sal404.news.dto.NewsItemDTO;
import com.ibm.itso.sal404.news.dto.NewsItemVectorDTO;

/**
 * sal404 Realty sample application
 * 
 * @component	newscomponent
 * @layer		Business Facade Layer
 * 
 * Form bean for a Struts application.
 * @version 	1.0
 * @author	Ilaria Gorla
 */
public class ManageNewsFormBean extends ActionForm
{
	// Configure Log4J Logger
	private static Logger logger = Logger.getLogger(ManageNewsFormBean.class);

	private String id = null;
	private String submit = null;
	
	// select for deletion
	private NewsItemVectorDTO newsItemVectorDTO = new NewsItemVectorDTO();
	
	/**
	* Constructor
	*/
	public ManageNewsFormBean()
	{
		super();
	}
	
	public void reset(ActionMapping mapping, HttpServletRequest request)
	{
		id = null;
		submit = null;
		newsItemVectorDTO = new NewsItemVectorDTO();
	}
	
	public ActionErrors validate(
		ActionMapping mapping,
		HttpServletRequest request)
	{
		ActionErrors errors = new ActionErrors();
		// Validate the fields in your form, adding
		// adding each error to this.errors as found, e.g.
		// if ((field == null) || (field.length() == 0)) {
		//   errors.add("field", new ActionError("error.field.required"));
		// }
		return errors;
	}
	
	/**
	 * Returns the id.
	 * @return String
	 */
	public String getId()
	{
		return id;
	}

	/**
	 * Returns the submit.
	 * @return String
	 */
	public String getSubmit()
	{
		return submit;
	}

	/**
	 * Sets the id.
	 * @param id The id to set
	 */
	public void setId(String id)
	{
		this.id = id;
	}

	/**
	 * Sets the submit.
	 * @param submit The submit to set
	 */
	public void setSubmit(String submit)
	{
		this.submit = submit;
	}

	/**
	 * Get news item  by index.
	 * @param int
	 * @return String
	 */
	public NewsItemDTO getNews(int index)
	{
		logger.debug("get news item " + index);
		
		List userList = null;
		NewsItemDTO newsItemDTO = null;
		int ubound;
		
		userList = getNewsItemVectorDTO().getNewsItemVector();
		ubound = userList.size() - 1;
		
		
		while (ubound < index)
		{
			ubound ++;
			// add new elements to the list if the index being called for is greater than the size
			newsItemDTO = new NewsItemDTO();
			userList.add(ubound, newsItemDTO);
		}
			
		try
		{
			newsItemDTO = (NewsItemDTO)userList.get(index);
		}
		finally
		{
			if (newsItemDTO == null)
			{
				userList.add(index, newsItemDTO = new NewsItemDTO());
			}
		}
		
		return newsItemDTO;
	}

	/**
	 * Returns the newsItemVectorDTO.
	 * @return NewsItemVectorDTO
	 */
	public NewsItemVectorDTO getNewsItemVectorDTO()
	{
		return newsItemVectorDTO;
	}

	/**
	 * Sets the newsItemVectorDTO.
	 * @param newsItemVectorDTO The newsItemVectorDTO to set
	 */
	public void setNewsItemVectorDTO(NewsItemVectorDTO newsItemVectorDTO)
	{
		this.newsItemVectorDTO = newsItemVectorDTO;
	}

}
