package com.ibm.itso.sal404.propertycatalog.action;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.ibm.itso.sal404.common.exception.ApplicationException;
import com.ibm.itso.sal404.propertycatalog.PropertyCatalogManager;
import com.ibm.itso.sal404.propertycatalog.dto.PropertyDTO;
import com.ibm.itso.sal404.propertycatalog.form.ManagePropertiesForm;
/**
 * 
 * sal404 Realty sample application
 * 
 * @component	propertycatalogcomponent
 * @layer		business facade
 * 
 * Description of the class here
 * Holds public methods within the propertycatalogcomponent.
 * @author 		Gwen Gaumond
 * @created		May 13, 2003		
 * @version		1.0.0 / @May 13, 2003	
 *
 * @see		 	viewProperties.jsp,
 * 				AddPopertyDetailsAction.java
 * 				addPropertyDetails.jsp				
 * 				ModifyPropertyDetailsAction.java
 * 				modifyPropertyDetails.jsp
 * 				
 * 
 */
public class ManagePropertiesAction extends Action
{
    ActionErrors errors = new ActionErrors();
	/**
	* Constructor
	*/
	public ManagePropertiesAction()
	{
		super();
	}
	public ActionForward execute(
		ActionMapping mapping,
		ActionForm form,
		HttpServletRequest request,
		HttpServletResponse response)
		throws Exception
	{
		errors.clear();
		ActionForward forward = new ActionForward();
		// return value
		ManagePropertiesForm managePropertiesForm = (ManagePropertiesForm) form;

		try
		{

			if (request.getParameter("new") != null)
			{ //actions for adding property details
				forward = addProperty(mapping);
			}
			else
			{
				if (request.getParameter("modify") != null)
					forward =
						modifyProperty(
							mapping,
							request,
							forward,
							managePropertiesForm);
			}
		}
		catch (Exception e)
		{
			// Report the error using the appropriate name and ID.
			errors.add("name", new ActionError("id"));
		}
		// If a message is required, save the specified key(s)
		// into the request for use by the <struts:errors> tag.
		forward = checkForErrors(mapping, request, errors, forward);

		// Finish with
		return (forward);
	}
	public ActionForward checkForErrors(
		ActionMapping mapping,
		HttpServletRequest request,
		ActionErrors errors,
		ActionForward forward)
	{
		if (!errors.isEmpty())
		{
			saveErrors(request, errors);
			forward = mapping.findForward("failure");
		}
		return forward;
	}
	public ActionForward modifyProperty(
		ActionMapping mapping,
		HttpServletRequest request,
		ActionForward forward,
		ManagePropertiesForm managePropertiesForm)
		throws ApplicationException
	{
		{ //actions for modifying property details

			PropertyCatalogManager propertyCatalogManager =
				new PropertyCatalogManager();
			//Call the manager to get property details
			if (managePropertiesForm.getId() != null)
			{
				PropertyDTO modifyPropertyDTO =
					propertyCatalogManager.populatePropertyDetails(
						new Integer(managePropertiesForm.getId()));
				//Put the result from the query in the request	
				request.getSession().setAttribute(
					"propertyDTO",
					modifyPropertyDTO);
				forward = mapping.findForward("modify");
				;
			}
			else
			{
				errors.add( "Property", new ActionError("prop.error.no.modify.selection"));
			}
		}
		return forward;
	}
	public ActionForward addProperty(ActionMapping mapping)
	{
		ActionForward forward;
		forward = mapping.findForward("add");
		return forward;
	}
}
