package com.ibm.itso.sal404.propertycatalog.action;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.ibm.itso.sal404.common.exception.ApplicationException;
import com.ibm.itso.sal404.propertycatalog.PropertyCatalogManager;
import com.ibm.itso.sal404.propertycatalog.dto.PropertyDTO;
import com.ibm.itso.sal404.propertycatalog.form.PropertyDetailsForm;
/**
 * 
 * sal404 Realty sample application
 * 
 * @component	propertycatalogcomponent
 * @layer		business facade
 * 
 * Description of the class here
 * Holds public methods within the propertycatalogcomponent.
 * @author 		Gwen Gaumond
 * @created		May 13, 2003		
 * @version		1.0.0 / @May 13, 2003	
 *
 * @see		 	viewProperties.jsp
 * 				
 * 				ModifyPropertyDetailsForm.java 
 * 				modifyPropertyDetails.jsp
 * 
 */
public class ModifyPropertyDetailsAction extends Action
{

	// Configure Log4J Logger
	private static Logger logger =
		Logger.getLogger(PropertyCatalogManager.class);

	/**
	* Constructor
	*/
	public ModifyPropertyDetailsAction()
	{
		super();
	}
	public ActionForward execute(
		ActionMapping mapping,
		ActionForm form,
		HttpServletRequest request,
		HttpServletResponse response)
		throws Exception
	{
		ActionErrors errors = new ActionErrors();
		ActionForward forward = new ActionForward();

		PropertyDetailsForm modifyPropertyDetailsForm =
			(PropertyDetailsForm) form;

		try
		{ //set manager class
			PropertyCatalogManager manager = new PropertyCatalogManager();
			PropertyDTO modifyPropertyDTO = null;
			//populate modifyPropertyDTO with form values
			modifyPropertyDTO =
				populatePropertyDTO(request, modifyPropertyDetailsForm);
			//call manager class to modify the details
			modifyProperty(manager, modifyPropertyDTO);
		} //end try
		catch (ApplicationException e)
		{
			// Report the error using the appropriate name and ID.
			if (e.getSeverityLevel() != 0)
			{
				forward = mapping.findForward("fatalError");
				return (forward);
			}
			else
			{
				errors.add(
					"addProperty",
					new ActionError(e.getStrutsMessage()));
				logger.debug("message " + e.getStrutsMessage());
			}
		}
		// If a message is required, save the specified key(s)
		// into the request for use by the <struts:errors> tag.
		forward = checkForErrors(mapping, request, errors);
		// Finish with
		return (forward);
	}
	public ActionForward checkForErrors(
		ActionMapping mapping,
		HttpServletRequest request,
		ActionErrors errors)
	{
		ActionForward forward;
		if (!errors.isEmpty())
		{
			System.err.println("modify");
			saveErrors(request, errors);
			forward = mapping.findForward("failure");
		}
		// Write logic determining how the user should be forwarded.
		else
		{
			forward = mapping.findForward("success");
		}
		return forward;
	}
	public void modifyProperty(
		PropertyCatalogManager manager,
		PropertyDTO modifyPropertyDTO)
		throws ApplicationException
	{
		manager.modifyPropertyDetails(modifyPropertyDTO);
	}
	public PropertyDTO populatePropertyDTO(
		HttpServletRequest request,
		PropertyDetailsForm modifyPropertyDetailsForm)
	{
		PropertyDTO modifyPropertyDTO = new PropertyDTO();
		modifyPropertyDTO.setId(new Integer(modifyPropertyDetailsForm.getId()));
		modifyPropertyDTO.setUnitNumber(
			modifyPropertyDetailsForm.getUnitNumber());
		modifyPropertyDTO.setType(modifyPropertyDetailsForm.getType());
		modifyPropertyDTO.setStreetName(
			modifyPropertyDetailsForm.getStreetName());
		modifyPropertyDTO.setStatus(modifyPropertyDetailsForm.getStatus());
		modifyPropertyDTO.setRegion(modifyPropertyDetailsForm.getRegion());
		modifyPropertyDTO.setPostOfficeBox(
			modifyPropertyDetailsForm.getPostOfficeBox());
		modifyPropertyDTO.setPostalCode(
			modifyPropertyDetailsForm.getPostalCode());
		modifyPropertyDTO.setPictureURL(
			modifyPropertyDetailsForm.getPictureURL());
		modifyPropertyDTO.setMunicipality(
			modifyPropertyDetailsForm.getMunicipality());
		modifyPropertyDTO.setCountryCode(modifyPropertyDetailsForm.getCountryCode());
		modifyPropertyDTO.setBuildingNumber(
			modifyPropertyDetailsForm.getBuildingNumber());
		modifyPropertyDTO.setAdditionalText(
			modifyPropertyDetailsForm.getAdditionalText());
		modifyPropertyDTO.setPrice(modifyPropertyDetailsForm.getPrice());
		modifyPropertyDTO.setUserId(modifyPropertyDetailsForm.getUserId());
		request.getSession().setAttribute("propertyDTO", modifyPropertyDTO);
		return modifyPropertyDTO;
	}
}
