package com.ibm.itso.sal404.propertycatalog.action;

import java.util.Vector;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.ibm.itso.sal404.common.exception.ApplicationException;
import com.ibm.itso.sal404.propertycatalog.PropertyCatalogManager;
import com.ibm.itso.sal404.propertycatalog.dto.SearchPropertiesByCriteriaDTO;

/**
 * 
 * sal404 Realty sample application
 * 
 * @component 	PropertyCatalog component
 * @layer		Controller Layer
 * 
 * This action retrieves a list of properties.
 * It's called when the user searchs properties
 * 
 * @author 		Pasi Valjus
 * @created		May 25  2003	
 * @version		1.0.0 / @May 25, 2003	
 *
 * @see		 	to be completed
 * 
 */
public class RepeatSearchByCriteraAction extends Action
{
	private static Logger logger =
		Logger.getLogger(RepeatSearchByCriteraAction.class);
	/**
	* Constructor
	*/
	public RepeatSearchByCriteraAction()
	{

		super();

	}
	public ActionForward execute(
		ActionMapping mapping,
		ActionForm form,
		HttpServletRequest request,
		HttpServletResponse response)
		throws Exception
	{

		ActionErrors errors = new ActionErrors();
		ActionForward forward = new ActionForward();
		// return value

		try
		{

			SearchPropertiesByCriteriaDTO searchByCriteriaDTO =
				(SearchPropertiesByCriteriaDTO) request
					.getSession()
					.getAttribute(
					"SearchPropertyDTO");

			//Create the manager and pass the DTO to the manager for search
			Vector propertiesVector =
				searchPropertiesByCriteria(searchByCriteriaDTO);

			//No properties found 
			if (propertiesVector.size() == 0)
				errors.add(
					"no properties found",
					new ActionError("prop.results.found"));

			//Put the result from the search in the request
			request.setAttribute("propertyVectorDTO", propertiesVector);

		}
		catch (ApplicationException e)
		{
			// Report the error using the appropriate name and ID.
			if (e.getSeverityLevel() != 0)
			{
				logger.debug("Error in repeat is " + e.getStrutsMessage());
				errors.add("fatalerror", new ActionError(e.getStrutsMessage()));
				saveErrors(request, errors);
				forward = mapping.findForward("fatalError");
				return (forward);
			}
			else
				errors.add(
					"searchByCriteria",
					new ActionError(e.getStrutsMessage()));
		}
		catch (Exception e)
		{
			errors.add(
				"fatalerror",
				new ActionError("prop.error.general.failure"));
			saveErrors(request, errors);
			forward = mapping.findForward("fatalError");
			return (forward);
		}

		// If a message is required, save the specified key(s)
		// into the request for use by the <struts:errors> tag.

		forward = checkForErrors(mapping, request, errors);

		// Finish with
		return (forward);

	}
	public ActionForward checkForErrors(
		ActionMapping mapping,
		HttpServletRequest request,
		ActionErrors errors)
	{
		ActionForward forward;
		if (!errors.isEmpty())
		{
			saveErrors(request, errors);
			// Forward control to the appropriate 'failure' URI (change name as desired)
			forward = mapping.findForward("failure");

		}
		else
		{

			// Forward control to the appropriate 'success' URI (change name as desired)
			forward = mapping.findForward("success");

		}
		return forward;
	}
	public Vector searchPropertiesByCriteria(SearchPropertiesByCriteriaDTO searchByCriteriaDTO)
		throws ApplicationException
	{
		PropertyCatalogManager manager = new PropertyCatalogManager();
		Vector propertiesVector = manager.searchByCriteria(searchByCriteriaDTO);
		return propertiesVector;
	}

}
