package com.ibm.itso.sal404.propertycatalog.action;
import java.util.Vector;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.ibm.itso.sal404.common.exception.ApplicationException;
import com.ibm.itso.sal404.propertycatalog.PropertyCatalogManager;
/**
 * 
 * sal404 Realty sample application
 * 
 * @component 	PropertyCatalog component
 * @layer		Controller Layer
 * 
 * This action retrieves a list of properties.
 * It's  called when a logged in agent wants to browse his properties
 * 
 * @author 		Pasi Valjus
 * @created		May 25  2003	
 * @version		1.0.0 / @May 25, 2003	
 *
 * @see		 	to be completed
 * 
 */
public class ViewPropertiesForAgentAction extends Action
{
	// Configure Log4J Logger
	private static Logger logger = Logger.getLogger(ViewPropertiesForAgentAction.class);
	/**
	* Constructor
	*/
	public ViewPropertiesForAgentAction()
	{
		super();
	}
	public ActionForward execute(
		ActionMapping mapping,
		ActionForm form,
		HttpServletRequest request,
		HttpServletResponse response)
		throws Exception
	{
		ActionErrors errors = new ActionErrors();
		ActionForward forward = new ActionForward();
		// return value
		try
		{
			
			String agentId = request.getParameter("agentId");
			logger.debug("ID is " + agentId);
			PropertyCatalogManager manager = new PropertyCatalogManager();
			Vector propertiesVector = manager.viewAgentProperties(Integer.parseInt(agentId));
					
			//Put the result from the search in the request
			request.setAttribute("propertyVectorDTO", propertiesVector);
		}
		catch (ApplicationException e) 
		{
			// Report the error using the appropriate name and ID.
			if(e.getSeverityLevel()!=0)
			{		
				errors.add("fatalerror", new ActionError(e.getStrutsMessage()));
				saveErrors(request, errors);		
				forward = mapping.findForward("fatalError");	
				return (forward);	
			}	
			else
				errors.add("viewPropertiesForAgent", new ActionError(e.getStrutsMessage()));
		}
		catch (Exception e) 
		{
			errors.add("fatalerror", new ActionError("prop.error.general.failure"));
			saveErrors(request, errors);		
			forward = mapping.findForward("fatalError");	
			return (forward);
		}
		// If a message is required, save the specified key(s)
		// into the request for use by the <struts:errors> tag.
		if (!errors.isEmpty())
		{
			saveErrors(request, errors);
			// Forward control to the appropriate 'failure' URI (change name as desired)
			forward = mapping.findForward("failure");
		}
		else
		{
			// Forward control to the appropriate 'success' URI (change name as desired)
			forward = mapping.findForward("success");
		}
		// Finish with
		return (forward);
	}
}
