package com.ibm.itso.sal404.propertycatalog.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.log4j.Logger;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.ibm.itso.sal404.common.exception.ApplicationException;
import com.ibm.itso.sal404.propertycatalog.PropertyCatalogManager;
import com.ibm.itso.sal404.propertycatalog.dto.PropertyDTO;
import com.ibm.itso.sal404.propertycatalog.dto.ResultPropertyDetailsDTO;

/**
 * 
 * sal404 Realty sample application
 * 
 * @component PropertyCatalog component
 * @layer Controller Layer
 * 
 * This action retrieves property details.
 * 
 * @author Pasi Valjus
 * @created May 25 2003
 * @version 1.0.0 /
 * @May 25, 2003
 * 
 * @see to be completed
 *  
 */
public class ViewPropertyDetailsAction extends Action
{
    //  Configure Log4J Logger
    private static Logger logger = Logger
            .getLogger(ViewPropertyDetailsAction.class);

    /**
     * Constructor
     */
    public ViewPropertyDetailsAction()
    {
        super();
        logger.info("Constructor");
    }

    public ActionForward execute(ActionMapping mapping, ActionForm form,
            HttpServletRequest request, HttpServletResponse response)
    {
        logger.info("Entered execute");
        ActionErrors errors = new ActionErrors();
        ActionForward forward = new ActionForward();
        try
        {
            ResultPropertyDetailsDTO resultFromPropertyDetailsDTO = retrieveSelectedProperty(request);
            //Put the result from the query in the request
            request.setAttribute("propertyDTO", resultFromPropertyDetailsDTO);
        }
        catch (ApplicationException e)
        {
            // Report the error using the appropriate name and ID.
            if (e.getSeverityLevel() != 0)
            {
                errors.add("fatalerror", new ActionError(e.getStrutsMessage()));
                saveErrors(request, errors);
                forward = mapping.findForward("fatalError");
                return (forward);
            }
            else
                errors.add("viewPropertyDetails", new ActionError(e
                        .getStrutsMessage()));
        }
        catch (Exception e)
        {
            errors.add("fatalerror", new ActionError(
                    "prop.error.general.failure"));
            saveErrors(request, errors);
            forward = mapping.findForward("fatalError");
            return (forward);
        }
        // If a message is required, save the specified key(s)
        // into the request for use by the <struts:errors> tag.
        forward = checkForErrors(mapping, request, errors);
        // Finish with
        return (forward);
    }

    public ActionForward checkForErrors(ActionMapping mapping,
            HttpServletRequest request, ActionErrors errors)
    {
        ActionForward forward;
        if (!errors.isEmpty())
        {
            saveErrors(request, errors);
            // Forward control to the appropriate 'failure' URI (change name as
            // desired)
            forward = mapping.findForward("failure");
        }
        else
        {
            // Forward control to the appropriate 'success' URI (change name as
            // desired)
            forward = mapping.findForward("success");
        }
        return forward;
    }

    public ResultPropertyDetailsDTO retrieveSelectedProperty(
            HttpServletRequest request) throws ApplicationException
    {
        Integer propertyId;
        if (request.getParameter("propertyId") == null)
        {
            PropertyDTO prop = (PropertyDTO) request.getSession().getAttribute(
                    "propertyDTO");
            propertyId = prop.getId();
        }
        else
        {
            propertyId = new Integer(Integer.parseInt(request
                    .getParameter("propertyId")));
        }
        PropertyCatalogManager manager = new PropertyCatalogManager();
        //Call the manager to get property details
        ResultPropertyDetailsDTO resultFromPropertyDetailsDTO = manager
                .viewPropertyDetails(propertyId.intValue());
        //Add the id
        resultFromPropertyDetailsDTO.setId(propertyId.intValue());
        PropertyDTO prop = manager.populatePropertyDetails(propertyId);
        request.getSession().setAttribute("propertyDTO", prop);

        return resultFromPropertyDetailsDTO;
    }
}
