package com.ibm.itso.sal404.propertycatalog.form;

import java.math.BigDecimal;
import java.util.Vector;

import javax.servlet.http.HttpServletRequest;

import org.apache.log4j.Logger;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;

/**
 * 
 * sal404 Realty sample application
 * 
 * @component PropertyCatalog component
 * @layer presentation layer
 * 
 * Contains the search criterias the user have entered
 * 
 * @author Pasi Valjus
 * @created May 25 2003
 * @version 1.0.0 /
 * @May 25, 2003
 * 
 * @see to be completed
 *  
 */
public class SearchPropertiesByCriteriaForm extends ActionForm
{
    // Configure Log4J Logger
    private static Logger logger = Logger
            .getLogger(SearchPropertiesByCriteriaForm.class);

    private String propertyTypeId = null;

    private String minPrice = null;

    private String maxPrice = null;

    private String postalCode = null;

    private Vector vectorPropertyTypes = null;

    /**
     * Constructor
     */
    public SearchPropertiesByCriteriaForm()
    {
        super();
    }

    public void reset(ActionMapping mapping, HttpServletRequest request)
    {

        // Reset values are provided as samples only. Change as appropriate.

        propertyTypeId = null;
        minPrice = null;
        maxPrice = null;

    }

    public ActionErrors validate(ActionMapping mapping,
            HttpServletRequest request)
    {

        ActionErrors errors = new ActionErrors();
        //Search is not required id adding a new property
        if (request.getParameter("new") == null)
        {
            validateSearchForm(errors);
        }

        return errors;

    }

    public void validateSearchForm(ActionErrors errors)
    {
        if (getPropertyTypeId().equals("0"))
        {
            errors.add("propertyTypeId", new ActionError(
                    "prop.error.propertyTypeId.required"));
        }

        //Minprice must be numbers
        if (getMinPrice().length() > 0)
        {
            try
            {
                new BigDecimal(getMinPrice());
            }
            catch (NumberFormatException e)
            {
                logger.info("NumberFormatException:" + e.getMessage());
                errors.add("minprize", new ActionError(
                        "prop.error.minprice.notnumbers"));
            }
        }

        //Maxprice must be numbers
        if (getMaxPrice().length() > 0)

        {
            try
            {
                new BigDecimal(getMaxPrice());
            }
            catch (NumberFormatException e)
            {
                logger.info("NumberFormatException:" + e.getMessage());
                errors.add("maxprize", new ActionError(
                        "prop.error.maxprice.notnumbers"));
            }

        }

        //Postal code must be numbers
        if (getPostalCode().length() > 0)

        {
            try
            {
                Integer.parseInt(getPostalCode());
                ;
            }
            catch (NumberFormatException e)
            {
                logger.info("NumberFormatException:" + e.getMessage());
                errors.add("maxprize", new ActionError(
                        "prop.error.postalcode.notnumbers"));
            }

        }
    }

    /**
     * Returns the postalcode.
     * 
     * @return String
     */
    public String getPostalcode()
    {
        return postalCode;
    }

    /**
     * Sets the postalcode.
     * 
     * @param postalcode
     *            The postalcode to set
     */
    public void setPostalcode(String postalCode)
    {
        this.postalCode = postalCode;
    }

    /**
     * Returns the logger.
     * 
     * @return Logger
     */
    public static Logger getLogger()
    {
        return logger;
    }

    /**
     * Returns the id.
     * 
     * @return String
     */
    public String getPropertyTypeId()
    {
        return propertyTypeId;
    }

    /**
     * Returns the maxPrice.
     * 
     * @return String
     */
    public String getMaxPrice()
    {
        return maxPrice;
    }

    /**
     * Returns the minPrice.
     * 
     * @return String
     */
    public String getMinPrice()
    {
        return minPrice;
    }

    /**
     * Returns the postalCode.
     * 
     * @return String
     */
    public String getPostalCode()
    {
        return postalCode;
    }

    /**
     * Sets the logger.
     * 
     * @param logger
     *            The logger to set
     */
    public static void setLogger(Logger logger)
    {
        SearchPropertiesByCriteriaForm.logger = logger;
    }

    /**
     * Sets the id.
     * 
     * @param id
     *            The id to set
     */
    public void setPropertyTypeId(String propertyTypeId)
    {
        this.propertyTypeId = propertyTypeId;
    }

    /**
     * Sets the maxPrice.
     * 
     * @param maxPrice
     *            The maxPrice to set
     */
    public void setMaxPrice(String maxPrice)
    {
        this.maxPrice = maxPrice;
    }

    /**
     * Sets the minPrice.
     * 
     * @param minPrice
     *            The minPrice to set
     */
    public void setMinPrice(String minPrice)
    {
        this.minPrice = minPrice;
    }

    /**
     * Sets the postalCode.
     * 
     * @param postalCode
     *            The postalCode to set
     */
    public void setPostalCode(String postalCode)
    {
        this.postalCode = postalCode;
    }

    /**
     * Returns the vectorPropertyTypes.
     * 
     * @return Vector
     */
    public Vector getVectorPropertyTypes()
    {
        return vectorPropertyTypes;
    }

    /**
     * Sets the vectorPropertyTypes.
     * 
     * @param vectorPropertyTypes
     *            The vectorPropertyTypes to set
     */
    public void setVectorPropertyTypes(Vector vectorPropertyTypes)
    {
        this.vectorPropertyTypes = vectorPropertyTypes;
    }

}