package com.ibm.itso.sal404.reporting.action;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.ibm.itso.sal404.reporting.ReportingManager;
import com.ibm.itso.sal404.reporting.dto.ReportDTO;

/**
 * @version 	1.0
 * @author
 */
public class ViewInterestForPropertyReportAction extends Action
{
	private ReportingManager	_manager = null;	
	/**
	* Constructor
	*/
	public ViewInterestForPropertyReportAction()
	{
		super();
		_manager = new ReportingManager();		
	}
	
	public ActionForward execute(
		ActionMapping mapping,
		ActionForm form,
		HttpServletRequest request,
		HttpServletResponse response)
		throws Exception
	{
		ActionErrors errors = new ActionErrors();
		ActionForward forward = new ActionForward();
		
		String propertyIdString = null;
		int propertyId = -1;
		ReportDTO resultReportDTO = null;		
		// return value
		try
		{
			propertyIdString = request.getParameter("propertyId");
			propertyId = Integer.parseInt(propertyIdString);
			resultReportDTO = _manager.viewInterestForPropertyReport(propertyId);
			if (resultReportDTO.getReportItems() != null)
			{
				if (resultReportDTO.getReportItems().size() == 0)
				{
					errors.add("no customers found for property", new ActionError("reporting.error.viewInterestForPropertyReport"));
				}
			}				 
			request.setAttribute("reportDTO", resultReportDTO);
		}
		catch (Exception e)
		{
			// Report the error using the appropriate name and ID.
			errors.add("fatal error", new ActionError("reporting.error.fatalerror"));
		}
		// If a message is required, save the specified key(s)
		// into the request for use by the <struts:errors> tag.
		if (!errors.isEmpty())
		{
			saveErrors(request, errors);
			forward = mapping.findForward("failure");
		}
		else
		{
			forward = mapping.findForward("success");
		}
		return (forward);
	}
}
