package com.ibm.itso.sal404.user.action;

import java.lang.reflect.InvocationTargetException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.ibm.itso.sal404.common.exception.ApplicationException;
import com.ibm.itso.sal404.user.UserSessionData;
import com.ibm.itso.sal404.user.dto.UserDetailsDTO;
import com.ibm.itso.sal404.user.form.UserDetailsFormBean;

// Import Log4J Logger
import org.apache.commons.beanutils.PropertyUtils;
import org.apache.log4j.Logger;

/**
 * 
 * sal404 Realty sample application
 * 
 * @component	name of component here
 * @layer		name of layer here
 * 
 * Description of the class here
 * 
 * @author 		Author full name here
 * @created		initial creation date here		
 * @version		x.y.z / @${date}	
 *
 * @see		 	classes associated with this class
 * 
 */
public class ModifyUserDetailsAction extends Action
{
	// Configure Log4J Logger
	private static Logger logger =
		Logger.getLogger(ModifyUserDetailsAction.class);

	/**
	* Constructor
	*/
	public ModifyUserDetailsAction()
	{
		super();
	}
	
	public ActionForward execute(
		ActionMapping mapping,
		ActionForm form,
		HttpServletRequest request,
		HttpServletResponse response)
	{
		logger.info("ENTRY: execute");

		ActionErrors errors = new ActionErrors();
		ActionForward forward = new ActionForward();
		// return value
		UserDetailsFormBean modifyUserDetailsForm =
			(UserDetailsFormBean) form;

		UserDetailsDTO userDetailsDTO = new UserDetailsDTO();

		// transfer properties
		transferProperties(modifyUserDetailsForm, userDetailsDTO);
		
		UserSessionData userSessionData = null;
		try
		{
		    userSessionData = 
		        	(UserSessionData)request.getSession().getAttribute("userSessionData");
		    
			// if password is empty, do not reset
			if (userDetailsDTO.getPassword()==null || userDetailsDTO.getPassword().equals("")) {
			    if (userSessionData.getUser() != null)
			        userDetailsDTO.setPassword(userSessionData.getUser().getPassword());
			    else
			        userDetailsDTO.setPassword(userSessionData.getLogInUser().getPassword());
			        
			    logger.debug("password is: " + userDetailsDTO.getPassword());
			}
			
			userSessionData.modifyUserDetails(userDetailsDTO);
		}
		catch (ApplicationException ae)
		{
			// Report the error using the appropriate name and ID.
			errors.add("user", new ActionError(ae.getMessage()));
		}

		if (!errors.isEmpty())
		{
			saveErrors(request, errors);

			// Forward control to the appropriate 'failure' URI (change name as desired)
			forward = mapping.findForward("failure");
		}
		else if (userSessionData.getUser() != null)
		{
		    userSessionData.setUser((UserDetailsDTO)null);
			forward = mapping.findForward("modifiedUser");

			logger.debug(
				"admin modify reset admin user: "
					+ userDetailsDTO.getUserName());
		}
		else
		{
			// Forward control to the appropriate 'success' URI (change name as desired)
			// confirmation message
			request.setAttribute(
				"confirmationMessage",
				new String("User modified"));

			forward = mapping.findForward("success");
		}

		logger.info("EXIT:  execute");
		// Finish with
		return (forward);
	}

/**
 * @param registerFormBean
 * @param userDetailsDTO
 */
    private void transferProperties(
            UserDetailsFormBean modifyUserDetailsForm,
            UserDetailsDTO userDetailsDTO) {
        logger.info("ENTRY: transferProperties");
        try {
            PropertyUtils.copyProperties(userDetailsDTO, modifyUserDetailsForm);
        } catch (IllegalAccessException e1) {
            e1.printStackTrace();
        } catch (InvocationTargetException e1) {
            e1.printStackTrace();
        } catch (NoSuchMethodException e1) {
            e1.printStackTrace();
        }
        logger.info("EXIT:  transferProperties");
    }
}
