package com.ibm.itso.sal404.user.action;

import java.lang.reflect.InvocationTargetException;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.commons.beanutils.PropertyUtils;
import org.apache.log4j.Logger;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.ibm.itso.sal404.common.exception.ApplicationException;
import com.ibm.itso.sal404.email.EmailManager;
import com.ibm.itso.sal404.email.dto.EmailMessage;
import com.ibm.itso.sal404.user.UserSessionData;
import com.ibm.itso.sal404.user.dto.UserDetailsDTO;
import com.ibm.itso.sal404.user.form.UserDetailsFormBean;

/**
 * @version 	1.0
 * @author
 */
public class RegisterAction extends Action
{
	// Configure Log4J Logger
	private static Logger logger = Logger.getLogger(RegisterAction.class);

	/**
	* Constructor
	*/
	public RegisterAction()
	{
		super();
	}
	
	public ActionForward execute(
		ActionMapping mapping,
		ActionForm form,
		HttpServletRequest request,
		HttpServletResponse response)
	{
		logger.info("ENTRY: execute");
	
		ActionErrors errors = new ActionErrors();
		ActionForward forward = new ActionForward();
		// return value
		UserDetailsFormBean userDetailsFormBean = (UserDetailsFormBean) form;
	
		// Create DTO(s)
		UserDetailsDTO userDetailsDTO = new UserDetailsDTO();
	
		// transfer properties
		transferProperties(userDetailsFormBean, userDetailsDTO);
	
		UserSessionData userSessionData = null;
		EmailManager emailManager = null;
		try
		{
			// Create Managers
		    userSessionData = 
	        	(UserSessionData)request.getSession().getAttribute("userSessionData");
			emailManager = new EmailManager();
		
			userDetailsDTO = userSessionData.create(userDetailsDTO);			
			
			emailManager = new EmailManager();			
			try
			{	
				EmailMessage greeting = emailManager.createGreetingMessage(userDetailsDTO);	
				greeting.sendMessage();
			}
			catch (Exception e)
			{
				logger.error("Email Manager: " + e.getMessage());
			}
		}
		catch (ApplicationException ae)
		{
			// Report the error using the appropriate name and ID.
			errors.add("register", new ActionError(ae.getStrutsMessage()));
		}
	
		// If a message is required, save the specified key(s)
		// into the request for use by the <struts:errors> tag.
		if (!errors.isEmpty())
		{
			logger.debug("failure");
	
			saveErrors(request, errors);
	
			// Forward control to the appropriate 'failure' URI (change name as desired)
			forward = mapping.findForward("failure");
		}
		else
		{
			logger.debug("success");
			
			// Forward control to the appropriate 'success' URI (change name as desired)
			forward = mapping.findForward("success");
		}
	
		logger.info("EXIT:  execute");
		// Finish with
		return (forward);
	}

	/**
	 * @param registerFormBean
	 * @param userDetailsDTO
	 */
	private void transferProperties(UserDetailsFormBean userDetailsFormBean, UserDetailsDTO userDetailsDTO) {
		logger.info("ENTRY: transferProperties");
		try {
			PropertyUtils.copyProperties(userDetailsDTO, userDetailsFormBean);
		} catch (IllegalAccessException e1) {
			e1.printStackTrace();
		} catch (InvocationTargetException e1) {
			e1.printStackTrace();
		} catch (NoSuchMethodException e1) {
			e1.printStackTrace();
		}
		
		logger.debug("form email: " + userDetailsFormBean.getEmailAddr());
		logger.debug("DTO email: " + userDetailsDTO.getEmailAddr());
		logger.info("EXIT:  transferProperties");
	}
}
