package com.ibm.itso.sal404.user.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.ibm.itso.sal404.email.EmailManager;
import com.ibm.itso.sal404.email.dto.EmailMessage;
import com.ibm.itso.sal404.user.UserManager;
import com.ibm.itso.sal404.user.dto.UserDetailsDTO;
import com.ibm.itso.sal404.user.dto.UserVectorDTO;
import com.ibm.itso.sal404.user.form.RequestPasswordFormBean;

/**
 * @version 	1.0
 * @author
 */
public class RequestPasswordAction extends Action {

	/**
	* Constructor
	*/
	public RequestPasswordAction() {

		super();

	}
	public ActionForward execute(
		ActionMapping mapping,
		ActionForm form,
		HttpServletRequest request,
		HttpServletResponse response)
		throws Exception {

		ActionErrors errors = new ActionErrors();
		ActionForward forward = new ActionForward();
		// return value

		RequestPasswordFormBean requestPasswordFormBean = (RequestPasswordFormBean) form;
		String rpUsername = requestPasswordFormBean.getUsername();
		String rpEmailAddress = requestPasswordFormBean.getEmailAddress();

		UserVectorDTO userVectorDTO = null;
		UserDetailsDTO userDetailsDTO = null;
		UserManager userManager = null;
		try
		{
			// Create Managers
			userManager = new UserManager();


			// Call User Manager - Get user detail by username
			userVectorDTO = userManager.buildUserDetailsDTO(rpUsername);
			
			if ((userVectorDTO == null) || userVectorDTO.getUserVector().isEmpty())
			{
				errors.add("requestPassword", new ActionError("user.error.usernotfound"));
			}
			else
			{
				for (int i=0; i<userVectorDTO.getUserVector().size(); i++)
				{
					userDetailsDTO = (UserDetailsDTO)userVectorDTO.getUserVector().elementAt(i);
                    if (rpEmailAddress.equals(userDetailsDTO.getEmailAddr()))
                    {
                    	break;
                    }					
                    else
                    {
                    	userDetailsDTO = null;	
                    }
				}
				
				if (userDetailsDTO == null)
				{
					errors.add("requestPassword", new ActionError("user.error.usernotfound"));					
				}
			}			
		}
		catch (Exception e)
		{
			// Report the error using the appropriate name and ID.
			errors.add("requestPassword", new ActionError(e.getMessage()));
		}

		// If a message is required, save the specified key(s)
		// into the request for use by the <struts:errors> tag.
		if (!errors.isEmpty()) 
		{
			saveErrors(request, errors);
			forward = mapping.findForward("failure");
		}
		else
		{
			// send out e-mail, go success
			EmailManager emailManager = new EmailManager();

			EmailMessage passwordReply =  emailManager.createPasswordReplyMessage(userDetailsDTO);				
			
			if(passwordReply.sendMessage())
			{
				errors.add("requestPassword", new ActionError("user.email.passwordsent"));
			}
			else
			{
				errors.add("requestPassword", new ActionError("user.email.passwordnotsent"));
			}

			saveErrors(request, errors);
			forward = mapping.findForward("success");
		}

		// Finish with
		return (forward);

	}
}
