package com.ibm.itso.sal404.user.action;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.struts.action.Action;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import com.ibm.itso.sal404.common.exception.ApplicationException;
import com.ibm.itso.sal404.user.UserSessionData;
import com.ibm.itso.sal404.user.dto.UserDetailsDTO;
import com.ibm.itso.sal404.user.dto.UserVectorDTO;
import com.ibm.itso.sal404.user.form.UserSearchFormBean;

// Import Log4J Logger
import org.apache.log4j.Logger;

/**
 * 
 * sal404 Realty sample application
 * 
 * @component	name of component here
 * @layer		name of layer here
 * 
 * Description of the class here
 * 
 * @author 		Author full name here
 * @created		initial creation date here		
 * @version		x.y.z / @${date}	
 *
 * @see		 	classes associated with this class
 * 
 */
public class UserSearchAction extends Action
{
	// Configure Log4J Logger
	private static Logger logger = Logger.getLogger(UserSearchAction.class);
	ActionErrors errors = new ActionErrors();
	ActionForward forward = new ActionForward();
	
	/**
	* Constructor
	*/
	public UserSearchAction()
	{
		super();
	}
	public ActionForward execute(
		ActionMapping mapping,
		ActionForm form,
		HttpServletRequest request,
		HttpServletResponse response)
	{

		ActionForward forward = null;
		errors.clear();
		// return value
		UserSearchFormBean userSearchFormBean = (UserSearchFormBean) form;

		UserSessionData userSessionData = null;
		try
		{
			logger.info("ENTRY: execute");

			// Get session data
			userSessionData = 
			    (UserSessionData)request.getSession().getAttribute("userSessionData");

			// Should I modify anyone?
			if (request.getParameter("modify") != null) {
			    logger.debug("modify");
			    userSessionData.setUser(userSearchFormBean.getModifyUser());
			}
				
			// Should I delete anyone?
			if (request.getParameter("delete") != null)
				deleteUser(userSearchFormBean, userSessionData);
			
			// Rebuild user list
			logger.info("rebuild list will be done");
			userSessionData.resetUserList();
			userSessionData.getUserList();
		}
		catch (ApplicationException ae)
		{
		    logger.error(ae.getMessage());
			// Report the error using the appropriate name and ID.
			errors.add("userSearch", new ActionError(ae.getStrutsMessage()));
		}

		// If a message is required, save the specified key(s)
		// into the request for use by the <struts:errors> tag.
		forward = checkForErrors(mapping, request, errors);

		logger.info("EXIT:  execute");

		// Finish with
		return (forward);
	}
	public ActionForward checkForErrors(
		ActionMapping mapping,
		HttpServletRequest request,
		ActionErrors errors)
	{
		ActionForward forward;
		if (!errors.isEmpty())
		{
			saveErrors(request, errors);
			forward = mapping.findForward("failure");
		}
		else if (request.getParameter("modify") != null)
		{
			forward = mapping.findForward("modifyUser");
		}
		else
		{
			forward = mapping.findForward("success");
		}
		return forward;
	}

	public void deleteUser(
		UserSearchFormBean userSearchFormBean,
		UserSessionData userSessionData)
	{
		UserVectorDTO userVectorDTO;

		boolean deletesSelected = false;
		userVectorDTO = userSearchFormBean.getUserVectorDTO();
		for (int i = 0; i < userVectorDTO.getUserVector().size(); i++)
		{
			UserDetailsDTO userDetailsDTO =
				(UserDetailsDTO) userVectorDTO.getUserVector().elementAt(i);
			logger.debug(
				"Delete Me "
					+ userDetailsDTO.getDelete()
					+ " "
					+ userDetailsDTO.getUserName());

			if (userDetailsDTO.getDelete())
			{
			    userSessionData.deleteUser(userDetailsDTO);
				deletesSelected = true;
			}
		}
		if (!deletesSelected)
		{
			logger.debug("delete flag error " + deletesSelected);
			errors.add(
				"User",
				new ActionError("user.error.no.delete.selection"));
		}
	}
}
