package com.ibm.itso.sal404.user.filterServlet;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.apache.log4j.Logger;

/**
 * @version 	1.0
 * @author
 */
public class SessionFilter implements Filter
{
	// Configure Log4J Logger
	private static Logger logger = Logger.getLogger(SessionFilter.class);

	private FilterConfig filterconfig = null;

	/**
	* @see javax.servlet.Filter#void ()
	*/
	public void destroy()
	{

	}

	/**
	* @see javax.servlet.Filter#void (javax.servlet.ServletRequest, javax.servlet.ServletResponse, javax.servlet.FilterChain)
	*/
	public void doFilter(
		ServletRequest req,
		ServletResponse resp,
		FilterChain chain)
		throws ServletException, IOException
	{
		logger.info("ENTRY: doFilter");

		HttpServletRequest httpServletRequest = (HttpServletRequest)req;
		HttpSession session = httpServletRequest.getSession();
		RequestDispatcher requestDispatcher = null;

		// check for session
		if (session.isNew())
		{
			requestDispatcher = filterconfig.getServletContext().
				getRequestDispatcher("/general/fatalError.jsp");
			
			httpServletRequest.setAttribute("fatalErrorMessage", 
				new String("Your session has expired"));
			
			requestDispatcher.forward(httpServletRequest, resp);
			
			logger.warn("new session");			
			return;
		}
		
		chain.doFilter(req, resp);

		logger.info("EXIT:  doFilter");
	}

	/**
	* Method init.
	* @param config
	* @throws javax.servlet.ServletException
	*/
	public void init(FilterConfig config) throws ServletException
	{
		logger.info("ENTRY: init");
		this.filterconfig = config;
		logger.info("EXIT:  init");
	}

}
