package com.ibm.itso.sal404.user.filterServlet;

import java.io.IOException;

import javax.servlet.Filter;
import javax.servlet.FilterChain;
import javax.servlet.FilterConfig;
import javax.servlet.RequestDispatcher;
import javax.servlet.ServletException;
import javax.servlet.ServletRequest;
import javax.servlet.ServletResponse;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpSession;

import org.apache.log4j.Logger;

import com.ibm.itso.sal404.user.UserSessionData;


/**
 * @version 	1.0
 * @author
 */
public class UserFilter implements Filter
{
	// Configure Log4J Logger
	private static Logger logger = Logger.getLogger(UserFilter.class);

	private FilterConfig filterconfig = null;

	/**
	* @see java.lang.Object#Object ()
	*/
	public UserFilter()
	{
		super();
	}

	/**
	* @see javax.servlet.Filter#void ()
	*/
	public void destroy()
	{

	}

	/**
	* @see javax.servlet.Filter#void (javax.servlet.ServletRequest, javax.servlet.ServletResponse, javax.servlet.FilterChain)
	*/
	public void doFilter(
		ServletRequest req,
		ServletResponse resp,
		FilterChain chain)
		throws ServletException, IOException
	{
		logger.info("ENTRY: doFilter");
		
		HttpServletRequest httpServletRequest = (HttpServletRequest)req;
		HttpSession session = httpServletRequest.getSession();
		RequestDispatcher requestDispatcher = null;

		int l1 = httpServletRequest.getContextPath().length();
		String requestedURI = httpServletRequest.getRequestURI().substring(l1);

		// check for session
		if (session.isNew())
		{
			httpServletRequest.getSession().setAttribute("requestedURI", requestedURI);
			requestDispatcher = filterconfig.getServletContext().
								getRequestDispatcher("/user/login.jsp");
								
			requestDispatcher.forward(httpServletRequest, resp);
			
			logger.error("NOT LOGGED IN");			
			return;
		}
		
		// check for user in session
		UserSessionData userSessionData = (UserSessionData)session.getAttribute("userSessionData");
		if (userSessionData.getLogInUser() == null)
		{
			httpServletRequest.getSession().setAttribute("requestedURI", requestedURI);
			requestDispatcher = filterconfig.getServletContext().
								getRequestDispatcher("/user/login.jsp");
								
			requestDispatcher.forward(httpServletRequest, resp);			

			logger.error("NOT LOGGED IN");			
			return;
		}
		
		chain.doFilter(req, resp);
		
		logger.info("EXIT:  doFilter");
	}

	/**
	* Method init.
	* @param config
	* @throws javax.servlet.ServletException
	*/
	public void init(FilterConfig config) throws ServletException
	{
		logger.info("ENTRY: init");
		this.filterconfig = config;
		logger.info("EXIT:  init");
	}

}
