package com.ibm.itso.sal404.user.form;

import javax.servlet.http.HttpServletRequest;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionMapping;

// Import Log4J Logger
import org.apache.log4j.Logger;

/**
 * Form bean for a Struts application.
 * Users may access 2 fields on this form:
 * <ul>
 * <li>userName - [your comment here]
 * <li>pasword - [your comment here]
 * </ul>
 * @version 	1.0
 * @author
 */
public class LoginFormBean extends ActionForm
{
	// Configure Log4J Logger
	private static Logger logger = Logger.getLogger(LoginFormBean.class);
	
	private String userName = null;
	private String password = null;

	/**
	 * Get userName
	 * @return String
	 */
	public String getUserName()
	{
		return userName;
	}

	/**
	 * Set userName
	 * @param <code>String</code>
	 */
	public void setUserName(String u)
	{
		userName = u;
	}
	
	/**
	 * Get pasword
	 * @return String
	 */
	public String getPassword()
	{
		return password;
	}

	/**
	 * Set pasword
	 * @param <code>String</code>
	 */
	public void setPassword(String p)
	{
		password = p;
	}

	/**
	* Constructor
	*/
	public LoginFormBean()
	{
		super();
	}

	public void reset(ActionMapping mapping, HttpServletRequest request)
	{
		// Reset values are provided as samples only. Change as appropriate.
		userName = null;
		password = null;
	}

	public ActionErrors validate(
		ActionMapping mapping,
		HttpServletRequest request)
	{
		logger.info(Messages.getString("user.component.login.formENTRY__validate_1")); //$NON-NLS-1$
		ActionErrors errors = new ActionErrors();

		// Validate the fields in your form, adding
		// adding each error to this.errors as found, e.g.

		if ((getUserName() == null) || (getUserName().length() == 0)) {
			errors.add("errors", 
				new ActionError(Messages.getString("user.component.login.formuser.error.username.required_3"))); //$NON-NLS-1$
		}
		
		if ((getPassword() == null) || (getPassword().length() == 0)) {
		   errors.add("errors",
		   	new ActionError(Messages.getString("user.component.login.formuser.error.password.required_5"))); //$NON-NLS-1$
		}
		
		logger.info(Messages.getString("user.component.login.formEXIT___validate_6"));		 //$NON-NLS-1$
		return errors;
	}
}
