package com.ibm.itso.sal404.user.form;

import javax.servlet.http.HttpServletRequest;

import org.apache.log4j.Logger;
import org.apache.struts.action.ActionError;
import org.apache.struts.action.ActionErrors;
import org.apache.struts.action.ActionMapping;
import org.apache.struts.validator.ValidatorForm;

/**
 * 
 * sal404 Realty sample application
 * 
 * @component	name of component here
 * @layer		name of layer here
 * 
 * Description of the class here
 * 
 * @author 		Author full name here
 * @created		initial creation date here		
 * @version		x.y.z / @${date}	
 *
 * @see		 	classes associated with this class
 * 
 */
public class UserDetailsFormBean extends ValidatorForm
{
	// Configure Log4J Logger
	private static Logger logger = Logger.getLogger(UserDetailsFormBean.class);	

	private Integer id = null;
	private String userName = null;
	private String password = null;
	private String password_conf = null;
	private String role = null;
 
	private String title = null;
	private String firstName = null;
	private String lastName = null;
	private String emailAddr = null;
	private String websiteURL = null;
	private String phoneNumber = null;

	private Integer addrId = null;
	private String addrName = null;
	private String addrCntryCode = null;
	private String addrPostCode = null;
	private String addrRgn = null;
	private String addrMuni = null;
	private String addrStreetName = null;
	private String addrBldNum = null;
	private String addrUnitNum = null;
	private String addrPoBox = null;
	private String addrAddltext = null;

	/**
	* Constructor
	*/
	public UserDetailsFormBean()
	{
		super();
	}
	
	public void reset(ActionMapping mapping, HttpServletRequest request)

	{
		// Reset values are provided as samples only. Change as appropriate.
		id = null;
		userName = null;
		password = null;
		password_conf = null;
		role = null;
		title = null;
		firstName = null;
		lastName = null;
		emailAddr = null;
		websiteURL = null;
		phoneNumber = null;

		addrId = null;
		addrName = null;
		addrCntryCode = null;
		addrPostCode = null;
		addrRgn = null;
		addrMuni = null;
		addrStreetName = null;
		addrBldNum = null;
		addrUnitNum = null;
		addrPoBox = null;
		addrAddltext = null;
	}

	public ActionErrors validate(
		ActionMapping mapping,
		HttpServletRequest request)
	{
		logger.info("ENTRY: validate");

		// validate super first ....
		ActionErrors errors = super.validate(mapping, request);
		
		if (!getPassword().equals(getPassword_conf())) {
		   errors.add("register", 
		   		new ActionError("register.error.password.notmatch"));
		}

		logger.info("EXIT:  validate");
		return errors;
	}


	/**
	 * Returns the addrAddltext.
	 * @return String
	 */
	public String getAddrAddltext()
	{
		return addrAddltext;
	}

	/**
	 * Returns the addrName.
	 * @return String
	 */
	public String getAddrName()
	{
		return addrName;
	}

	/**
	 * Returns the addrBldNum.
	 * @return String
	 */
	public String getAddrBldNum()
	{
		return addrBldNum;
	}

	/**
	 * Returns the cntryCd.
	 * @return String
	 */
	public String getAddrCntryCode()
	{
		return addrCntryCode;
	}

	/**
	 * Returns the emailAddress.
	 * @return String
	 */
	public String getEmailAddr()
	{
		return emailAddr;
	}

	/**
	 * Returns the firstName.
	 * @return String
	 */
	public String getFirstName()
	{
		return firstName;
	}

	/**
	 * Returns the lastName.
	 * @return String
	 */
	public String getLastName()
	{
		return lastName;
	}

	/**
	 * Returns the addrMuni.
	 * @return String
	 */
	public String getAddrMuni()
	{
		return addrMuni;
	}

	/**
	 * Returns the password.
	 * @return String
	 */
	public String getPassword()
	{
		return password;
	}

	/**
	 * Returns the password_conf.
	 * @return String
	 */
	public String getPassword_conf()
	{
		return password_conf;
	}

	/**
	 * Returns the phoneNumber.
	 * @return String
	 */
	public String getPhoneNum()
	{
		return phoneNumber;
	}

	/**
	 * Returns the addrPoBox.
	 * @return String
	 */
	public String getAddrPoBox()
	{
		return addrPoBox;
	}

	/**
	 * Returns the addrPostCode.
	 * @return String
	 */
	public String getAddrPostCode()
	{
		return addrPostCode;
	}

	/**
	 * Returns the addrRgn.
	 * @return String
	 */
	public String getAddrRgn()
	{
		return addrRgn;
	}

	/**
	 * Returns the addrStreetName.
	 * @return String
	 */
	public String getAddrStreetName()
	{
		return addrStreetName;
	}

	/**
	 * Returns the title.
	 * @return String
	 */
	public String getTitle()
	{
		return title;
	}

	/**
	 * Returns the addrUnitNum.
	 * @return String
	 */
	public String getAddrUnitNum()
	{
		return addrUnitNum;
	}

	/**
	 * Returns the userName.
	 * @return String
	 */
	public String getUserName()
	{
		return userName;
	}

	/**
	 * Returns the websiteURL.
	 * @return String
	 */
	public String getWebURL()
	{
		return websiteURL;
	}

	/**
	 * Sets the addrAddltext.
	 * @param addrAddltext The addrAddltext to set
	 */
	public void setAddrAddltext(String addlText)
	{
	    this.addrAddltext = addlText;
	}

	/**
	 * Sets the addrName.
	 * @param addrName The addrName to set
	 */
	public void setAddrName(String addrName)
	{
		this.addrName = addrName;
	}

	/**
	 * Sets the addrBldNum.
	 * @param addrBldNum The addrBldNum to set
	 */
	public void setAddrBldNum(String bldgNum)
	{
	    this.addrBldNum = bldgNum;
	}

	/**
	 * Sets the cntryCd.
	 * @param cntryCd The cntryCd to set
	 */
	public void setAddrCntryCode(String cntryCd)
	{
	    this.addrCntryCode = cntryCd;
	}

	/**
	 * Sets the emailAddress.
	 * @param emailAddress The emailAddress to set
	 */
	public void setEmailAddr(String emailAddr)
	{
	    this.emailAddr = emailAddr;
	}

	/**
	 * Sets the firstName.
	 * @param firstName The firstName to set
	 */
	public void setFirstName(String firstName)
	{
	    this.firstName = firstName;
	}

	/**
	 * Sets the lastName.
	 * @param lastName The lastName to set
	 */
	public void setLastName(String lastName)
	{
	    this.lastName = lastName;
	}

	/**
	 * Sets the addrMuni.
	 * @param addrMuni The addrMuni to set
	 */
	public void setAddrMuni(String muni)
	{
	    this.addrMuni = muni;
	}

	/**
	 * Sets the password.
	 * @param password The password to set
	 */
	public void setPassword(String password)
	{
	    this.password = password;
	}

	/**
	 * Sets the password_conf.
	 * @param password_conf The password_conf to set
	 */
	public void setPassword_conf(String password_conf)
	{
	    this.password_conf = password_conf;
	}

	/**
	 * Sets the phoneNumber.
	 * @param phoneNumber The phoneNumber to set
	 */
	public void setPhoneNum(String phoneNumber)
	{
	    this.phoneNumber = phoneNumber;
	}

	/**
	 * Sets the addrPoBox.
	 * @param addrPoBox The addrPoBox to set
	 */
	public void setAddrPoBox(String poBox)
	{
	    this.addrPoBox = poBox;
	}

	/**
	 * Sets the addrPostCode.
	 * @param addrPostCode The addrPostCode to set
	 */
	public void setAddrPostCode(String postCd)
	{
	    this.addrPostCode = postCd;
	}

	/**
	 * Sets the addrRgn.
	 * @param addrRgn The addrRgn to set
	 */
	public void setAddrRgn(String rgn)
	{
	    this.addrRgn = rgn;
	}

	/**
	 * Sets the addrStreetName.
	 * @param addrStreetName The addrStreetName to set
	 */
	public void setAddrStreetName(String strtName)
	{
	    this.addrStreetName = strtName;
	}

	/**
	 * Sets the title.
	 * @param title The title to set
	 */
	public void setTitle(String title)
	{
	    this.title = title;
	}

	/**
	 * Sets the addrUnitNum.
	 * @param addrUnitNum The addrUnitNum to set
	 */
	public void setAddrUnitNum(String unitNum)
	{
	    this.addrUnitNum = unitNum;
	}

	/**
	 * Sets the userName.
	 * @param userName The userName to set
	 */
	public void setUserName(String userName)
	{
	    this.userName = userName;
	}

	/**
	 * Sets the websiteURL.
	 * @param websiteURL The websiteURL to set
	 */
	public void setWebsiteURL(String websiteURL)
	{
	    this.websiteURL = websiteURL;
	}

	/**
	 * Returns the id.
	 * @return Integer
	 */
	public Integer getId()
	{
		return id;
	}

	/**
	 * Sets the id.
	 * @param id The id to set
	 */
	public void setId(Integer id)
	{
		this.id = id;
	}

	 /**
     * @return Returns the role.
     */
    public String getRole() {
        return role;
    }
    /**
     * @param role The role to set.
     */
    public void setRole(String role) {
        this.role = role;
    }
    /**
     * @return Returns the addrId.
     */
    public Integer getAddrId() {
        return addrId;
    }
    /**
     * @param addrId The addrId to set.
     */
    public void setAddrId(Integer addrId) {
        this.addrId = addrId;
    }
}
