package com.ibm.itso.sab404r.employee.manager;

public class EmployeeManagerProxy implements com.ibm.itso.sab404r.employee.manager.EmployeeManager {
  private boolean _useJNDI = true;
  private String _endpoint = null;
  private com.ibm.itso.sab404r.employee.manager.EmployeeManager employeeManager = null;
  
  public EmployeeManagerProxy() {
    _initEmployeeManagerProxy();
  }
  
  private void _initEmployeeManagerProxy() {
  
  if (_useJNDI) {
    try{
      javax.naming.InitialContext ctx = new javax.naming.InitialContext();
      employeeManager = ((com.ibm.itso.sab404r.employee.manager.EmployeeManagerService)ctx.lookup("java:comp/env/service/EmployeeManagerService")).getEmployeeManager();
      }
    catch (javax.naming.NamingException namingException) {}
    catch (javax.xml.rpc.ServiceException serviceException) {}
  }
  if (employeeManager == null) {
    try{
      employeeManager = (new com.ibm.itso.sab404r.employee.manager.EmployeeManagerServiceLocator()).getEmployeeManager();
      }
    catch (javax.xml.rpc.ServiceException serviceException) {}
  }
  if (employeeManager != null) {
    if (_endpoint != null)
      ((javax.xml.rpc.Stub)employeeManager)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
    else
      _endpoint = (String)((javax.xml.rpc.Stub)employeeManager)._getProperty("javax.xml.rpc.service.endpoint.address");
  }
  
}


public void useJNDI(boolean useJNDI) {
  _useJNDI = useJNDI;
  employeeManager = null;
  
}

public String getEndpoint() {
  return _endpoint;
}

public void setEndpoint(String endpoint) {
  _endpoint = endpoint;
  if (employeeManager != null)
    ((javax.xml.rpc.Stub)employeeManager)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
  
}

public com.ibm.itso.sab404r.employee.manager.EmployeeManager getEmployeeManager() {
  if (employeeManager == null)
    _initEmployeeManagerProxy();
  return employeeManager;
}

public void addAnEmployee(com.ibm.itso.sab404r.employee.dto.EmployeeDTO anEmployee) throws java.rmi.RemoteException, com.ibm.itso.sab404r.utils.Sab404RException{
  if (employeeManager == null)
    _initEmployeeManagerProxy();
  employeeManager.addAnEmployee(anEmployee);
}


}