package com.ibm.itso.sab404r.listings.manager;

public class ListingManagerProxy implements com.ibm.itso.sab404r.listings.manager.ListingManager {
  private boolean _useJNDI = true;
  private String _endpoint = null;
  private com.ibm.itso.sab404r.listings.manager.ListingManager listingManager = null;
  
  public ListingManagerProxy() {
    _initListingManagerProxy();
  }
  
  private void _initListingManagerProxy() {
  
  if (_useJNDI) {
    try{
      javax.naming.InitialContext ctx = new javax.naming.InitialContext();
      listingManager = ((com.ibm.itso.sab404r.listings.manager.ListingManagerService)ctx.lookup("java:comp/env/service/ListingManagerService")).getListingManager();
      }
    catch (javax.naming.NamingException namingException) {}
    catch (javax.xml.rpc.ServiceException serviceException) {}
  }
  if (listingManager == null) {
    try{
      listingManager = (new com.ibm.itso.sab404r.listings.manager.ListingManagerServiceLocator()).getListingManager();
      }
    catch (javax.xml.rpc.ServiceException serviceException) {}
  }
  if (listingManager != null) {
    if (_endpoint != null)
      ((javax.xml.rpc.Stub)listingManager)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
    else
      _endpoint = (String)((javax.xml.rpc.Stub)listingManager)._getProperty("javax.xml.rpc.service.endpoint.address");
  }
  
}


public void useJNDI(boolean useJNDI) {
  _useJNDI = useJNDI;
  listingManager = null;
  
}

public String getEndpoint() {
  return _endpoint;
}

public void setEndpoint(String endpoint) {
  _endpoint = endpoint;
  if (listingManager != null)
    ((javax.xml.rpc.Stub)listingManager)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
  
}

public com.ibm.itso.sab404r.listings.manager.ListingManager getListingManager() {
  if (listingManager == null)
    _initListingManagerProxy();
  return listingManager;
}

public java.lang.String addListing(com.ibm.itso.sab404r.listings.dto.ListingDTO aListing) throws java.rmi.RemoteException{
  if (listingManager == null)
    _initListingManagerProxy();
  return listingManager.addListing(aListing);
}

public java.lang.String changeListing(com.ibm.itso.sab404r.listings.dto.ListingDTO aListing) throws java.rmi.RemoteException{
  if (listingManager == null)
    _initListingManagerProxy();
  return listingManager.changeListing(aListing);
}


}