package com.ibm.itso.sal404.news;

public class NewsManagerProxy implements com.ibm.itso.sal404.news.NewsManager {
  private boolean _useJNDI = true;
  private String _endpoint = null;
  private com.ibm.itso.sal404.news.NewsManager newsManager = null;
  
  public NewsManagerProxy() {
    _initNewsManagerProxy();
  }
  
  private void _initNewsManagerProxy() {
  
  if (_useJNDI) {
    try{
      javax.naming.InitialContext ctx = new javax.naming.InitialContext();
      newsManager = ((com.ibm.itso.sal404.news.NewsManagerService)ctx.lookup("java:comp/env/service/NewsManagerService")).getNewsManager();
      }
    catch (javax.naming.NamingException namingException) {}
    catch (javax.xml.rpc.ServiceException serviceException) {}
  }
  if (newsManager == null) {
    try{
      newsManager = (new com.ibm.itso.sal404.news.NewsManagerServiceLocator()).getNewsManager();
      }
    catch (javax.xml.rpc.ServiceException serviceException) {}
  }
  if (newsManager != null) {
    if (_endpoint != null)
      ((javax.xml.rpc.Stub)newsManager)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
    else
      _endpoint = (String)((javax.xml.rpc.Stub)newsManager)._getProperty("javax.xml.rpc.service.endpoint.address");
  }
  
}


public void useJNDI(boolean useJNDI) {
  _useJNDI = useJNDI;
  newsManager = null;
  
}

public String getEndpoint() {
  return _endpoint;
}

public void setEndpoint(String endpoint) {
  _endpoint = endpoint;
  if (newsManager != null)
    ((javax.xml.rpc.Stub)newsManager)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
  
}

public com.ibm.itso.sal404.news.NewsManager getNewsManager() {
  if (newsManager == null)
    _initNewsManagerProxy();
  return newsManager;
}

public java.util.Vector viewWSNewsItem() throws java.rmi.RemoteException, com.ibm.itso.sal404.common.exception.ApplicationException{
  if (newsManager == null)
    _initNewsManagerProxy();
  return newsManager.viewWSNewsItem();
}

public void addWSNewsItem(com.ibm.itso.sal404.news.dto.WSNewsItemDTO tempWSNewsItemDTO) throws java.rmi.RemoteException, com.ibm.itso.sal404.common.exception.ApplicationException{
  if (newsManager == null)
    _initNewsManagerProxy();
  newsManager.addWSNewsItem(tempWSNewsItemDTO);
}

public com.ibm.itso.sal404.news.dto.WSNewsItemDTO viewWSNewsItemDetails(java.lang.String newsId) throws java.rmi.RemoteException, com.ibm.itso.sal404.common.exception.ApplicationException{
  if (newsManager == null)
    _initNewsManagerProxy();
  return newsManager.viewWSNewsItemDetails(newsId);
}


}