package com.ibm.itso.sal404.propertycatalog;

public class PropertyCatalogServicesProxy implements com.ibm.itso.sal404.propertycatalog.PropertyCatalogServices {
  private boolean _useJNDI = true;
  private String _endpoint = null;
  private com.ibm.itso.sal404.propertycatalog.PropertyCatalogServices propertyCatalogServices = null;
  
  public PropertyCatalogServicesProxy() {
    _initPropertyCatalogServicesProxy();
  }
  
  private void _initPropertyCatalogServicesProxy() {
  
  if (_useJNDI) {
    try{
      javax.naming.InitialContext ctx = new javax.naming.InitialContext();
      propertyCatalogServices = ((com.ibm.itso.sal404.propertycatalog.PropertyCatalogServicesService)ctx.lookup("java:comp/env/service/PropertyCatalogServicesService")).getPropertyCatalogServices();
      }
    catch (javax.naming.NamingException namingException) {}
    catch (javax.xml.rpc.ServiceException serviceException) {}
  }
  if (propertyCatalogServices == null) {
    try{
      propertyCatalogServices = (new com.ibm.itso.sal404.propertycatalog.PropertyCatalogServicesServiceLocator()).getPropertyCatalogServices();
      }
    catch (javax.xml.rpc.ServiceException serviceException) {}
  }
  if (propertyCatalogServices != null) {
    if (_endpoint != null)
      ((javax.xml.rpc.Stub)propertyCatalogServices)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
    else
      _endpoint = (String)((javax.xml.rpc.Stub)propertyCatalogServices)._getProperty("javax.xml.rpc.service.endpoint.address");
  }
  
}


public void useJNDI(boolean useJNDI) {
  _useJNDI = useJNDI;
  propertyCatalogServices = null;
  
}

public String getEndpoint() {
  return _endpoint;
}

public void setEndpoint(String endpoint) {
  _endpoint = endpoint;
  if (propertyCatalogServices != null)
    ((javax.xml.rpc.Stub)propertyCatalogServices)._setProperty("javax.xml.rpc.service.endpoint.address", _endpoint);
  
}

public com.ibm.itso.sal404.propertycatalog.PropertyCatalogServices getPropertyCatalogServices() {
  if (propertyCatalogServices == null)
    _initPropertyCatalogServicesProxy();
  return propertyCatalogServices;
}

public com.ibm.itso.sal404.propertycatalog.dto.ResultPropertiesDTO[] searchByCriteria(com.ibm.itso.sal404.propertycatalog.dto.SearchPropertiesByCriteriaDTO searchByCriteriaDTO) throws java.rmi.RemoteException, com.ibm.itso.sal404.common.exception.ApplicationException{
  if (propertyCatalogServices == null)
    _initPropertyCatalogServicesProxy();
  return propertyCatalogServices.searchByCriteria(searchByCriteriaDTO);
}


}